

/***********************************************************************************************
 *                                                                                             *
 * Ex4-TFT43_Bitmap : GLCD_Touch Screen 480x272 (ET-TFT43-EVE) For "ET-BASE PIC8722 (ICD2)"    *
 *                                                                                             *
 *                     Interface GLCD Data SPI Software                                        *
 *                                                                                             *
 ***********************************************************************************************
 *                                                                                             *
 *                                                                                             *
 * Target MCU        : PIC18F8722                                                              *
 *                   : X-TAL : 10 MHz                                                          *
 *                   : CPU Clock = 40 MHz (x4)                                                 *                                                                  *
 * Editor-Compiler   : CCS Version 4.124                                                       *
 * Create By         : Mr. Sittiphol Yooyod (WWW.ETT.CO.TH)                                    *
 * Last Update       : 9/March/2014                                                            *
 *                                                                                             *
 * Port Interface :  ---- MCU-PIC18F8722 ----                ---- ET-TFT43-EVE ----            *
 *                                                                                             *
 *      SPI       :                                                                            *
 *                     RJ0 (MISO-In)       Connect          MISO              [Pin0]           *
 *                     RJ1 (MOSI-Out)      Connect          MOSI              [Pin1]           *
 *                     RJ2 (SCK-Out)       Connect          SCK  (Ideal=Low)  [Pin2]           *
 *                     RJ3 (CS-Out)        Connect          CS#  (Active Low) [Pin3]           *
 *                     RJ4 (OUT))          Connect          PD#  (Active=Low) [Pin4]           *
 *                     RJ5 (IN)            Connect          INT# (Active=Low) [Pin5]           *
 *                     RJ6 (OUT)           Connect          SD_CS(Active=Low) [Pin6]           *
 *                                                                                             *
 *                                                                                             *
 *                                                                                             *
 ***********************************************************************************************/



#include <18F8722.h>
#include <stdio.h>

//#define TX1   PIN_C6
//#define RX1   PIN_C7

#fuses H4,NOLVP,NOWDT,NOPROTECT,NOSTVREN           //Setup MCU
#use delay (clock = 40000000)                      //delay Clock = (ms)

//#use rs232(baud = 9600, xmit = TX1, rcv = RX1)   //Set Rs232

#use fast_io(ALL)                                  //Stop Set direction Auto for All Port  by Compiler  


 rom int8 jpeg_audio[22050] = {
/*('file properties ', 'resolution ', 105, 'x', 105, 'format ', 'ARGB1555', ' total size ', 22050)*/ 
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,251,
188,243,123,239,90,239,156,243,90,235,89,235,90,235,90,235,90,235,90,239,157,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,188,243,
90,239,90,231,23,227,214,218,82,202,49,194,239,189,174,185,173,181,172,181,173,185,206,185,173,181,140,177,140,181,173,181,139,177,140,177,140,177,82,202,213,218,47,194,181,214,56,231,155,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,221,247,122,235,57,231,214,218,115,206,16,194,49,202,115,210,116,206,114,206,82,202,82,202,16,194,206,185,172,177,107,173,73,169,9,161,41,165,41,165,8,161,8,161,8,165,41,161,73,165,40,165,238,189,197,152,73,169,205,181,
14,190,206,185,47,198,245,222,88,235,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,251,155,243,55,227,147,210,238,189,205,181,238,185,238,193,15,194,239,193,205,181,140,177,107,173,41,161,230,152,198,152,164,144,99,140,98,140,66,136,33,132,33,132,66,140,99,140,131,140,
100,144,99,140,66,136,98,140,98,140,204,185,66,136,98,140,66,136,164,144,7,161,139,177,238,189,172,177,238,189,214,218,155,243,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,188,247,23,223,113,202,204,181,139,177,172,177,73,173,231,160,198,156,198,152,231,156,41,165,74,169,107,173,74,169,41,165,41,165,7,161,
197,152,132,144,132,140,98,140,66,136,66,136,98,140,131,144,132,144,131,140,132,140,131,144,131,144,66,136,205,181,99,136,99,140,67,140,65,132,66,136,98,136,66,140,131,144,8,165,107,173,140,177,239,189,248,226,254,251,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,88,239,179,214,204,185,140,177,138,173,41,165,132,144,33,132,66,140,132,144,165,152,
198,152,8,161,75,169,108,177,140,177,140,177,107,173,74,169,8,161,231,156,197,152,165,148,132,144,99,140,131,140,132,144,132,148,164,144,164,148,131,144,164,144,165,148,132,144,206,189,99,136,131,140,98,140,98,136,98,136,66,136,67,140,99,136,
99,140,66,140,132,148,230,156,41,165,173,181,181,214,190,247,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,23,223,81,202,171,181,172,185,
172,185,197,152,66,136,33,132,65,136,99,140,132,140,100,144,166,152,8,161,42,169,141,177,174,181,174,185,174,185,141,177,107,173,74,165,8,161,231,156,230,152,197,148,133,144,165,148,198,152,196,148,165,148,165,148,166,152,230,156,231,156,165,148,
206,185,131,144,164,144,99,140,98,136,99,140,66,136,98,136,66,136,66,140,65,136,65,136,98,140,99,140,165,148,41,165,205,181,24,223,254,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,57,231,115,210,205,185,238,193,239,193,197,152,33,136,0,132,65,136,99,140,67,140,99,140,133,144,166,152,231,160,41,165,107,173,206,185,239,189,16,194,240,193,206,185,173,181,108,173,75,169,9,161,231,156,230,156,197,152,
230,152,7,157,7,157,231,156,231,156,199,156,7,161,8,165,230,156,238,185,197,152,197,152,132,144,99,144,99,140,66,140,66,136,66,136,99,136,98,140,66,136,66,132,66,136,99,140,132,144,132,144,42,161,206,181,156,243,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,188,243,148,210,16,194,139,173,80,198,105,173,99,140,33,136,33,132,97,140,131,144,132,144,99,144,132,144,198,152,231,156,8,161,107,173,206,185,16,194,81,198,82,202,
82,202,16,194,240,189,175,185,174,181,108,173,75,169,41,165,41,165,41,169,106,173,41,165,74,169,73,169,8,161,7,161,40,165,40,161,15,194,7,157,7,161,165,148,132,144,165,144,132,144,132,140,99,140,100,144,100,144,132,144,132,144,133,144,
132,144,132,140,98,140,100,140,49,194,246,218,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,148,210,204,185,73,165,48,198,198,152,66,136,99,140,33,136,99,140,99,140,131,140,165,148,166,148,
166,152,231,160,41,161,108,173,173,181,239,189,82,202,116,206,149,210,148,210,82,206,82,198,16,194,15,190,206,185,140,177,107,177,139,177,139,177,171,181,107,173,107,177,74,173,41,169,41,165,106,177,74,169,15,198,7,161,40,161,230,152,165,148,
165,148,133,148,164,148,131,144,131,144,132,144,132,144,133,148,165,148,165,148,164,144,132,144,41,169,247,218,239,181,214,214,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,114,202,164,148,139,177,106,173,97,140,
66,136,99,140,132,144,99,144,132,144,164,148,197,148,198,152,232,160,8,165,107,169,139,173,173,181,239,193,82,202,180,214,214,218,215,218,214,218,213,214,180,214,147,210,114,206,80,202,48,198,47,198,48,198,47,202,47,198,172,181,204,185,107,177,
74,169,74,173,172,181,139,177,16,198,7,161,40,165,7,161,198,152,198,152,165,152,197,148,132,148,164,148,165,148,164,148,166,148,197,148,197,148,198,148,230,156,15,194,180,210,239,185,240,185,157,239,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,24,227,230,156,198,156,48,198,99,140,130,140,165,148,166,148,165,148,164,148,197,148,231,156,231,156,73,165,73,169,74,169,140,177,174,181,16,194,50,202,149,214,23,227,57,235,89,231,57,231,89,231,57,231,24,231,56,231,
245,222,180,214,147,210,113,206,48,202,15,198,16,194,48,198,237,189,139,181,138,177,238,185,172,185,16,194,7,161,73,169,8,165,7,161,230,160,198,156,198,156,165,152,230,156,230,152,198,156,198,152,164,148,165,148,198,152,231,156,211,214,112,198,
205,177,74,161,215,210,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,48,198,98,136,81,202,197,156,132,148,132,148,198,156,165,152,199,156,231,156,8,161,7,161,40,165,107,173,108,173,140,177,15,190,81,198,148,210,213,214,
57,231,123,239,122,239,24,231,214,222,213,218,181,214,116,210,116,210,83,206,49,198,16,194,239,189,141,181,107,173,140,181,237,185,171,181,73,173,40,165,41,169,7,161,41,169,8,165,106,173,105,173,41,169,8,165,7,161,231,160,231,160,7,165,
7,161,230,156,198,156,198,156,230,156,7,161,40,165,243,218,237,189,181,206,115,198,116,194,215,214,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,89,235,41,169,140,177,173,185,98,140,197,148,198,152,199,156,231,156,199,156,40,169,139,177,
105,173,106,173,172,181,238,189,48,198,147,210,181,218,181,218,213,218,214,214,246,218,247,222,214,222,214,218,181,214,181,214,181,214,181,214,247,222,57,231,91,235,156,243,189,247,221,251,255,255,223,255,255,255,222,255,223,255,189,247,24,227,147,210,
237,185,172,177,106,173,106,173,106,173,73,173,40,165,8,165,39,169,71,169,40,169,7,161,231,160,230,156,106,173,172,185,145,206,171,177,57,231,82,190,115,194,115,190,124,231,255,255,255,255,222,251,223,251,223,247,190,247,255,255,255,255,255,255,
255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,214,218,165,148,149,214,
132,144,197,148,40,165,230,156,231,160,7,161,9,165,41,169,205,189,172,185,173,181,238,193,81,206,147,210,147,214,180,214,181,218,181,214,213,218,214,222,24,223,24,227,90,235,124,239,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,155,243,24,227,213,214,114,202,15,194,204,185,139,177,137,173,105,173,73,169,72,169,8,165,8,165,106,177,238,193,238,193,72,169,24,223,116,202,149,198,182,202,83,190,
241,185,19,178,152,194,251,202,218,198,53,178,85,182,92,223,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,82,202,40,165,81,202,99,144,71,165,171,181,7,165,41,165,41,165,74,169,106,173,15,194,238,189,239,193,49,202,115,210,147,210,115,210,213,218,25,227,90,235,123,239,156,243,222,251,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,188,247,90,235,246,222,116,210,48,198,205,185,139,181,138,177,107,173,140,177,
172,181,106,173,165,152,99,136,8,157,239,185,148,202,58,223,125,227,26,215,29,211,28,211,61,211,94,211,62,207,60,211,27,215,255,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,173,181,206,185,238,185,165,148,203,185,237,189,40,165,72,165,8,165,40,165,106,173,147,210,116,206,115,206,114,206,149,214,57,231,
157,247,221,247,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,251,189,251,155,239,247,226,180,218,48,198,205,185,238,185,113,206,74,173,164,148,66,136,66,136,165,144,131,140,33,128,134,140,116,194,125,227,28,211,60,207,60,207,251,198,185,194,119,182,52,182,184,202,25,223,191,243,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,139,177,16,194,172,181,165,148,46,198,112,206,105,173,72,165,
73,169,7,161,74,173,114,206,50,202,248,226,157,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,247,124,243,24,227,147,210,48,194,147,210,230,152,131,144,67,140,100,140,198,148,198,148,133,140,34,128,134,132,51,182,150,190,151,190,152,182,120,186,
85,178,53,174,20,174,20,174,52,178,209,173,250,210,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,140,177,173,181,238,189,131,144,145,210,146,214,171,181,106,173,73,165,74,165,239,189,24,227,157,243,254,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,251,222,251,155,239,246,222,238,185,230,156,197,148,100,140,67,136,132,140,
231,152,199,152,67,132,133,132,10,145,248,206,183,194,86,186,21,178,242,173,242,169,177,161,178,161,211,157,210,161,144,157,51,182,223,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,173,181,230,152,147,206,98,140,47,202,212,222,205,185,106,173,206,189,24,227,123,239,223,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,222,251,190,247,107,173,40,161,231,156,164,144,66,136,33,132,199,152,231,148,165,140,68,128,101,132,44,153,19,174,242,169,176,157,143,153,144,157,175,153,144,153,144,153,144,153,177,157,143,157,118,198,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,49,198,65,136,16,198,7,161,7,165,247,226,15,194,247,222,190,251,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,157,243,107,169,74,169,7,157,230,152,99,140,66,136,100,140,231,152,232,148,132,136,66,132,202,140,175,165,207,157,176,157,177,153,112,153,144,153,175,157,144,157,
145,161,145,153,144,153,175,165,222,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,181,210,230,152,197,144,206,185,
229,148,146,202,181,210,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,239,74,169,107,177,74,169,231,156,164,148,66,132,99,136,198,144,41,157,199,140,100,132,
199,136,76,153,208,161,176,157,176,157,177,161,177,161,177,165,177,161,177,165,210,165,211,169,19,166,92,223,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,23,223,147,206,240,185,166,148,41,161,231,152,49,194,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,24,231,107,173,206,181,
108,173,41,161,164,144,99,136,98,136,99,136,232,152,9,153,133,132,167,128,175,161,176,161,18,170,242,161,18,166,19,166,19,170,53,170,21,174,20,170,21,174,21,170,61,215,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,231,24,219,24,215,83,194,43,161,199,144,166,140,42,161,190,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,247,222,42,165,139,177,239,189,74,169,230,152,165,144,67,140,66,132,199,148,75,161,199,140,200,132,142,157,144,157,53,178,52,174,86,178,53,174,86,174,53,178,53,178,86,178,86,182,86,182,27,215,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,122,231,58,219,124,227,248,210,150,194,208,169,168,136,68,128,148,202,
156,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,243,124,239,123,231,90,235,25,223,148,202,116,202,214,218,156,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,247,222,40,165,198,152,173,181,17,198,7,161,164,144,66,136,66,132,165,140,107,165,41,157,233,140,200,136,176,161,118,186,119,182,
151,182,87,182,86,178,120,182,119,182,120,182,119,182,153,186,60,211,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
124,231,248,206,158,223,26,211,184,194,143,157,176,165,51,178,116,190,84,190,216,210,255,247,255,255,255,255,255,255,255,255,255,251,157,235,90,223,116,198,174,173,18,186,116,202,216,214,215,210,49,190,174,177,74,165,9,161,75,173,214,214,255,255,
223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,247,222,40,165,133,148,164,144,173,181,140,177,164,144,132,140,
33,128,67,132,74,161,76,165,109,157,200,136,19,174,86,182,152,186,152,186,184,190,151,186,152,186,120,186,152,190,152,190,218,190,27,211,255,251,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,239,59,215,158,219,27,207,251,198,44,141,250,198,185,198,85,182,86,186,85,186,118,190,124,231,255,255,223,243,157,231,26,215,59,223,249,210,84,186,209,177,150,198,58,219,
248,214,116,198,240,181,74,161,8,153,199,148,232,152,231,152,40,157,148,210,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,247,226,41,165,132,148,66,140,33,132,140,177,231,156,133,148,34,132,65,132,232,152,174,177,175,173,233,140,144,165,85,182,28,207,28,207,60,211,61,207,61,215,93,215,158,223,127,223,159,223,191,235,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,191,239,218,202,126,215,28,207,185,194,12,137,250,198,60,203,28,203,119,186,53,178,119,186,183,194,118,190,
20,178,241,169,150,194,183,198,151,194,118,194,183,202,248,206,26,215,216,210,215,206,50,190,8,153,199,144,165,140,231,148,199,148,231,152,231,152,9,161,23,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,57,235,73,169,164,144,99,144,1,128,99,140,73,169,132,148,66,136,66,132,166,144,239,181,18,186,43,153,234,144,119,190,127,223,159,223,94,215,94,215,61,215,60,211,
61,207,28,207,93,207,159,227,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,243,27,207,127,215,252,202,218,202,
236,140,251,202,251,202,251,198,27,203,94,215,127,223,127,215,62,211,60,211,151,186,19,174,117,186,182,194,151,194,118,194,208,169,241,177,215,202,183,206,116,194,50,186,173,169,199,144,132,132,133,136,198,144,231,152,198,148,198,152,82,198,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,157,243,41,165,164,144,34,132,1,132,33,132,73,165,8,165,98,140,33,132,100,136,173,173,84,190,
110,165,134,132,118,190,60,215,191,227,126,219,159,223,158,223,158,227,191,231,191,231,191,231,255,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,243,27,203,127,215,252,202,249,194,12,137,218,194,251,198,185,190,159,219,159,223,159,219,27,203,250,194,27,203,29,207,186,198,152,190,86,182,210,165,143,153,242,165,85,186,184,194,183,198,84,186,19,182,18,182,
241,181,76,161,100,132,132,136,165,144,233,156,9,161,9,161,173,177,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,222,255,41,165,132,144,34,132,
0,132,0,128,133,148,74,169,133,144,34,132,100,136,109,173,146,198,207,169,100,132,117,182,126,227,255,255,255,251,223,255,222,247,223,243,255,243,255,243,223,243,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,247,27,207,127,211,252,206,185,194,46,145,185,194,217,194,159,223,191,227,217,198,110,157,210,165,121,194,153,190,87,182,53,174,176,161,142,153,
142,157,176,153,210,169,85,178,151,190,151,190,85,186,18,182,19,182,50,182,50,182,16,182,133,136,100,136,198,148,9,157,42,165,74,165,106,169,124,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,173,177,99,144,66,132,0,128,0,128,132,144,106,173,165,144,33,132,67,136,74,165,148,202,18,182,100,136,19,178,59,215,255,251,255,251,255,251,255,255,255,247,255,247,255,247,223,243,255,251,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,59,215,61,207,28,207,217,198,77,145,85,182,61,215,191,227,19,178,
177,161,218,198,93,211,250,194,151,186,86,174,243,161,177,161,144,161,144,165,209,161,242,165,85,178,118,186,118,182,52,182,52,178,51,178,52,186,117,190,117,190,116,194,232,148,99,136,231,148,42,161,107,169,75,169,74,169,189,243,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,16,198,132,144,33,136,32,132,0,128,99,140,107,169,231,152,66,132,67,132,232,156,149,206,84,194,166,140,144,165,250,206,255,247,
255,247,255,251,255,251,255,247,255,247,223,243,191,243,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
92,223,60,211,250,198,217,198,111,157,53,182,191,231,250,198,218,198,62,207,28,203,218,198,118,186,53,178,243,169,210,161,210,161,112,149,144,153,177,161,211,165,53,174,119,182,86,182,85,178,53,178,85,178,85,186,150,194,118,194,182,198,183,206,
9,157,100,136,199,152,107,165,173,173,107,165,75,169,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,214,218,133,144,66,136,33,132,0,132,65,136,106,173,231,156,
34,136,67,132,165,148,149,206,150,198,199,144,76,153,150,190,191,235,191,235,191,235,191,231,191,231,191,227,158,227,159,227,255,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,239,117,194,250,206,218,198,112,153,53,174,251,206,27,203,86,182,184,190,185,194,86,182,21,174,20,166,244,169,211,161,176,153,176,153,209,157,178,161,243,165,53,178,119,186,
119,182,119,178,86,182,118,182,119,190,152,190,184,198,184,198,249,210,216,210,9,153,133,136,42,157,173,173,206,181,9,161,206,181,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,90,235,165,148,66,136,33,128,0,132,1,132,41,165,199,156,66,140,66,136,132,140,148,202,182,202,231,144,9,145,19,178,93,219,93,211,61,211,93,207,61,207,61,211,93,207,61,211,223,239,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,149,202,150,198,219,198,176,157,243,165,151,186,45,145,201,136,200,136,75,157,52,178,250,202,218,194,
19,170,209,161,210,161,177,161,178,169,242,165,20,170,86,182,152,186,152,186,151,186,152,186,184,186,152,190,184,190,250,202,250,206,249,206,26,215,25,215,9,153,166,144,74,161,207,181,173,177,8,157,24,227,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,161,66,140,33,132,0,128,32,132,41,161,198,152,66,140,34,132,100,140,115,198,181,202,9,149,199,140,241,173,61,207,62,203,29,207,61,203,28,203,28,203,
28,203,28,203,191,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,251,82,198,19,186,176,169,
241,173,150,186,27,203,84,186,207,169,9,153,101,132,35,128,233,140,51,186,249,206,119,186,210,161,244,165,20,170,53,174,118,182,152,190,185,194,184,190,184,190,185,190,218,198,218,194,251,198,251,206,27,211,27,211,26,219,249,214,166,140,8,149,
173,173,17,190,140,173,8,157,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,16,194,67,140,33,132,1,132,66,136,8,165,166,148,98,140,34,132,67,136,82,194,181,206,
74,157,165,140,142,165,28,207,61,207,60,203,28,207,251,202,28,203,27,203,251,198,191,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,90,235,147,210,107,165,240,173,26,207,27,207,118,190,50,178,240,173,207,169,108,161,167,144,35,128,68,128,110,161,183,194,151,186,52,178,86,178,118,186,152,190,185,194,217,190,185,194,218,198,251,198,
252,202,60,207,61,211,60,211,92,219,91,219,125,227,150,206,133,132,41,157,207,181,175,181,42,165,115,206,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,57,231,99,140,33,132,
33,132,99,140,8,165,166,144,99,140,65,132,66,132,50,194,182,206,75,161,101,136,44,161,217,198,250,198,249,198,251,202,217,198,218,202,218,194,185,194,222,243,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,122,235,148,206,206,177,248,214,59,227,150,202,51,190,208,181,174,169,141,165,75,157,167,144,200,144,35,128,35,128,43,161,
184,190,250,202,152,190,218,194,218,194,217,194,250,198,28,203,27,207,27,203,61,207,94,211,94,215,126,219,158,223,191,231,123,227,173,173,166,140,109,169,17,194,76,169,9,161,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,222,251,124,239,8,165,34,136,0,128,99,140,230,156,131,140,132,140,32,132,66,136,239,185,147,202,41,157,133,140,76,161,216,202,184,194,185,194,216,190,183,190,217,194,185,186,184,194,255,251,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,239,214,214,149,206,59,223,183,206,51,190,
17,186,207,177,109,165,74,157,101,132,133,136,232,148,200,144,34,128,1,128,109,153,218,198,250,202,27,199,251,198,218,198,28,203,28,207,62,211,94,211,126,215,159,215,158,219,158,223,191,231,222,239,189,239,134,140,9,157,240,189,239,185,8,157,
24,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,156,243,25,231,239,189,65,132,0,132,100,140,197,148,132,144,66,136,0,128,65,136,16,190,83,202,41,165,100,132,140,169,117,190,183,194,
183,190,185,190,151,190,152,186,153,186,184,194,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,189,243,116,202,91,231,215,214,83,198,17,190,174,177,108,169,10,153,68,136,100,132,99,132,133,136,232,148,200,140,33,128,133,132,242,169,29,211,251,202,27,199,60,207,61,207,95,207,95,211,127,219,159,223,159,231,
223,239,255,243,255,251,223,247,49,190,199,144,108,169,17,186,74,169,172,173,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,24,227,148,206,131,140,66,132,132,144,165,144,66,136,33,136,
0,128,98,136,206,177,115,198,8,157,132,140,206,177,115,194,116,190,116,186,119,186,119,190,119,186,119,182,184,198,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,24,227,89,231,248,222,148,206,49,194,207,185,173,173,75,165,101,136,99,136,99,132,67,128,35,128,134,132,10,153,99,136,33,128,10,145,
250,198,61,215,62,211,94,203,127,211,93,211,158,227,255,243,255,243,255,247,255,251,223,247,255,251,158,239,166,140,75,161,17,186,206,177,231,152,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,156,243,214,218,74,169,33,132,66,136,99,136,0,128,0,128,0,128,133,144,174,177,49,194,231,152,133,144,239,181,114,194,115,190,115,190,85,190,118,190,118,194,118,190,59,219,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,251,247,226,56,231,180,210,82,198,239,185,141,177,74,165,99,132,
100,136,99,136,34,132,35,128,100,128,67,132,167,144,200,148,33,132,100,132,150,186,126,219,93,215,159,227,223,239,223,243,223,243,255,247,255,247,254,247,255,247,223,247,223,243,206,173,232,148,240,181,206,181,231,152,247,222,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,243,214,214,99,140,65,136,33,128,32,132,32,128,0,128,197,152,140,177,17,194,166,148,197,144,114,202,147,202,214,210,24,219,58,223,91,227,157,231,190,235,
190,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,89,235,56,231,213,214,81,198,207,185,141,177,107,169,164,144,99,140,66,132,66,132,66,132,65,128,67,128,67,128,67,128,9,145,165,136,67,128,52,178,191,235,223,243,223,243,255,247,255,247,255,247,255,251,223,247,255,247,223,239,92,223,
183,202,199,140,174,173,239,185,9,161,49,198,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,247,49,194,0,128,32,128,1,128,0,128,66,136,232,156,108,173,239,189,230,152,
165,148,114,202,58,231,155,235,123,235,88,227,56,223,57,223,56,219,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,251,56,231,247,222,115,202,238,189,173,181,139,173,166,148,100,140,67,136,67,136,66,132,34,128,66,132,66,128,100,132,100,128,200,136,11,149,33,128,51,186,255,243,
255,243,191,235,255,247,223,239,255,247,191,239,126,219,94,223,223,231,92,219,232,140,141,169,240,185,42,165,108,173,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,222,247,
207,185,33,132,0,128,0,128,99,140,8,161,107,173,141,177,41,161,106,173,15,190,140,173,207,185,141,177,173,181,49,198,214,214,156,243,221,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,239,24,227,180,214,48,198,173,181,140,173,165,148,99,136,66,136,98,136,66,132,34,132,
66,128,34,128,67,132,67,132,68,132,167,136,109,153,35,128,150,202,223,247,223,247,255,247,191,239,126,223,126,215,191,227,126,223,251,206,217,206,201,144,75,161,206,181,75,165,42,165,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,82,202,66,140,66,136,164,144,7,157,42,165,75,173,42,165,7,161,74,165,73,165,165,148,107,173,115,210,215,218,25,227,123,239,221,251,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,251,247,226,245,222,
49,198,173,177,172,181,7,161,132,144,99,140,34,136,99,140,34,132,33,132,65,128,66,136,67,132,67,132,101,132,166,136,77,149,67,128,125,219,223,235,93,215,93,219,191,231,127,223,26,203,184,194,185,194,184,194,76,157,43,157,175,177,75,165,
41,165,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,57,231,50,198,18,194,149,210,244,210,23,223,56,227,179,210,205,189,16,194,83,206,175,185,
8,157,149,206,222,251,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,23,227,213,222,114,206,173,181,139,177,41,165,100,140,34,132,99,140,34,136,34,132,34,132,34,132,66,132,98,132,67,132,133,132,134,136,44,145,232,144,43,157,93,215,191,227,159,227,29,211,
184,194,218,194,152,190,118,186,151,190,76,153,42,157,175,181,41,161,74,173,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,190,247,222,251,
223,251,255,255,255,255,255,255,255,255,191,251,57,227,82,198,115,202,181,214,205,185,74,165,247,218,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,247,212,214,147,210,15,194,107,173,74,169,132,144,66,136,67,136,66,136,66,132,66,128,33,132,33,132,66,132,67,132,
100,132,133,136,136,132,143,161,67,128,218,194,27,211,218,202,218,194,152,190,152,190,119,178,85,178,242,173,43,153,10,153,141,173,9,157,49,198,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,247,56,231,146,206,81,202,147,210,107,173,75,169,90,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,22,227,180,214,15,194,173,181,107,169,199,152,
67,136,34,132,66,140,66,136,34,132,34,136,34,136,66,132,67,132,100,136,134,136,168,132,44,149,233,144,177,161,218,202,185,190,185,190,151,186,53,174,20,170,209,165,209,165,233,140,11,157,75,165,8,161,90,239,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,239,181,214,114,198,49,194,
41,165,140,177,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,156,247,179,210,147,206,205,185,107,173,41,165,67,140,66,136,65,136,66,136,66,136,34,136,66,136,66,136,66,132,100,132,133,136,201,136,233,148,210,169,234,144,251,198,151,186,119,182,53,174,210,165,178,161,176,161,175,165,
201,140,75,157,74,165,206,181,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,243,89,231,115,202,141,181,8,161,115,206,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,23,227,115,210,15,194,172,177,75,169,132,144,66,140,34,136,66,136,34,132,66,132,66,136,66,136,99,136,100,136,165,144,167,136,9,145,53,178,
167,140,153,190,54,174,19,170,177,161,176,157,144,157,209,165,76,153,9,145,41,161,107,169,188,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,254,255,253,255,255,255,255,255,189,243,20,219,208,210,52,227,255,255,255,255,255,255,255,255,255,255,255,255,91,239,83,202,41,165,40,161,89,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,114,206,113,206,15,194,173,185,230,156,66,140,67,136,66,136,66,136,
66,136,98,140,67,136,99,136,132,140,166,140,199,144,10,149,18,182,200,140,118,190,21,170,177,161,144,157,176,165,249,202,150,190,199,136,10,153,75,165,122,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,235,20,219,42,190,136,177,172,177,138,169,41,190,84,223,254,255,255,255,255,255,255,255,255,255,255,255,255,255,90,235,206,181,
231,152,49,194,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
189,247,47,194,80,202,237,185,105,173,100,144,67,140,66,136,66,136,66,136,66,140,67,140,99,140,133,144,166,144,230,148,177,165,9,153,76,157,19,178,210,161,176,161,52,178,59,211,209,169,133,128,232,144,174,169,247,218,222,251,223,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,188,247,55,231,211,218,9,182,101,161,7,157,75,165,75,165,73,169,140,173,241,193,72,186,
116,227,255,255,255,255,255,255,254,255,255,255,255,255,255,255,222,251,213,214,232,156,9,161,123,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,154,243,238,193,113,202,239,189,198,148,100,140,65,136,65,132,66,136,99,140,99,140,100,144,132,144,167,152,230,152,206,181,66,128,83,186,18,178,52,182,217,202,151,194,
197,144,197,148,40,161,207,185,116,206,215,222,90,235,222,251,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,253,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,251,255,251,156,239,87,235,174,206,8,178,105,165,7,161,
232,156,7,161,198,152,165,148,165,148,100,140,99,140,198,148,105,165,40,178,115,227,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,156,239,206,185,198,156,181,214,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,122,235,15,190,113,202,106,173,99,140,65,136,65,136,66,136,98,140,132,144,165,144,165,148,
166,152,75,169,99,136,75,157,26,219,183,202,51,190,173,169,141,169,240,189,49,202,83,202,147,206,181,214,24,231,124,239,221,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,252,251,
153,235,244,218,42,194,135,169,231,156,163,144,132,136,165,140,101,144,66,132,33,132,32,132,33,132,0,132,0,128,1,128,34,132,64,136,199,156,36,170,149,231,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,57,231,232,160,
17,198,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,251,80,198,
16,194,5,161,66,140,66,136,67,136,100,140,132,144,134,148,199,156,232,160,131,144,231,152,156,239,149,206,173,177,205,181,114,202,23,223,90,235,123,239,155,243,156,243,155,239,155,243,221,247,254,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,254,255,255,255,255,255,220,247,88,235,240,214,137,186,4,149,130,140,66,140,64,132,32,128,34,132,1,132,64,132,32,128,32,132,0,128,0,128,33,132,99,140,165,148,74,169,206,185,114,202,249,218,108,177,135,186,150,235,255,255,
255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,247,107,173,239,189,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,251,179,210,172,181,133,144,68,140,100,140,166,148,198,152,165,148,132,144,98,136,107,177,213,218,16,194,114,202,213,218,90,231,156,247,222,255,255,255,255,255,255,255,255,251,255,251,
222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,155,243,21,227,205,202,200,190,232,190,231,194,9,199,165,169,230,152,0,132,0,128,32,128,1,128,1,128,66,140,166,144,41,161,206,185,82,206,180,210,247,222,
24,227,247,222,246,218,245,222,214,218,214,218,74,173,201,194,152,231,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,74,165,238,185,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,121,239,180,214,171,181,230,156,229,156,229,152,39,165,14,194,245,218,246,222,23,227,155,239,156,247,
222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,254,255,221,255,153,243,240,214,204,198,200,190,232,186,8,191,8,191,39,195,7,195,7,195,39,187,102,161,232,160,40,169,174,181,
49,198,149,214,248,222,24,227,24,227,214,218,247,218,247,218,214,218,213,214,181,214,181,210,147,214,150,210,148,202,115,202,72,165,74,203,154,247,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,199,156,82,202,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,254,255,122,239,
89,235,188,247,187,247,122,243,253,255,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,243,53,231,206,210,202,190,44,203,112,215,113,219,114,223,80,215,43,203,
41,195,41,195,41,195,7,195,73,199,41,203,70,157,247,222,24,227,24,227,247,222,215,218,214,222,215,218,182,214,181,214,181,214,181,214,149,210,148,206,115,206,84,202,81,198,50,202,114,206,48,190,40,161,140,207,253,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,24,227,132,144,156,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,253,255,154,243,53,227,236,198,234,194,
232,190,145,219,252,243,191,247,223,251,188,247,157,243,188,243,122,239,118,227,13,207,41,203,40,199,41,199,74,199,40,199,103,157,246,218,247,222,214,218,212,214,149,218,181,214,116,210,114,206,82,206,82,202,50,198,16,194,16,194,83,202,49,194,
75,177,195,144,6,153,69,170,167,203,244,227,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,140,177,107,169,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,255,255,255,255,
255,255,189,251,88,231,241,210,237,198,232,190,7,191,39,191,12,203,151,235,221,255,159,251,156,243,86,227,115,223,19,215,55,231,122,235,57,227,246,222,114,223,71,195,73,195,72,199,74,203,233,194,105,165,214,218,115,206,149,206,82,206,82,202,
50,198,48,198,16,194,239,189,17,198,239,189,74,169,99,144,34,153,133,170,105,207,239,227,242,235,241,239,206,223,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,148,210,165,148,222,251,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,18,223,234,194,9,199,230,190,7,191,8,199,7,191,6,191,115,219,123,239,125,243,151,235,9,203,72,199,40,195,71,191,39,195,48,211,157,243,25,231,123,235,109,211,105,199,
72,195,72,195,73,203,71,182,175,185,50,206,48,198,242,193,206,185,15,186,17,194,240,193,10,165,131,140,35,149,165,182,169,207,240,223,243,231,240,231,174,227,205,210,145,206,124,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,247,222,41,165,89,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,122,239,55,227,48,215,40,195,41,195,8,199,40,195,8,195,41,195,123,231,123,239,90,239,116,223,73,199,42,199,
74,199,73,203,73,199,72,203,220,247,255,255,255,255,179,231,105,203,105,207,73,199,135,203,106,203,196,161,82,198,174,185,172,185,139,177,231,160,164,144,99,157,198,182,202,207,239,227,241,235,239,231,108,219,172,198,144,198,23,223,219,247,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,115,206,173,181,90,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,251,82,202,55,231,110,215,41,191,40,195,
7,195,9,195,39,195,87,227,88,235,122,239,154,235,74,199,70,203,74,199,72,195,103,199,143,219,255,255,223,255,222,255,213,231,104,195,138,203,139,199,169,199,136,199,106,207,4,153,132,140,196,144,194,157,7,195,235,219,239,231,242,239,239,239,
75,215,172,190,179,210,156,243,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,99,140,239,189,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,123,239,205,189,244,218,74,203,41,191,7,195,74,199,72,199,49,215,157,247,158,251,255,255,252,247,180,227,144,223,178,223,249,239,255,255,255,255,255,255,255,255,141,211,135,199,136,203,137,203,106,199,139,199,168,203,
103,199,38,195,236,219,240,235,242,231,239,227,41,207,107,194,246,218,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,251,75,173,198,152,82,206,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,148,210,140,189,118,235,104,199,41,195,105,203,74,199,74,207,118,227,255,255,255,255,255,255,254,255,254,251,254,255,222,255,189,255,255,255,
253,251,145,219,104,199,138,203,138,207,136,195,169,199,201,207,237,223,241,231,242,231,141,219,203,198,176,202,56,231,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,253,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,90,235,231,156,165,144,107,177,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,241,197,171,189,179,231,103,195,73,203,74,195,105,207,105,199,
79,211,218,239,255,255,254,255,255,255,255,255,255,255,253,247,183,235,110,207,106,199,137,203,168,203,169,211,204,219,242,235,240,235,172,223,170,194,113,198,153,231,254,251,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,239,205,185,98,136,100,144,49,198,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,
255,255,188,243,206,189,87,235,108,207,105,203,137,203,137,199,103,195,137,203,104,203,106,207,146,223,146,215,114,223,109,211,106,203,168,203,168,199,203,211,236,227,241,235,240,231,75,207,140,198,113,206,156,247,254,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,189,247,115,206,8,157,66,136,132,144,73,169,57,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,148,210,155,251,216,247,103,195,105,203,138,203,105,203,138,207,105,199,138,211,137,199,135,203,136,199,201,207,204,215,238,227,241,235,240,239,43,215,75,190,145,210,
188,243,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,254,251,24,223,16,194,198,152,66,136,132,140,165,148,139,177,56,231,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,220,251,16,194,252,251,78,227,137,199,169,203,169,203,137,199,138,199,169,203,201,211,235,219,
240,227,239,231,207,227,10,207,42,190,180,210,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,251,149,214,106,173,99,136,99,136,
98,136,133,148,42,165,116,206,190,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,220,251,141,177,198,156,
16,223,105,203,137,203,137,203,200,207,204,215,242,239,245,243,208,223,235,202,76,186,180,206,189,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,57,231,173,181,66,136,132,140,132,140,132,144,140,173,214,218,188,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,247,222,229,156,17,194,108,173,48,202,238,223,238,223,241,231,243,239,207,227,201,194,235,185,115,214,189,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,214,218,166,152,65,136,133,144,132,144,106,173,181,218,254,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,251,206,185,108,173,173,181,15,190,84,206,240,189,181,243,142,227,103,190,203,181,115,206,122,239,255,255,255,255,255,255,255,255,255,255,254,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,247,218,198,152,67,140,132,148,132,144,16,194,157,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,41,161,206,181,215,222,246,218,181,218,215,218,82,202,17,194,114,210,90,239,255,255,
255,255,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,107,173,232,160,74,169,132,144,107,177,189,251,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,157,173,181,215,222,
248,226,155,239,222,251,155,247,156,247,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,214,214,
164,148,15,194,74,165,41,161,214,214,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,172,177,108,173,58,231,123,235,221,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,239,193,198,152,239,189,107,169,107,173,247,226,156,243,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,246,222,231,156,215,218,223,251,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,243,214,218,74,169,41,165,173,181,165,148,132,148,66,140,131,144,66,140,131,144,165,148,75,169,115,210,188,243,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,161,15,194,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,57,235,239,185,198,148,0,128,33,132,41,165,74,169,230,152,107,173,115,206,214,214,214,222,246,222,
148,210,206,185,41,165,132,144,132,144,108,173,188,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,124,243,198,152,
123,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,231,174,181,132,148,67,140,99,144,231,160,107,173,
9,161,106,173,214,214,247,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,251,83,206,230,152,100,144,17,194,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,223,255,255,255,214,218,106,169,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,157,243,
50,198,198,152,34,136,165,148,164,144,107,173,213,214,90,235,7,161,41,165,247,218,214,218,189,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,239,193,133,144,40,161,222,251,255,255,255,255,255,255,223,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,214,218,41,165,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,246,222,73,165,66,136,99,136,133,148,8,165,83,206,222,247,255,255,255,255,40,165,41,165,181,214,247,218,222,247,255,255,255,255,223,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,215,222,198,152,198,152,221,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,155,239,198,148,123,239,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,239,239,189,132,144,66,136,100,140,165,148,206,185,57,235,255,255,255,255,255,255,255,255,57,231,166,152,206,185,247,222,189,247,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,239,165,148,198,148,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,206,185,198,152,156,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,188,247,82,202,8,157,33,132,99,144,131,144,41,161,181,214,254,255,255,255,255,255,255,255,255,255,255,255,
255,255,140,177,41,165,115,206,157,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,89,235,231,156,73,165,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,140,177,133,144,205,181,90,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,239,49,198,232,160,99,140,99,140,132,144,198,148,240,193,
123,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,161,172,181,90,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
214,218,165,144,148,206,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,214,218,42,169,7,157,7,161,8,165,173,181,173,177,108,177,73,165,
197,152,131,144,165,148,164,148,197,152,238,185,57,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,56,227,42,169,115,202,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,141,181,100,140,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,223,251,123,239,214,218,115,206,82,202,16,194,16,194,206,185,173,181,206,185,115,206,91,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,181,214,74,169,189,247,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,155,243,199,152,247,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,82,202,174,185,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,141,177,82,202,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,82,202,82,202,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,115,206,16,194,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,82,202,49,198,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,181,214,239,185,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,114,202,
172,181,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,82,202,239,189,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,24,227,8,161,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,73,169,83,202,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,231,152,90,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,235,165,148,247,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,173,181,173,181,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,8,161,41,165,189,247,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,181,210,165,152,124,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,206,185,165,152,148,210,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,75,169,106,173,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,239,185,100,144,75,173,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,115,206,198,148,115,206,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,41,161,132,144,41,165,221,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,74,169,165,152,214,218,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,50,198,99,140,132,144,73,169,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,243,41,165,133,144,148,214,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,49,194,100,140,98,140,132,144,16,194,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,243,8,161,8,161,74,169,248,226,189,247,255,255,255,255,188,247,247,222,49,198,231,156,
66,136,132,144,132,144,41,165,89,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,141,181,
239,185,173,181,41,165,230,152,132,144,67,140,132,144,99,140,165,148,164,144,41,169,24,227,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,56,231,206,185,139,177,41,169,199,156,198,156,231,156,140,177,115,206,156,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,

 } ;


rom int8 jpeg_dog[12750] = {  

/*('file properties ', 'resolution ', 75, 'x', 85, 'format ', 'ARGB1555', ' total size ', 12750)*/ 

255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,254,255,254,255,254,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,222,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,254,255,253,255,186,255,120,251,120,251,153,255,218,255,219,255,253,255,254,255,253,255,253,255,254,255,254,255,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,220,255,186,255,153,251,54,247,177,234,44,222,233,217,232,213,41,218,76,226,141,230,175,234,208,238,18,243,85,247,119,251,186,255,219,255,252,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,221,255,88,251,242,238,110,226,11,218,233,217,199,217,231,221,230,221,196,221,196,225,230,225,7,230,39,230,
39,230,40,226,74,226,108,230,207,238,51,247,86,251,153,251,218,251,252,255,254,255,254,255,255,255,254,255,255,255,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,153,251,178,230,235,213,135,209,
134,209,198,217,197,221,229,225,6,230,229,229,229,229,6,230,39,238,38,230,38,234,71,238,71,238,104,234,104,234,105,230,139,234,172,238,239,238,17,243,84,255,184,255,218,255,186,255,218,255,219,255,219,255,252,255,254,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,187,255,245,234,236,209,103,197,101,205,134,213,197,221,197,221,163,225,195,225,229,233,37,234,5,230,37,230,39,234,103,238,38,242,104,246,136,246,103,246,103,238,103,234,137,242,137,242,137,238,171,242,204,242,
205,238,174,238,207,238,207,238,240,238,86,247,153,251,253,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,254,255,254,255,255,255,255,255,255,255,254,255,121,251,77,222,135,205,102,201,101,209,101,213,99,213,99,221,197,229,195,225,6,234,229,229,72,238,40,230,72,230,104,234,71,230,
103,238,103,242,136,242,137,242,137,246,170,246,170,242,137,246,137,242,136,238,136,242,136,242,169,242,138,242,105,242,105,238,74,234,207,238,53,243,219,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,254,255,254,255,188,255,21,239,13,218,102,201,69,197,67,197,67,205,133,213,
133,217,131,217,197,229,196,229,6,238,5,230,104,242,72,238,104,234,104,238,71,234,104,238,137,242,169,246,169,246,169,246,201,250,201,246,137,246,169,242,168,246,168,246,135,246,167,242,135,238,103,242,103,238,105,242,40,226,76,226,178,234,186,255,
255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,254,255,255,255,
255,255,253,255,252,255,52,243,202,209,134,205,100,201,100,205,100,209,67,205,132,213,164,221,163,221,164,225,5,230,39,234,5,234,105,246,102,238,104,238,103,238,70,234,71,238,137,246,169,246,169,246,136,242,170,250,168,246,136,246,167,246,135,246,
166,242,135,242,134,246,135,242,102,242,103,242,37,238,164,217,166,213,167,205,145,234,188,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,251,254,255,254,255,251,255,84,247,10,214,166,209,198,221,132,213,132,213,132,213,132,217,131,217,196,221,229,229,230,225,37,230,71,234,70,238,103,242,70,242,102,238,70,238,
102,238,136,242,137,242,105,242,137,246,104,242,168,246,135,242,135,242,135,246,134,242,134,242,134,242,135,246,168,250,103,242,71,242,37,238,228,233,164,217,133,209,233,217,53,251,253,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,219,255,242,238,42,222,41,222,230,225,165,217,67,209,99,213,100,217,133,217,
164,217,197,221,6,230,39,230,39,234,38,234,103,238,102,242,135,246,37,238,103,242,135,242,168,246,103,242,38,234,70,234,4,230,5,226,5,230,71,238,137,246,136,246,103,242,102,242,134,246,102,242,69,242,69,238,226,229,227,229,163,221,133,217,
135,213,144,234,153,255,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,252,255,
151,251,174,230,75,226,40,230,39,226,7,230,99,213,100,213,100,213,99,213,131,213,164,217,196,221,6,230,72,238,103,238,71,234,136,242,136,242,169,246,69,238,103,242,103,238,103,242,37,234,37,234,37,234,228,225,162,217,163,221,5,226,102,242,
103,242,135,246,135,242,102,242,102,242,101,242,69,242,38,238,228,225,131,217,34,209,68,209,168,209,177,230,154,255,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,253,255,219,255,52,247,76,222,8,218,8,230,6,226,229,221,196,221,99,213,68,213,101,213,67,205,99,205,164,213,165,217,6,230,104,238,105,238,103,234,137,242,136,238,201,250,103,234,
103,234,70,234,103,242,38,234,71,238,39,238,71,238,195,225,196,225,230,229,37,234,70,238,136,242,135,246,103,242,70,242,71,242,103,242,39,238,163,221,132,217,132,217,101,217,69,209,235,217,21,247,221,255,254,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,219,255,54,243,76,226,231,217,230,221,7,226,229,221,195,217,99,213,36,205,36,201,36,205,36,201,
100,209,99,209,164,217,7,226,6,230,105,242,104,238,136,238,137,238,203,246,136,238,39,230,5,226,38,234,5,230,38,238,5,226,6,234,163,221,5,234,39,238,40,234,40,238,74,242,104,242,104,242,103,242,70,238,70,242,39,242,196,225,98,217,
98,217,66,213,102,217,168,217,79,230,187,255,253,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,253,255,255,255,253,255,252,255,117,255,42,226,
198,221,229,221,228,225,229,225,229,221,132,217,68,205,67,201,3,197,35,193,68,205,68,209,133,213,164,217,7,226,73,234,137,238,137,238,105,238,105,238,104,242,135,242,37,234,228,225,228,229,38,238,38,238,4,230,38,238,229,225,73,230,106,230,
8,218,75,226,173,238,73,234,70,234,101,242,102,242,69,234,69,234,229,229,66,209,66,209,67,217,100,217,167,221,41,234,17,247,218,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,254,255,254,255,219,255,53,243,10,218,199,217,198,221,229,221,228,225,228,225,196,221,133,217,68,201,226,192,225,188,3,197,2,201,1,201,66,205,132,213,197,221,7,226,71,238,169,242,104,234,137,238,104,238,
136,242,38,234,163,217,229,225,104,246,102,242,102,242,5,234,6,230,8,226,66,193,192,172,193,176,69,189,166,205,40,234,70,238,70,238,137,246,71,238,5,230,98,213,67,209,67,213,133,221,166,221,232,225,174,238,184,255,254,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,186,255,143,218,233,213,232,217,231,217,198,221,229,225,228,221,196,225,229,221,133,209,36,197,3,193,226,192,192,188,
2,197,132,213,198,225,164,221,130,213,197,225,38,234,136,246,103,242,71,242,70,234,103,238,39,234,132,217,132,213,137,242,71,242,103,242,4,230,229,221,166,209,160,172,96,152,137,193,162,168,64,160,68,201,40,234,105,242,104,242,103,242,6,234,
132,217,35,209,66,209,166,217,166,225,198,221,42,226,243,242,221,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,254,255,254,255,242,230,233,209,165,209,198,221,
167,221,166,221,165,221,164,221,196,225,165,221,67,205,227,192,4,197,2,193,35,201,101,209,198,221,199,221,132,213,131,213,196,221,71,238,103,242,70,242,69,238,70,238,71,238,39,230,165,217,99,205,106,238,170,250,168,250,37,230,163,213,2,193,
128,172,130,160,229,176,197,176,129,168,96,172,130,205,71,234,70,234,103,242,7,234,165,217,2,205,34,205,166,225,198,225,165,217,166,217,44,222,154,255,255,255,255,255,223,255,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,254,255,254,255,55,239,234,205,166,205,198,221,132,217,199,221,165,221,165,217,196,221,197,221,132,213,2,197,226,188,5,193,193,188,69,205,133,213,200,217,167,213,101,205,132,209,132,213,40,234,71,238,70,242,36,234,
70,238,103,238,7,230,100,213,132,209,138,242,203,254,169,250,103,238,229,217,33,193,2,189,228,180,163,176,6,189,129,172,35,193,40,230,137,242,36,230,71,238,230,233,133,217,1,197,67,205,166,221,231,233,165,217,132,213,201,217,53,247,253,255,
254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,188,255,210,230,233,213,133,213,132,217,100,217,133,217,133,217,165,221,197,225,133,217,35,201,2,193,226,188,4,189,226,184,
135,209,102,209,135,213,36,193,3,185,35,189,133,201,199,217,40,230,5,234,38,238,103,242,136,242,39,230,99,209,100,209,138,242,137,246,169,250,168,242,137,242,230,221,133,209,226,192,193,188,160,180,160,184,231,217,105,234,136,238,4,230,38,238,
230,229,100,213,193,192,36,205,133,221,8,234,197,229,131,213,198,217,111,230,219,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,255,85,247,200,209,133,213,100,213,
165,221,99,213,134,213,166,217,198,221,133,213,226,196,225,188,3,189,3,189,36,193,69,201,135,209,103,201,195,168,64,152,96,156,4,177,34,189,165,217,229,229,6,238,71,238,104,238,73,238,230,225,165,221,138,246,105,242,137,242,201,246,235,246,
104,234,230,225,230,225,198,225,231,225,106,234,205,246,236,250,169,246,5,230,4,230,230,229,34,205,193,192,2,201,165,221,7,234,230,233,131,221,165,217,233,217,20,247,219,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,154,251,77,222,134,209,133,213,99,213,100,213,133,217,165,217,132,213,165,217,133,213,2,193,194,188,3,189,35,189,69,197,2,193,101,201,160,168,32,148,65,144,163,156,64,152,160,168,34,197,197,229,
230,229,71,238,39,234,137,242,139,246,7,234,138,246,104,242,103,238,202,242,168,242,70,234,38,238,39,234,72,246,170,250,204,250,13,251,236,246,170,246,103,242,227,225,6,230,225,196,225,192,2,197,133,217,231,229,7,238,197,229,131,217,134,213,
235,213,55,247,253,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,253,255,186,255,77,226,133,209,100,201,66,201,132,213,134,213,100,213,133,213,68,201,102,205,226,188,35,197,36,197,69,197,
1,185,3,193,161,172,32,156,130,156,98,148,64,144,65,144,32,152,225,180,198,221,165,221,198,221,40,226,103,226,135,234,101,234,37,230,38,234,72,238,137,242,170,246,170,246,103,238,70,238,103,238,168,242,171,242,204,246,205,250,138,246,103,242,
38,238,8,230,3,201,36,205,2,205,133,221,166,229,6,238,163,229,196,225,165,213,232,213,211,234,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,153,251,201,205,35,197,68,201,
35,197,100,209,132,209,132,213,101,209,102,205,4,193,161,180,225,184,4,193,36,197,35,193,193,180,64,164,64,160,97,156,64,148,96,148,64,152,96,164,35,193,133,217,131,217,165,221,39,226,6,222,71,230,70,234,39,234,104,238,171,246,170,242,
171,242,169,242,103,238,103,238,136,238,202,242,203,242,171,242,170,242,138,242,136,242,104,242,232,229,35,201,68,205,34,205,132,217,198,229,229,233,229,233,197,225,230,225,8,222,209,234,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,254,251,253,255,144,218,102,193,35,197,3,193,134,205,193,184,2,193,100,205,100,209,102,205,194,184,129,176,193,180,2,185,2,189,34,189,3,193,37,197,69,193,3,181,193,168,162,172,195,176,225,180,35,197,
132,213,99,213,164,213,165,213,196,213,39,230,39,230,72,234,105,242,171,246,203,246,203,246,202,246,201,242,104,238,103,234,135,238,202,246,202,246,170,242,137,242,136,242,103,242,199,225,35,201,36,205,67,209,133,221,197,229,163,229,229,237,5,234,
231,229,231,217,143,230,220,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,255,202,197,35,185,3,193,3,193,36,197,128,176,1,189,100,205,100,201,36,193,162,184,129,172,226,180,193,180,
192,176,225,184,3,193,101,209,133,209,166,205,233,213,168,205,135,209,36,197,35,201,132,213,132,213,132,213,131,209,164,209,231,225,6,230,71,234,106,238,170,242,203,242,203,246,235,250,235,250,170,250,71,238,102,238,136,242,168,242,136,242,135,242,
103,242,104,242,198,221,3,201,35,205,133,217,197,225,230,229,229,233,229,233,6,234,197,225,230,217,175,234,219,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,89,247,135,193,35,189,35,193,
4,189,194,180,193,180,35,189,101,201,36,201,226,188,195,184,162,176,195,176,193,176,224,180,226,188,2,193,101,209,100,209,166,213,200,217,166,209,102,209,36,197,35,201,68,209,99,209,133,213,165,213,164,213,197,217,6,230,72,234,105,238,170,242,
171,246,235,246,203,250,235,246,203,246,104,238,103,238,135,246,134,246,133,242,101,242,70,238,136,238,166,221,2,201,34,205,165,221,197,229,229,233,5,234,6,238,6,234,229,225,7,226,241,242,219,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,254,255,253,255,46,214,37,185,35,189,36,193,227,184,162,180,194,176,2,181,69,197,36,197,225,188,194,184,163,180,129,168,194,180,4,193,68,197,226,192,1,193,100,205,133,209,165,209,167,213,134,209,3,197,
35,197,35,201,67,201,133,213,133,213,132,213,165,217,229,221,39,230,105,234,138,234,171,242,203,246,204,246,12,247,204,242,138,238,103,234,70,238,102,242,134,246,102,246,101,242,104,238,165,213,1,201,2,209,165,225,197,229,197,229,37,234,71,242,
39,234,7,230,231,217,142,230,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,221,255,121,251,70,189,4,189,35,189,226,184,227,188,162,176,3,181,35,185,4,189,227,188,226,192,194,188,195,180,97,164,
162,176,4,197,36,197,2,193,2,193,100,209,133,209,100,209,134,209,68,201,226,188,3,193,227,192,3,197,68,205,132,209,163,213,198,217,197,221,40,226,105,234,138,234,171,242,172,238,205,242,47,247,238,238,206,242,138,234,71,234,103,242,167,246,
135,246,135,238,104,234,132,213,33,201,99,213,197,225,229,233,230,233,39,238,70,234,71,234,39,226,198,213,77,222,220,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,155,251,104,189,37,193,35,189,68,193,
4,197,194,184,194,180,4,185,3,181,227,184,194,188,3,197,194,188,195,184,129,168,129,172,4,193,69,205,101,209,67,201,67,201,101,209,166,209,101,201,34,193,3,189,3,193,225,184,192,184,2,197,164,213,197,217,197,217,197,213,72,226,171,234,
173,238,172,238,140,234,173,230,15,235,48,239,82,247,239,242,73,234,72,234,103,238,103,238,103,238,39,230,98,209,1,201,99,217,196,225,5,234,6,238,70,238,38,230,71,234,39,226,8,222,209,234,188,255,255,255,255,255,255,255,255,255,255,255,
253,255,255,255,255,255,255,255,255,255,254,255,237,205,37,189,36,197,68,193,36,193,36,193,227,188,227,184,38,193,5,189,193,180,225,180,3,193,226,192,195,188,227,184,128,172,228,192,68,201,65,197,33,193,2,197,67,201,68,205,68,201,36,193,
3,193,226,184,162,180,193,180,224,188,99,205,166,217,199,213,166,205,74,218,174,226,10,214,102,193,36,181,161,160,4,173,234,201,19,243,19,251,238,246,135,230,135,238,168,246,70,242,196,225,99,201,224,188,98,217,164,229,197,229,39,238,229,237,
70,234,39,226,41,218,243,234,186,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,222,255,46,206,4,185,3,193,35,197,226,184,3,193,36,193,227,188,36,189,195,180,192,176,193,180,3,193,226,192,4,189,
227,184,96,168,227,180,68,201,99,205,34,201,1,193,35,197,34,197,2,193,3,193,36,193,227,184,161,176,193,180,225,188,133,209,232,217,10,222,234,209,36,177,192,164,128,164,96,160,130,160,196,164,163,160,194,160,228,168,86,255,83,255,171,238,
135,234,136,242,38,238,197,221,99,205,224,188,98,213,196,229,229,229,7,234,5,234,39,234,72,226,174,230,152,251,253,255,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,47,210,70,189,2,189,1,185,
225,184,193,188,226,188,227,184,228,184,228,180,160,176,193,184,3,193,226,196,37,197,37,189,128,168,161,176,35,197,133,205,100,201,3,197,36,197,35,197,35,197,37,197,4,193,227,184,161,176,192,180,2,189,199,209,10,218,202,205,129,160,64,148,
129,160,130,160,39,181,106,185,172,193,172,193,104,181,163,164,104,193,84,255,15,251,138,238,105,238,39,234,164,217,99,201,224,188,67,209,198,233,231,229,198,225,229,233,41,234,174,238,85,251,252,255,253,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,254,255,255,255,254,255,179,222,70,185,3,189,194,184,2,189,226,188,194,188,193,176,193,180,194,180,193,180,194,184,226,188,226,192,102,205,102,201,193,180,96,172,226,184,69,201,101,205,36,197,35,197,68,197,68,197,
37,193,36,193,227,180,194,176,193,176,2,185,200,209,202,205,228,176,32,144,96,148,98,152,197,172,15,210,15,206,140,185,197,160,33,148,98,152,163,160,210,230,117,255,173,238,107,242,107,246,165,213,67,201,224,184,2,201,231,229,232,229,198,221,
198,229,43,234,20,251,220,255,254,255,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,89,243,104,189,3,181,226,180,129,180,226,192,3,193,128,176,227,184,194,180,194,184,194,184,226,184,193,184,
102,205,134,209,4,193,128,176,195,184,69,197,101,205,37,201,69,201,68,197,36,193,36,193,37,193,227,180,193,176,226,180,67,189,232,209,104,197,32,148,130,152,32,136,32,136,130,156,197,168,131,156,163,152,64,144,34,144,98,148,98,148,177,222,
85,251,208,242,108,238,108,242,166,217,68,201,225,188,1,193,231,229,8,230,198,225,198,225,11,234,87,251,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,255,179,222,38,177,
227,180,128,176,193,184,3,189,226,180,37,193,4,193,227,188,226,188,161,184,192,180,68,201,102,205,37,201,160,176,194,180,69,201,69,201,3,193,68,201,68,197,3,189,36,193,69,197,3,181,193,172,226,180,101,197,233,209,70,185,32,148,65,144,
98,140,98,140,65,144,65,144,98,148,131,148,32,140,66,144,132,152,230,160,80,214,119,247,241,242,174,238,76,238,199,217,68,201,2,193,225,192,198,217,231,229,230,225,197,225,10,226,88,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,253,255,46,210,229,176,196,184,161,180,194,184,3,185,3,185,227,184,3,193,227,192,226,188,193,180,34,197,37,205,101,205,161,176,161,176,4,193,2,189,226,184,2,189,225,188,
225,184,36,197,68,193,226,184,160,172,226,180,101,197,168,205,36,185,96,152,33,144,98,144,64,132,64,140,98,144,64,136,97,144,98,148,231,164,74,181,164,160,179,222,87,243,118,251,17,247,76,234,198,221,100,205,35,201,34,197,99,213,230,233,
229,229,165,225,9,226,120,255,255,255,255,255,221,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,155,251,229,172,163,176,161,172,128,172,3,181,226,180,227,184,4,193,4,197,36,197,
226,188,2,193,36,201,134,213,194,184,161,176,227,188,226,188,225,188,193,184,192,184,225,184,36,193,36,189,226,180,161,172,226,180,68,197,168,205,37,181,96,152,66,144,64,140,97,132,64,136,96,140,96,140,96,144,64,144,98,148,131,152,73,177,
245,230,86,239,119,247,241,246,141,242,166,213,101,209,100,209,99,205,66,209,6,238,229,229,196,225,41,230,86,247,255,255,255,255,221,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
187,251,15,202,196,168,196,176,128,168,227,180,194,176,227,184,3,193,3,185,3,189,2,189,2,189,4,197,70,209,227,196,194,180,3,193,3,193,193,184,161,184,225,188,68,201,101,201,35,193,35,189,226,184,225,180,102,201,168,201,169,197,196,168,
32,140,64,136,97,140,64,136,96,140,162,144,96,140,129,148,64,144,98,152,47,202,54,231,86,235,185,251,19,243,140,234,199,221,99,209,66,205,67,205,33,197,230,221,230,229,198,225,73,226,118,247,254,255,254,255,254,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,155,251,81,218,39,185,196,172,226,176,193,176,194,180,4,193,3,189,36,189,3,189,2,193,3,197,101,209,226,192,226,184,3,197,3,189,194,184,226,188,
3,193,166,213,102,205,101,201,35,193,2,185,69,193,135,205,136,201,138,201,71,185,172,189,197,160,64,140,97,144,65,144,97,144,97,144,96,144,97,148,40,169,81,206,23,231,152,247,54,243,18,247,76,230,231,221,165,213,100,205,67,201,67,197,
9,222,233,225,7,222,107,226,119,247,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,255,221,255,212,230,162,164,228,180,226,180,226,184,36,197,36,193,
4,193,35,189,2,193,2,193,69,205,194,188,4,193,68,197,3,193,226,188,227,192,68,197,166,213,69,201,34,189,100,193,100,197,101,197,134,201,168,205,168,197,71,193,14,202,172,185,230,164,163,156,98,152,32,140,64,140,130,148,163,152,73,177,
48,206,244,222,55,239,120,251,209,242,75,230,132,209,199,221,69,201,36,197,69,197,143,238,176,238,143,238,243,238,186,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,56,243,211,230,71,193,4,189,227,192,36,197,37,197,36,193,4,193,2,193,2,193,36,205,193,184,4,193,36,197,3,193,227,188,227,192,35,193,102,205,3,193,226,184,68,193,167,201,200,209,168,205,234,213,11,214,
203,209,204,197,171,193,172,189,106,185,164,160,164,160,97,148,6,169,6,169,139,185,180,222,55,239,53,235,21,243,210,246,75,230,132,213,231,217,35,197,227,188,103,201,88,255,186,255,154,255,186,251,254,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,254,255,154,255,170,205,4,189,3,189,36,197,68,197,37,197,4,197,227,192,2,193,36,201,192,180,226,184,3,193,227,188,195,184,
195,184,226,188,102,201,36,197,160,176,226,180,135,197,167,201,201,205,43,218,12,218,12,214,204,201,237,201,237,197,173,197,197,168,230,168,73,177,39,173,206,197,15,206,147,222,212,230,54,239,46,214,210,246,9,226,165,217,100,201,102,205,227,188,
203,213,187,255,221,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,89,251,38,189,226,184,3,193,35,197,
36,201,36,197,3,193,3,193,3,193,227,192,160,180,161,180,226,184,227,192,227,184,195,188,226,188,36,197,69,197,226,184,160,168,36,181,169,201,10,214,11,214,45,218,45,214,14,214,237,205,138,189,15,210,106,185,139,189,230,168,98,156,198,172,
74,189,114,222,114,226,137,189,163,168,77,226,167,213,67,209,67,201,167,213,68,201,201,209,154,255,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,254,255,80,218,228,184,194,184,68,205,2,201,67,197,36,197,226,188,4,201,36,201,194,184,160,176,162,180,226,184,3,189,228,184,229,192,226,184,225,184,68,193,70,197,96,168,64,160,169,201,202,209,169,205,
78,226,13,214,170,205,202,197,137,185,138,185,197,168,130,156,65,152,32,148,32,156,230,176,206,209,48,218,96,160,128,164,201,217,101,209,67,209,102,209,100,201,67,205,167,209,154,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,187,247,105,185,39,193,193,184,34,197,1,197,35,197,35,197,194,188,36,201,36,201,193,184,161,176,194,180,225,184,227,188,
195,180,228,188,194,180,193,180,36,197,103,201,4,185,96,160,128,164,4,185,12,218,45,222,13,218,13,218,171,197,5,169,131,152,32,144,32,148,64,148,64,156,131,168,106,197,15,218,244,242,5,185,162,172,11,226,100,209,36,209,103,209,100,209,
132,213,233,217,184,251,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,48,214,72,193,70,193,35,193,68,201,
2,201,1,197,34,197,194,188,37,201,4,193,161,180,161,180,193,180,193,180,195,184,131,176,163,180,161,176,226,184,193,184,68,197,69,201,4,189,64,156,33,144,131,148,7,169,104,189,228,172,64,160,32,160,33,164,65,164,34,164,33,160,166,180,
9,201,173,221,83,234,214,246,238,209,160,168,42,230,67,209,66,217,133,217,164,213,132,209,201,213,187,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,255,255,255,255,
254,251,254,251,255,255,255,255,222,255,187,255,104,189,227,176,103,201,4,193,3,193,67,205,1,193,3,197,70,205,38,197,161,184,162,180,193,180,161,180,162,176,162,180,163,180,163,180,194,176,194,184,226,184,226,184,3,189,37,193,161,164,97,148,
32,136,65,148,130,160,97,160,32,156,99,168,198,184,40,197,42,205,133,180,233,200,174,229,83,242,149,246,214,246,113,234,160,172,200,221,166,221,131,221,131,213,132,209,134,209,45,222,188,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,222,255,47,210,162,172,194,176,135,201,226,188,161,180,69,201,37,193,69,201,70,201,227,188,162,184,4,193,195,184,194,180,161,180,
161,180,195,180,195,180,163,180,194,184,227,188,194,180,4,193,226,180,70,185,129,156,32,144,0,144,33,152,132,168,197,180,140,209,174,217,207,221,50,238,108,221,142,225,16,238,117,254,118,250,181,250,212,246,4,193,167,213,166,217,197,225,133,217,
132,209,199,209,144,234,188,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,222,255,255,255,56,239,228,168,128,164,194,180,101,197,162,180,
96,168,128,172,194,180,5,193,3,185,161,180,195,184,194,188,162,184,193,188,193,184,161,180,195,180,162,180,194,180,194,176,226,180,226,184,227,184,194,176,227,176,229,172,64,148,32,144,66,156,74,197,206,213,114,238,82,242,115,246,182,254,49,246,
17,242,82,246,116,250,149,250,246,254,22,255,201,217,200,221,166,221,198,225,197,221,197,217,42,222,20,243,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,188,255,170,193,163,164,128,168,194,176,37,193,194,180,128,168,64,164,96,168,194,176,194,184,194,184,227,188,194,184,194,184,193,184,193,188,193,180,194,184,161,180,227,184,194,180,162,176,162,176,195,176,162,172,161,168,
228,180,194,172,0,148,32,156,171,213,16,230,115,246,150,250,182,250,181,254,181,254,50,242,148,254,182,250,214,250,246,254,55,255,44,230,200,225,232,229,197,225,229,225,7,226,241,246,186,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,189,255,146,222,228,172,162,172,96,164,227,184,70,197,3,185,128,176,96,168,160,172,161,176,226,184,226,188,36,193,35,197,226,192,193,188,
225,188,193,184,194,184,194,184,227,184,195,180,162,176,163,172,162,172,96,164,160,172,162,172,103,193,163,172,64,156,107,205,48,234,83,242,215,254,149,246,182,246,215,254,82,238,182,250,214,250,214,250,214,250,22,255,45,234,9,230,41,234,5,226,
5,230,40,230,117,255,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,187,255,178,230,104,189,227,176,129,168,96,164,227,180,70,197,
36,193,193,176,161,176,161,180,193,184,68,193,35,201,36,201,36,197,2,193,3,193,226,192,226,188,226,188,227,188,227,184,195,176,161,172,162,168,97,168,129,168,96,168,227,180,69,193,102,201,161,176,6,197,49,234,83,242,117,246,149,246,215,250,
182,250,83,238,148,246,182,250,214,246,181,246,179,250,11,234,107,238,72,234,38,230,38,234,40,230,117,251,220,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,253,255,187,255,210,226,103,189,37,185,194,172,129,168,128,164,96,164,4,189,70,197,3,185,227,184,3,189,36,193,36,201,100,201,134,209,68,205,68,205,101,205,3,197,3,197,2,193,4,193,226,180,194,176,129,168,96,160,163,172,195,176,
194,176,36,193,35,197,102,197,103,205,129,176,237,225,181,250,149,246,150,246,151,246,117,246,84,242,83,242,181,250,115,242,180,242,47,230,102,209,9,230,73,234,71,234,37,230,40,226,150,255,253,255,254,251,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,220,255,186,255,79,222,102,189,69,197,2,181,194,176,161,168,129,164,161,168,227,176,37,193,70,201,68,197,34,193,67,201,133,217,101,209,101,209,68,209,101,209,
68,205,67,205,35,205,35,197,3,193,227,184,161,172,128,164,96,160,194,172,162,176,4,189,35,197,133,205,101,205,135,209,37,197,69,197,180,250,149,250,118,246,120,250,87,250,20,250,242,237,84,250,52,242,148,246,46,226,174,238,107,234,72,234,
70,238,70,234,41,230,86,247,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,186,255,203,201,36,189,102,201,68,197,3,185,226,176,161,168,129,164,129,164,
161,172,3,185,102,201,102,205,68,201,99,209,132,213,133,213,101,213,101,209,101,209,100,205,68,205,67,205,35,201,36,197,227,188,128,168,129,168,128,160,162,172,228,180,68,193,101,201,101,205,68,201,101,201,200,209,36,197,48,234,149,250,151,254,
151,254,152,254,20,246,240,237,19,246,116,250,245,254,170,209,207,242,73,230,38,230,37,234,71,234,140,234,120,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
122,251,169,197,36,189,68,197,2,193,34,197,3,193,194,176,161,168,130,168,96,164,64,164,195,180,70,205,133,205,101,209,99,209,99,209,133,217,101,213,133,213,133,213,100,209,133,213,100,205,101,205,69,201,226,188,161,172,161,172,162,168,162,172,
4,185,69,193,101,201,101,201,69,201,68,201,134,201,44,226,104,205,48,234,183,254,183,254,150,254,50,246,174,233,17,242,82,246,13,226,143,238,239,246,72,226,38,226,70,238,105,234,207,242,186,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,154,251,235,205,69,193,3,197,67,201,67,205,67,201,3,189,193,180,161,172,162,168,129,164,97,164,194,176,69,197,100,205,133,213,132,209,67,209,132,217,99,213,100,213,
132,213,133,209,133,213,100,209,101,209,100,201,225,184,193,176,193,176,195,176,162,176,227,184,36,189,36,193,68,197,100,201,68,201,199,209,200,213,110,234,47,230,147,242,246,254,23,255,147,250,139,221,14,234,145,242,210,246,207,238,40,222,38,226,
38,234,38,230,106,226,241,238,187,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,218,255,111,222,102,189,2,189,100,205,68,205,100,205,35,201,225,188,193,180,161,172,130,164,
97,164,129,168,162,176,194,184,2,193,101,209,100,209,132,213,68,209,99,213,100,213,132,213,133,209,100,209,132,209,133,213,35,201,225,188,226,184,194,180,227,180,194,180,194,180,3,189,2,189,35,189,36,197,100,201,100,205,68,205,101,205,235,217,
178,242,178,242,145,238,143,238,44,238,176,246,208,246,108,230,8,218,105,234,195,221,38,234,72,230,174,230,53,247,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,208,234,
166,197,100,197,68,201,132,209,100,205,68,201,36,197,226,192,226,188,162,180,161,172,162,168,161,172,161,172,128,172,194,188,68,197,100,205,132,209,100,209,133,213,133,217,165,221,133,213,100,209,100,209,132,209,35,201,2,189,3,189,226,188,227,188,
226,184,193,180,3,185,226,184,3,189,35,189,67,193,101,205,68,205,67,205,4,197,102,201,11,218,109,234,74,226,174,250,107,238,74,230,106,230,7,222,71,230,70,234,70,234,139,238,83,247,218,255,254,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,199,209,100,201,100,201,165,213,100,213,100,209,101,205,36,197,36,193,2,189,226,184,194,184,194,176,161,172,97,172,129,168,3,189,35,189,68,197,68,205,68,205,101,209,
100,213,132,217,133,213,131,209,100,213,100,209,67,201,68,197,36,193,4,193,36,197,3,193,226,180,227,188,226,184,2,185,2,185,67,197,68,205,34,201,134,217,35,197,193,188,166,209,231,221,39,230,72,234,105,238,138,238,104,234,137,242,104,242,
136,242,136,242,205,242,184,255,253,255,254,255,255,255,255,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,134,209,166,209,99,209,101,209,166,217,166,217,100,205,36,197,69,197,3,193,227,188,
4,189,227,184,161,176,161,172,194,172,227,184,226,180,35,193,35,197,36,201,69,209,101,213,100,213,133,213,132,209,133,209,99,205,68,201,101,201,68,197,69,197,101,201,36,197,1,189,225,184,2,181,226,184,2,185,67,193,68,205,100,209,101,213,
69,209,35,201,134,213,230,225,6,234,72,238,170,246,105,238,171,246,202,250,104,246,136,242,137,242,206,242,249,255,253,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
100,209,99,213,164,217,197,221,131,217,131,213,132,213,100,205,35,201,34,201,3,197,3,193,226,188,193,184,194,180,228,188,195,180,227,184,226,184,2,185,100,197,69,201,69,205,103,213,133,209,131,209,131,205,164,209,67,201,100,205,101,209,101,213,
132,205,34,193,224,184,2,189,68,193,226,184,3,193,65,197,34,201,100,209,166,213,101,213,35,205,133,217,164,221,6,234,102,238,136,238,168,234,204,242,237,250,202,242,170,242,203,238,15,235,217,255,254,255,254,255,255,255,255,255,255,255,254,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,131,209,164,217,198,221,165,221,132,213,99,209,100,209,68,205,67,201,3,197,3,197,36,197,36,197,3,189,194,188,227,188,194,184,226,184,226,180,193,180,3,185,
3,193,69,209,135,213,100,209,99,209,164,213,131,209,67,205,101,209,101,209,133,213,198,213,68,205,68,201,2,193,35,197,226,184,1,189,99,201,165,213,133,213,166,213,199,217,132,209,196,221,196,221,39,234,136,242,136,238,136,238,202,242,236,246,
235,250,203,242,203,238,16,235,218,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,164,213,196,217,198,217,166,217,100,209,68,205,68,201,68,201,36,205,35,201,
35,201,36,201,36,197,227,192,227,192,36,193,3,189,226,184,2,189,161,180,160,180,192,184,3,201,101,209,132,213,132,213,132,213,134,213,101,209,102,209,167,213,200,217,200,221,134,205,134,209,2,189,3,189,4,189,68,193,133,201,167,213,166,209,
231,217,230,217,197,213,196,213,5,218,71,234,105,234,171,238,235,242,13,247,236,242,203,246,14,251,14,247,49,243,185,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,196,213,196,213,164,213,197,209,165,209,133,209,68,205,35,205,36,205,35,201,35,201,68,205,35,197,3,193,227,192,36,193,3,193,35,193,36,193,226,188,161,180,128,176,225,188,36,201,133,213,166,217,133,209,134,209,135,205,104,205,70,197,
169,201,201,205,167,205,168,201,102,193,37,189,70,193,103,193,135,197,12,214,10,210,76,222,109,226,9,214,41,218,8,214,75,226,77,222,206,238,172,234,173,234,206,242,173,238,48,251,80,255,83,247,186,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,165,217,164,213,165,213,165,209,134,213,134,213,101,209,36,209,36,205,3,201,35,201,68,205,68,205,35,197,2,197,1,193,226,192,35,197,3,197,3,193,
226,188,128,180,192,184,67,201,99,205,198,213,133,201,225,180,195,176,39,185,130,156,163,160,227,168,38,173,70,173,105,185,104,185,39,181,39,177,138,185,49,210,55,239,88,243,88,243,87,247,245,234,245,234,79,210,12,198,37,173,168,193,12,214,
77,218,142,226,207,234,49,247,84,251,186,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,197,213,197,217,165,213,164,213,133,213,100,213,68,209,68,209,68,209,
35,205,35,201,68,205,68,209,35,201,2,197,2,197,3,201,67,201,35,201,35,193,36,197,193,184,160,184,3,193,2,193,133,205,101,197,160,168,32,152,195,164,97,148,99,152,229,156,5,161,229,156,38,161,230,164,197,160,41,173,241,193,151,206,
151,210,249,218,126,239,158,239,92,231,118,206,109,169,9,157,164,148,97,152,130,156,137,193,167,193,173,226,16,243,52,251,153,251,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,198,217,198,217,164,217,131,213,164,217,132,213,67,213,100,213,69,209,67,209,35,205,68,209,68,205,34,205,36,205,100,209,68,205,68,209,68,205,35,201,68,205,2,197,194,188,193,188,36,197,135,205,133,205,35,189,160,164,163,164,
230,168,230,168,199,160,7,161,7,157,40,165,231,160,7,165,82,198,184,210,120,198,55,186,21,182,212,177,21,186,146,169,81,161,15,153,144,165,233,152,196,156,96,148,195,164,35,181,16,239,240,242,50,247,119,247,222,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,198,217,198,217,132,213,131,213,164,221,165,217,100,209,99,213,68,213,35,205,67,205,101,213,101,213,101,209,100,209,100,209,67,205,67,209,100,209,
100,209,101,209,101,205,36,197,161,184,227,192,101,209,134,213,101,201,102,197,228,176,228,168,196,164,233,168,232,160,7,161,9,165,198,156,40,169,91,231,27,219,88,194,246,177,246,177,213,173,148,169,115,161,115,161,82,161,154,198,108,165,195,156,
36,173,10,206,174,230,16,243,17,247,18,247,53,247,220,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,166,217,133,217,131,217,164,225,198,225,197,221,164,217,100,213,
99,209,99,209,132,213,100,209,100,209,100,209,133,217,166,221,164,217,101,213,100,209,69,205,133,213,101,209,68,209,1,197,192,188,68,205,134,217,100,209,133,209,101,197,102,197,104,189,37,177,227,164,230,160,230,160,197,156,115,206,124,235,218,210,
118,194,211,173,88,190,246,173,246,181,115,165,115,165,115,161,119,198,113,202,136,189,10,214,139,234,238,246,47,251,113,255,50,243,19,239,119,243,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,166,217,164,217,165,217,197,221,230,225,197,221,132,217,99,213,132,213,165,217,133,213,67,213,133,217,165,217,165,217,166,217,164,217,133,213,100,213,133,213,101,213,133,213,100,213,2,201,1,197,100,209,133,217,99,205,165,213,
101,201,167,205,234,209,234,201,201,197,103,181,228,164,195,152,247,222,125,235,119,202,86,186,120,194,54,186,186,202,219,206,121,194,181,173,82,157,144,165,22,227,45,210,174,234,138,234,205,242,14,247,80,251,82,251,51,239,119,239,254,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,198,217,197,217,164,217,197,225,229,225,197,221,164,217,164,213,133,213,197,221,197,221,132,213,132,213,133,217,166,221,165,221,164,217,197,221,
132,213,166,217,133,213,133,213,101,213,34,205,66,209,132,213,132,213,34,201,165,213,132,205,199,213,42,226,75,226,140,222,9,198,135,181,171,185,123,239,250,218,243,181,89,190,153,194,250,206,215,198,216,202,152,202,120,198,180,169,77,161,55,231,
11,206,141,230,172,238,204,242,46,251,80,251,83,251,83,243,119,243,254,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,199,217,166,213,165,217,165,217,229,217,229,217,198,221,
197,217,197,221,197,217,230,221,164,217,131,213,132,217,197,217,165,221,164,217,165,217,165,217,197,221,165,217,165,217,132,213,99,209,100,213,132,209,68,209,67,205,166,217,132,209,165,213,9,230,73,226,205,242,74,218,168,193,112,206,157,243,151,202,
210,169,152,190,27,207,92,223,255,239,190,235,59,219,152,198,54,186,111,165,245,222,234,205,75,226,237,246,172,238,15,247,48,251,82,251,84,247,153,247,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,199,209,167,213,166,217,165,217,229,217,229,217,230,221,230,221,197,221,198,221,165,217,164,213,164,217,164,217,164,213,165,221,196,221,164,221,164,221,229,221,229,221,164,217,165,221,131,213,133,217,133,217,100,209,68,209,
166,213,132,217,164,217,7,234,41,234,172,242,107,226,200,197,112,210,159,247,243,181,245,177,219,198,218,202,255,247,25,215,114,190,191,239,218,214,53,186,79,165,22,231,77,214,42,222,139,242,173,242,15,247,17,247,50,247,85,247,218,255,254,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,168,205,200,209,200,217,231,221,6,226,6,222,7,222,230,221,230,225,229,221,197,221,196,217,196,217,163,217,196,221,197,221,197,221,
164,217,229,221,230,225,6,226,196,221,197,225,163,217,165,217,133,217,68,205,68,209,101,213,165,217,165,221,231,229,73,238,106,234,140,230,10,206,12,202,223,251,177,177,245,177,154,190,220,206,125,227,140,165,41,153,255,251,218,210,55,190,77,165,
54,231,109,222,73,230,106,234,238,246,239,242,82,247,18,243,86,247,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,201,205,202,209,10,222,41,222,40,226,7,226,
7,226,230,221,5,222,5,226,6,226,230,221,164,217,196,221,229,225,5,226,230,225,197,221,229,221,38,230,6,230,230,225,229,225,196,221,165,221,165,217,100,209,99,209,131,209,196,217,196,225,196,225,73,242,138,242,173,234,42,214,136,189,122,239,
85,198,178,169,122,190,155,202,94,227,255,247,191,243,217,214,119,202,179,177,175,181,243,230,142,230,139,238,137,238,205,242,238,242,83,251,20,247,120,251,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,203,205,12,214,43,222,42,230,40,230,72,226,39,230,230,225,6,226,39,230,7,230,229,221,5,222,6,226,7,230,6,226,231,229,230,225,197,225,71,234,38,230,39,230,230,229,197,225,198,225,198,221,198,217,
132,213,196,217,228,221,228,229,163,221,72,238,105,238,173,238,108,226,168,189,211,218,249,218,78,161,22,178,154,198,153,206,29,223,152,210,119,202,211,181,79,165,247,218,242,230,206,234,138,238,170,242,204,242,238,242,115,251,53,247,153,255,222,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,13,206,14,214,78,218,109,226,76,222,74,222,72,226,41,230,39,226,39,226,38,226,5,222,4,222,5,230,38,230,69,230,
4,230,5,230,37,230,39,230,38,234,6,226,39,230,5,226,230,225,197,217,198,221,133,213,164,213,165,221,196,221,163,217,37,230,71,230,203,242,139,234,74,218,202,197,246,222,150,206,79,153,179,169,24,186,247,181,246,185,144,173,76,169,146,210,
207,230,81,247,204,238,204,238,205,246,238,242,15,239,83,243,118,247,220,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,80,214,112,218,111,222,143,230,110,230,
75,226,75,230,75,234,73,230,39,226,39,226,39,226,38,230,38,226,38,230,70,234,38,230,38,230,71,234,70,234,38,234,6,226,38,230,229,225,6,222,197,221,197,217,132,213,99,209,165,217,197,221,228,221,4,226,71,230,236,246,238,246,15,243,
11,210,235,197,147,214,216,214,51,190,13,161,111,169,144,177,240,193,212,226,210,226,240,234,48,247,238,242,13,247,237,246,14,247,49,243,51,243,151,247,220,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,180,226,147,226,145,226,144,226,143,226,109,230,141,230,141,234,140,234,74,230,73,226,106,230,105,234,71,226,71,230,104,238,104,234,71,234,104,238,71,234,71,234,38,230,71,234,38,230,38,226,5,226,
230,221,165,217,67,205,100,213,196,217,197,225,163,217,73,238,106,234,172,238,238,242,205,234,140,222,233,201,203,193,144,214,213,226,179,218,113,214,143,218,176,226,240,234,240,242,15,247,15,247,16,251,239,242,48,247,49,243,50,243,184,255,253,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,23,231,213,226,180,230,178,226,177,230,175,226,175,230,143,230,142,234,141,234,140,234,140,234,107,234,106,234,138,234,
105,238,104,238,104,238,104,238,103,234,104,234,71,234,71,234,70,234,38,230,39,230,40,230,230,225,132,213,98,213,132,213,131,217,164,217,73,234,73,230,171,242,204,242,14,247,238,246,73,218,108,226,141,226,175,230,208,234,142,226,108,222,173,234,
238,242,206,242,238,242,15,247,49,251,239,242,16,247,49,243,18,239,184,255,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,89,235,23,235,246,234,245,234,
212,234,211,230,177,230,176,234,176,234,208,234,175,238,173,234,140,234,172,238,171,238,138,238,138,242,137,238,138,238,104,234,104,238,104,234,135,234,103,238,104,238,70,234,105,238,7,230,198,221,98,209,131,213,66,205,132,213,7,230,73,234,138,238,
237,246,14,251,173,242,40,226,140,238,174,242,206,246,206,238,206,238,173,238,107,230,172,238,141,242,206,246,206,242,240,250,239,246,15,243,49,243,18,235,186,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,

 };


 rom int8 jpeg_human[24700] = {
    
/*('file properties ', 'resolution ', 130, 'x', 95, 'format ', 'ARGB1555', ' total size ', 24700)*/ 

255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,255,255,222,251,222,251,254,255,255,255,222,251,221,251,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,255,255,254,255,221,251,221,251,156,247,156,247,190,251,222,251,222,251,189,247,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,251,221,251,188,247,156,243,156,243,123,239,157,247,189,247,190,247,155,243,222,251,255,255,255,255,255,251,254,255,255,255,255,255,222,251,
222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,222,251,222,255,222,255,221,251,123,239,123,239,156,243,89,235,90,235,123,239,123,239,189,247,123,239,156,243,189,247,221,251,222,251,255,255,255,251,
190,251,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,188,247,188,247,156,243,123,239,156,243,24,227,247,226,24,227,214,218,24,227,248,226,155,239,90,235,247,222,124,239,189,247,221,247,
254,251,156,247,188,243,254,251,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,255,251,156,243,123,243,57,227,90,235,57,231,81,202,115,206,114,206,181,210,181,214,24,231,90,239,82,206,90,235,
190,251,189,247,123,239,90,235,222,251,189,247,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,251,189,247,222,247,188,247,57,235,247,222,114,206,246,222,48,198,74,169,207,189,15,194,50,202,115,210,215,222,
15,194,214,218,189,247,124,239,90,235,57,231,123,239,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,251,255,255,223,255,156,247,58,235,156,243,56,231,81,206,240,193,205,185,240,193,73,169,197,152,107,177,141,181,
174,185,82,198,207,185,49,198,90,239,57,231,90,231,214,218,156,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,188,243,123,239,189,247,123,239,24,227,213,218,83,206,140,181,41,165,8,161,106,169,164,144,
131,144,106,173,107,177,173,185,140,181,107,177,24,231,182,222,214,214,181,214,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,155,239,222,251,156,243,247,226,122,235,122,239,82,202,239,189,205,185,231,156,164,148,
131,144,40,165,34,136,99,144,8,161,8,165,107,173,74,169,82,206,115,210,147,206,82,198,123,239,188,247,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,123,239,24,227,58,235,90,235,115,210,115,206,214,218,15,190,74,169,
230,152,99,140,32,132,131,144,164,148,33,136,164,148,67,140,197,152,198,156,106,173,206,189,240,193,240,189,90,231,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,157,247,156,243,248,226,114,206,147,206,206,189,106,177,
107,177,41,165,132,144,33,136,65,136,33,132,99,144,66,136,67,144,98,140,131,144,165,148,198,156,41,165,141,181,173,181,56,231,156,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,251,189,247,156,243,90,235,214,218,206,185,
173,181,74,169,165,148,99,140,98,140,33,132,65,136,33,132,65,136,98,140,0,132,66,140,66,136,164,148,165,152,230,156,75,169,140,177,181,218,91,239,189,247,190,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,190,251,189,247,123,239,
247,222,206,185,7,161,198,152,164,144,98,140,66,140,66,136,65,136,66,136,65,136,65,136,33,136,66,140,65,136,131,144,99,144,132,148,8,161,107,173,148,210,124,243,222,247,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,251,188,247,
122,235,89,235,24,227,181,214,172,181,99,140,32,132,65,132,65,136,65,136,65,136,33,132,66,136,33,132,65,136,98,140,66,140,99,140,99,144,99,144,165,152,41,165,49,202,156,243,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
222,251,156,243,90,235,247,222,115,206,48,198,48,198,106,173,100,140,65,136,33,132,66,136,66,136,34,136,99,140,98,140,67,140,67,140,66,140,131,144,131,144,98,144,131,144,231,160,206,189,123,239,222,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,190,247,189,243,123,239,23,223,83,202,140,177,41,165,198,152,99,144,33,132,65,140,98,144,99,144,98,140,100,144,99,144,132,152,98,144,99,144,165,148,99,148,98,144,197,152,139,177,56,231,189,247,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,221,251,123,239,89,231,247,222,148,206,207,185,8,161,132,148,99,144,98,140,66,136,98,140,131,144,99,144,132,148,198,156,133,152,131,148,99,144,165,148,165,152,66,140,164,148,41,169,214,222,254,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,189,243,91,235,23,227,180,210,15,190,107,173,231,156,131,144,98,140,99,140,164,148,132,148,165,152,132,148,231,160,197,156,165,148,198,156,164,148,198,156,99,144,132,148,7,161,115,210,
255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,189,247,157,247,123,235,57,231,23,223,148,206,239,189,75,169,8,161,165,152,131,148,132,148,164,148,197,156,198,156,165,152,6,161,198,160,230,156,166,156,198,156,197,152,132,144,
165,152,206,185,189,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,188,247,122,239,23,227,148,210,148,210,16,198,73,169,165,152,197,152,230,156,164,152,197,156,199,160,165,156,198,160,231,164,165,152,230,156,198,156,
7,161,131,148,164,144,40,165,89,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,251,188,247,123,239,90,235,57,231,182,218,49,202,173,181,9,165,198,156,164,148,164,152,230,160,231,160,197,156,166,156,197,152,198,156,198,156,
165,156,198,156,7,161,166,152,132,144,197,152,181,214,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,255,255,255,255,222,247,123,239,24,227,181,214,115,206,15,194,108,177,40,165,198,152,164,148,165,152,198,156,231,160,164,148,165,152,
165,152,198,156,197,152,166,156,230,156,231,164,197,152,165,152,173,185,223,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,251,156,243,156,239,123,239,122,235,90,235,57,231,22,227,115,210,139,177,197,156,132,148,197,156,231,156,
230,160,165,148,165,152,132,152,165,152,198,160,197,156,8,165,198,156,197,152,197,152,90,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,243,247,222,82,202,207,185,173,177,141,177,
107,173,173,177,239,189,116,206,23,223,123,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,223,251,254,255,222,251,255,255,223,255,222,251,254,255,156,243,148,210,107,169,
165,148,165,152,230,160,230,160,163,148,132,148,165,148,230,152,131,148,229,152,231,172,132,148,165,152,15,190,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,247,222,205,185,231,160,165,148,99,144,99,144,132,144,
66,140,130,140,164,152,164,152,165,152,198,156,230,160,7,161,74,169,81,202,90,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,255,255,255,255,
223,255,189,247,114,210,198,156,165,152,198,156,198,156,131,144,132,148,131,148,197,156,164,148,230,160,5,157,165,156,167,156,189,247,255,255,255,255,255,255,255,255,223,255,255,255,255,255,157,247,16,194,131,148,98,140,32,132,65,136,66,136,98,144,
132,144,197,152,40,161,40,169,73,169,41,169,8,169,8,161,40,165,41,169,40,165,198,156,230,156,139,177,246,222,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,124,243,172,181,165,152,230,156,231,160,164,148,132,148,131,148,165,152,132,152,230,156,229,148,231,160,83,214,255,255,255,255,255,255,255,255,255,255,58,239,50,206,164,148,32,128,65,136,0,132,0,132,66,136,
99,148,131,148,132,148,164,148,165,148,165,152,198,152,8,165,73,173,74,173,41,169,230,160,232,164,41,169,231,156,231,160,198,156,74,177,24,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,222,251,50,202,231,156,231,160,197,156,131,148,66,140,164,144,100,148,166,148,231,168,196,156,39,161,255,255,255,255,255,255,190,243,239,185,132,144,0,132,66,136,1,132,65,140,65,140,
66,136,99,144,99,144,98,140,65,140,33,136,32,136,65,140,132,148,230,160,8,169,73,173,7,165,197,156,132,148,164,152,166,152,165,156,231,164,230,156,7,165,82,206,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,255,255,255,255,246,222,72,169,231,160,230,160,165,144,132,152,164,152,99,144,165,156,165,160,229,148,147,210,123,251,82,214,197,152,65,132,33,132,33,132,66,136,65,132,
98,140,65,136,32,132,32,132,0,132,0,132,32,136,65,136,99,144,165,148,231,160,40,169,73,173,41,169,231,160,197,152,198,156,132,148,98,140,66,140,100,144,165,152,231,160,231,160,238,189,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,56,235,139,177,231,160,232,160,133,152,131,148,132,152,164,144,199,152,199,152,37,220,5,216,34,156,32,128,0,136,32,136,66,136,
66,136,33,132,0,132,0,128,0,132,0,132,32,136,66,136,66,140,98,140,132,152,7,161,74,169,106,177,41,173,8,165,230,156,164,152,99,144,132,148,99,140,98,140,66,140,33,136,99,144,198,156,198,152,16,194,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,243,205,185,231,168,198,160,164,152,131,152,163,148,132,152,71,212,3,204,34,144,0,128,0,128,32,132,
0,132,32,136,33,140,0,136,0,132,0,132,32,136,33,132,33,136,66,140,131,148,165,152,8,169,41,169,41,169,7,165,8,161,7,161,197,156,99,144,34,136,99,140,66,136,33,136,66,140,98,140,66,140,99,140,100,144,199,152,214,218,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,190,247,14,194,231,160,231,156,164,140,133,164,37,232,35,188,0,128,34,132,1,136,
33,132,32,132,0,132,0,128,64,128,98,140,65,140,33,136,32,132,32,132,66,136,132,148,230,156,7,161,41,173,73,173,74,173,7,165,230,156,198,156,132,148,99,144,99,136,66,132,65,136,32,132,33,132,66,136,98,136,65,136,33,136,99,140,
165,152,156,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,251,49,198,7,153,164,148,37,212,2,188,0,128,34,132,
32,132,0,128,0,128,0,132,0,128,0,128,33,132,34,136,97,136,97,136,66,132,65,136,131,152,231,164,73,173,75,173,39,165,6,165,230,160,7,165,197,156,131,144,131,148,65,136,97,132,0,132,32,136,32,136,32,128,32,128,33,136,2,140,
67,140,98,140,98,144,74,165,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,254,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,173,201,39,216,3,184,32,128,
65,140,0,132,33,132,32,128,32,132,32,132,32,132,1,132,33,132,1,132,65,140,131,148,198,156,230,156,231,160,7,165,40,165,39,165,231,160,231,160,165,156,165,148,165,152,98,144,65,140,65,140,97,152,65,148,64,148,98,160,97,152,0,132,
0,128,33,128,33,136,33,132,35,132,33,132,244,226,154,255,156,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,44,229,3,196,
65,136,33,132,0,128,0,132,0,128,32,132,33,136,32,128,32,132,65,136,34,136,33,136,131,144,198,160,41,169,41,173,41,169,40,169,7,161,196,156,165,152,99,144,131,148,98,152,131,164,197,172,196,176,5,185,7,197,104,197,103,201,71,205,
105,205,6,181,65,140,32,128,33,132,65,132,0,132,6,185,85,255,19,255,211,246,22,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,187,247,
2,184,32,132,33,132,1,140,0,132,32,128,32,128,32,132,32,132,33,136,33,132,33,136,98,140,165,152,231,160,40,169,105,177,106,177,41,173,8,165,198,156,132,156,131,152,65,152,196,176,5,193,69,205,169,225,234,225,234,229,235,233,235,233,
11,234,45,234,45,234,236,229,72,201,130,168,0,128,131,140,98,152,168,217,50,255,243,254,146,246,235,233,122,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,140,185,32,132,32,136,0,132,0,132,33,136,32,128,65,132,65,136,65,136,66,140,66,140,66,140,165,152,231,160,74,177,73,173,41,173,41,169,8,161,166,156,197,160,6,181,7,193,71,205,201,221,11,234,77,242,142,242,175,246,176,246,
209,246,176,246,176,246,209,242,209,242,145,246,111,238,12,226,130,160,0,128,99,152,103,201,208,254,243,246,179,242,144,246,44,238,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,48,198,33,136,33,132,0,128,0,132,32,128,33,136,0,132,0,132,33,136,66,140,66,140,99,148,231,160,40,169,41,169,73,173,74,173,41,169,199,152,100,148,163,164,38,193,202,225,44,242,110,250,144,250,209,250,243,250,242,246,
19,251,20,251,20,255,244,246,21,255,245,250,244,246,244,246,210,242,178,246,44,226,131,152,2,132,164,168,45,238,242,250,113,242,211,250,234,237,188,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,148,214,33,140,66,136,33,132,1,128,0,132,32,132,32,128,0,136,0,132,33,136,98,140,164,152,230,164,41,169,73,173,74,177,72,169,7,169,230,164,197,168,6,185,104,209,235,233,76,246,208,246,242,254,20,255,85,255,
86,255,53,255,53,255,19,255,20,251,53,255,243,250,212,250,20,255,20,251,20,247,245,254,209,250,203,205,64,140,65,140,137,205,211,254,177,250,144,242,110,246,244,250,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,124,243,66,136,0,132,33,128,1,132,0,128,1,136,0,128,33,132,32,132,33,136,98,140,165,152,7,165,40,169,41,173,41,169,40,169,231,160,197,168,39,185,169,217,11,238,76,242,142,250,19,255,53,255,86,255,
85,255,53,255,52,255,52,255,51,255,18,255,19,251,242,250,243,250,243,250,19,251,20,255,244,254,245,250,245,250,178,254,70,185,1,132,166,156,81,226,111,234,76,238,113,238,111,246,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,106,173,32,132,0,128,0,128,0,132,32,132,32,132,0,128,0,132,34,140,98,136,196,148,40,169,74,173,106,173,7,173,7,173,230,164,227,168,36,189,10,230,44,242,207,250,19,255,85,255,54,255,
86,255,85,255,86,255,84,255,243,250,242,250,19,255,19,255,242,254,18,255,19,255,19,255,243,250,21,255,53,255,244,250,22,247,242,250,111,242,197,172,1,128,107,185,176,242,233,237,111,234,43,242,254,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,213,218,33,136,0,128,0,128,33,128,0,132,33,136,1,132,0,132,33,136,99,140,228,152,231,160,73,173,106,177,8,169,231,160,164,156,229,184,136,217,235,229,77,242,242,254,117,255,85,251,
151,251,151,255,85,255,19,251,143,234,13,226,77,230,242,250,20,255,209,250,242,250,242,250,242,250,18,255,19,251,243,250,20,251,244,250,20,247,21,251,19,255,236,217,66,140,99,144,80,234,78,242,13,242,111,246,223,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,74,173,0,128,0,128,33,132,32,132,0,132,34,140,65,140,65,136,131,144,197,156,40,169,138,181,40,169,73,177,231,156,131,152,6,181,137,217,45,246,143,250,19,255,85,255,
87,251,185,255,119,255,242,242,234,217,169,213,202,217,143,238,243,254,243,254,209,250,18,255,242,250,242,254,242,250,19,251,19,251,20,251,20,251,21,251,244,250,245,246,21,251,244,250,71,181,32,132,40,181,245,254,146,246,110,242,222,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,89,235,66,140,65,136,32,132,32,132,32,136,0,132,33,136,98,140,165,152,230,160,7,165,74,173,106,181,8,169,199,160,164,156,197,176,202,225,77,242,240,254,52,255,
118,255,185,255,153,255,211,238,169,209,70,205,168,213,175,238,85,255,19,255,242,250,242,254,241,250,242,250,243,254,18,255,19,255,19,251,19,251,20,251,20,251,21,255,54,255,19,251,22,251,55,251,145,234,131,156,67,140,80,226,245,246,142,250,
120,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,239,189,33,132,0,132,0,132,32,132,66,136,33,140,33,136,131,144,40,165,106,173,73,169,73,173,8,169,230,160,132,152,7,193,202,225,75,238,142,242,
243,246,119,255,153,255,119,255,236,217,70,197,70,201,110,234,51,255,52,255,19,255,18,251,19,255,51,255,18,251,51,255,242,254,243,254,19,255,19,255,19,255,52,255,53,255,52,255,53,255,243,250,21,251,55,251,87,255,14,210,34,136,230,172,
145,246,241,246,22,247,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,198,152,33,132,0,128,0,132,32,132,65,132,65,140,132,148,231,160,106,173,139,181,106,181,8,169,197,156,165,152,6,185,202,229,77,242,
143,246,241,250,152,255,153,255,86,251,170,209,4,193,135,209,176,242,53,255,19,255,20,255,52,251,19,251,51,251,19,251,18,251,18,251,242,254,209,250,241,250,52,255,52,255,53,255,85,255,52,255,20,255,243,250,20,251,22,255,88,255,122,255,
8,177,0,136,203,217,176,250,245,254,223,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,57,231,65,136,0,132,33,132,0,132,33,132,65,136,131,148,7,165,74,177,106,177,106,177,74,177,230,164,132,152,39,185,234,225,
10,238,175,250,19,255,119,255,184,255,152,255,203,205,4,189,169,213,209,250,52,255,20,255,52,251,20,255,52,255,20,251,51,255,84,255,51,255,18,251,241,254,143,242,208,242,85,255,85,255,85,255,85,255,52,251,53,255,20,255,20,251,20,255,
22,251,154,255,213,242,99,144,165,160,79,238,19,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,147,206,33,132,0,128,33,136,0,132,65,132,131,144,7,161,106,177,107,177,73,177,41,169,231,160,164,148,6,185,
235,221,44,238,108,246,18,255,119,255,154,255,52,255,169,209,37,189,135,205,241,242,51,255,51,255,20,251,20,255,53,255,118,255,85,255,19,251,19,251,20,255,19,251,241,254,76,238,175,242,52,255,85,255,85,251,53,251,52,251,20,255,52,251,
19,251,243,250,21,251,56,251,188,255,207,205,65,136,171,201,88,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,75,173,0,128,65,136,32,132,0,132,66,132,164,152,72,173,173,185,139,177,73,173,7,169,134,152,
3,181,169,217,11,242,109,250,242,250,85,251,152,255,119,255,202,217,4,193,201,213,242,250,52,255,19,255,52,255,52,255,51,247,53,255,85,255,85,251,84,255,19,255,19,255,243,254,240,254,42,234,109,238,117,255,52,247,85,255,53,255,52,255,
243,250,20,251,19,255,18,251,242,250,21,251,55,255,188,255,165,156,74,173,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,243,33,132,66,136,66,140,32,132,99,144,197,152,7,165,41,173,140,185,41,169,41,165,
165,152,197,172,169,217,43,238,109,246,241,250,84,255,152,255,119,255,236,217,135,205,12,222,177,242,51,255,51,255,19,251,19,255,20,251,20,251,85,255,53,251,85,255,52,255,19,251,19,255,242,254,174,250,233,221,51,255,85,255,85,255,86,255,
53,255,21,255,19,251,243,254,20,255,242,250,242,250,244,250,55,255,156,255,16,202,67,140,188,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,147,210,0,128,66,140,98,140,99,144,198,156,7,165,74,177,75,177,74,173,
72,165,165,148,197,164,137,217,12,242,44,238,143,246,85,255,118,251,151,255,20,247,137,209,11,222,241,246,52,255,19,255,19,255,19,255,51,255,20,251,54,255,86,255,52,251,52,255,52,255,20,251,18,251,240,254,169,217,109,230,118,255,86,255,
86,255,85,255,85,251,53,251,19,251,19,255,19,255,242,250,242,250,243,250,22,251,123,255,89,243,99,144,156,239,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,73,169,32,132,66,136,98,140,198,160,74,173,106,181,41,173,
73,173,8,165,231,156,196,164,169,209,10,230,109,246,175,246,20,255,120,255,152,255,87,255,85,255,242,250,242,250,242,254,242,254,19,251,51,255,19,255,20,255,52,255,53,251,52,251,53,255,53,255,52,251,19,251,50,255,75,234,234,213,53,251,
118,255,86,255,86,251,53,251,54,255,53,255,52,251,19,255,19,255,18,251,210,254,211,254,245,250,89,255,156,255,198,156,123,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,251,132,144,65,136,98,140,230,160,41,169,139,177,
139,181,73,173,231,160,230,152,164,156,136,209,234,237,44,234,76,238,242,250,86,255,119,255,120,255,87,255,53,251,84,255,51,255,19,251,19,251,18,251,19,251,20,255,20,255,20,251,51,251,52,255,86,255,86,255,52,255,19,255,175,246,201,221,
53,251,151,255,87,255,119,251,119,251,87,255,54,255,53,251,52,251,20,255,20,255,241,250,241,250,211,254,244,250,55,251,188,255,73,173,124,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,24,231,32,132,66,140,164,152,106,173,
107,177,41,169,40,169,7,165,164,148,130,148,71,201,202,229,12,238,109,242,209,250,84,255,118,255,119,251,119,255,86,255,52,255,52,255,18,251,19,251,20,255,242,250,243,250,19,255,242,250,19,255,19,251,53,255,85,255,18,247,51,255,208,250,
201,213,242,246,185,255,87,255,152,255,120,255,119,255,152,255,86,255,85,251,51,251,19,255,19,255,242,250,241,254,209,254,210,250,21,251,221,255,172,185,156,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,213,218,65,136,98,140,
73,173,139,177,74,177,231,160,198,156,132,152,65,148,39,189,169,229,44,242,109,238,175,250,52,255,86,255,119,255,118,255,86,255,52,255,85,255,19,251,51,255,50,255,19,251,243,250,20,255,18,255,209,246,18,255,18,255,18,255,51,255,18,255,
142,238,11,222,19,247,119,255,119,255,119,255,120,255,152,255,120,255,152,255,85,255,85,255,19,255,19,255,19,255,242,246,241,250,177,250,178,246,20,251,156,255,139,185,25,231,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,181,218,
132,148,231,156,139,177,173,189,8,169,163,152,100,144,66,144,196,172,169,221,234,229,77,238,142,242,242,250,118,255,86,255,119,255,86,255,52,251,84,255,53,255,53,255,51,251,52,251,51,251,20,255,52,255,241,250,241,250,208,250,242,254,241,254,
208,254,75,242,44,230,85,247,151,255,118,255,153,255,120,255,152,255,152,255,152,255,86,251,86,255,85,255,51,255,19,255,242,250,241,246,241,250,177,250,177,250,244,250,123,255,173,189,189,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,114,206,7,169,107,181,139,185,74,177,231,160,99,148,0,128,97,152,137,213,11,238,44,234,143,250,210,254,85,251,84,251,149,255,118,255,86,255,86,251,84,251,52,251,20,251,20,255,52,251,52,251,242,250,19,251,243,250,18,251,241,250,
174,242,176,250,176,246,243,246,118,255,119,255,119,255,120,255,152,255,121,255,153,255,152,255,152,255,119,255,86,255,85,255,19,255,19,255,18,255,209,250,176,254,177,250,209,250,210,250,87,255,237,185,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,115,206,107,177,172,181,106,177,41,173,164,152,99,144,64,140,38,185,235,225,12,238,110,242,208,250,20,255,86,251,117,255,118,255,53,251,53,255,52,255,52,255,19,255,20,255,19,251,52,255,51,255,19,251,19,251,19,251,
19,255,242,254,18,247,85,255,119,251,151,255,150,255,85,255,85,255,118,251,152,255,152,255,153,255,153,255,152,255,119,255,117,255,53,251,52,255,242,250,242,250,176,246,144,246,111,246,144,246,209,250,53,255,172,181,255,255,255,255,222,247,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,213,214,173,185,140,185,73,169,198,156,98,136,33,136,163,168,137,213,45,238,109,238,175,246,242,254,85,255,151,255,152,255,78,226,136,205,143,238,19,255,241,250,19,255,20,255,20,251,51,255,19,255,19,251,
19,251,51,255,20,255,20,255,85,255,118,255,150,255,119,251,118,255,119,255,118,255,184,251,153,255,184,255,153,255,152,255,152,255,119,255,85,255,52,251,51,255,242,250,241,250,208,250,175,246,176,246,208,250,209,254,178,242,106,177,58,235,90,239,
222,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,24,227,139,185,73,177,231,160,132,144,65,132,33,136,38,197,202,225,44,242,175,246,208,246,51,255,85,251,184,255,177,234,37,193,136,209,144,246,242,254,18,251,242,250,19,255,52,255,19,255,
51,255,19,251,19,255,20,255,52,255,52,255,53,255,86,255,118,255,118,255,87,255,151,255,152,255,153,255,185,255,152,255,152,255,152,255,119,255,119,255,85,251,52,255,243,250,242,246,210,254,177,250,208,246,240,250,176,250,177,254,245,246,156,251,
148,206,57,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,239,139,181,198,156,163,144,97,136,32,132,98,152,104,205,234,233,76,238,175,242,19,251,85,255,118,255,87,255,203,209,70,193,77,234,210,254,241,254,242,250,19,255,241,250,
242,254,19,255,19,255,19,255,19,255,19,251,19,251,84,255,119,251,119,255,119,255,150,255,119,255,118,255,151,255,151,255,184,255,185,255,152,255,152,251,151,255,86,255,84,255,20,251,19,251,242,250,177,250,176,250,175,246,176,242,110,242,143,246,
246,242,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,156,243,173,185,99,148,33,132,32,132,32,132,196,172,170,217,10,234,109,242,208,246,53,255,85,255,119,255,112,234,228,180,104,201,18,255,242,254,209,250,242,250,
241,246,241,254,241,254,242,250,19,255,19,255,19,251,19,247,20,251,52,255,53,255,52,251,85,251,118,255,151,255,152,255,152,255,184,255,152,255,153,255,151,255,151,255,86,255,85,255,19,255,19,251,242,250,177,246,176,246,176,250,175,246,142,242,
143,242,144,250,122,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,251,15,194,99,144,0,128,32,132,64,144,6,193,202,225,44,234,142,246,19,255,54,255,118,255,53,255,104,197,227,184,77,230,210,254,241,250,
18,255,19,251,243,254,209,250,209,250,210,250,19,255,20,255,52,251,19,251,52,251,85,255,241,250,207,250,242,254,117,255,151,255,120,255,153,255,185,251,153,255,120,255,120,255,118,255,85,255,53,255,19,255,242,254,210,250,208,246,175,246,176,250,
143,246,143,242,144,246,45,234,123,243,124,235,157,243,254,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,48,202,132,152,32,132,65,136,97,152,6,201,203,225,109,238,142,246,53,255,86,251,151,255,176,230,194,176,170,209,244,254,
210,250,18,255,19,255,242,250,242,250,208,254,177,250,209,250,19,255,52,255,52,255,52,251,52,251,85,255,118,255,209,254,143,250,19,255,119,255,152,255,152,255,120,255,153,255,152,255,119,255,86,255,86,255,52,255,19,255,18,255,209,250,176,246,
175,242,176,246,143,242,144,246,111,242,70,205,164,140,233,156,75,173,205,181,149,202,248,222,124,235,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,222,251,221,247,190,251,254,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,221,251,221,251,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,214,226,164,152,66,140,0,128,98,152,103,213,10,222,109,234,209,250,244,254,118,255,53,255,137,205,39,189,
142,234,19,251,18,251,20,251,19,251,242,250,18,255,241,254,241,246,110,246,242,254,116,255,51,251,52,255,119,255,183,251,84,251,174,246,202,237,241,246,151,255,152,255,153,255,152,255,86,251,118,255,53,255,52,255,51,255,19,255,242,254,242,250,
209,242,142,242,209,246,143,246,110,242,110,242,43,242,65,148,64,136,36,181,69,193,169,201,235,213,15,198,243,177,17,186,214,214,222,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,223,243,
158,235,93,219,28,207,251,202,55,215,246,198,187,186,93,227,254,251,255,255,255,255,255,255,255,255,255,255,155,243,56,243,254,251,254,255,254,255,253,251,121,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,157,247,197,156,99,144,33,128,65,148,71,205,10,222,109,238,209,246,53,255,119,255,144,230,
227,184,44,226,19,255,242,250,19,255,19,251,85,255,51,251,19,251,19,251,240,250,175,246,19,255,84,255,52,255,19,255,86,255,86,255,83,247,45,254,10,242,51,255,151,255,153,255,184,255,118,255,53,251,86,255,52,255,51,251,19,255,18,255,
209,250,241,250,143,246,143,242,144,242,78,242,111,238,78,242,104,209,0,128,162,156,4,181,133,185,167,197,235,213,15,202,242,173,210,177,144,161,176,169,84,190,26,223,190,247,255,255,255,255,255,255,255,255,255,251,126,231,93,223,60,215,28,207,
218,190,186,178,184,170,186,178,122,182,212,222,77,255,45,255,149,194,152,178,251,198,222,251,255,255,255,255,157,231,185,255,80,247,10,243,84,247,255,255,254,255,253,255,253,255,119,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,172,185,131,148,35,132,0,132,39,189,10,234,175,250,241,250,52,255,
87,255,205,209,70,193,17,255,19,255,20,255,20,251,52,255,53,255,51,255,52,255,52,251,177,250,142,242,84,255,118,255,85,255,19,251,242,254,242,254,109,242,11,242,175,254,117,255,185,255,185,255,151,255,52,255,20,251,52,255,20,255,243,250,
242,250,241,250,176,246,208,246,176,246,145,246,143,246,78,242,45,238,236,225,66,156,32,136,196,168,35,177,100,201,134,193,140,169,209,173,243,181,175,157,177,165,78,153,142,157,176,173,209,173,116,186,249,202,60,215,59,219,217,198,120,170,89,170,
89,158,154,170,122,174,217,174,153,178,218,186,121,166,46,247,78,251,77,255,44,251,215,194,184,186,26,207,125,235,252,198,180,202,43,255,76,255,140,255,76,255,182,255,254,255,255,255,252,255,155,247,156,247,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,246,222,164,152,34,132,0,128,65,144,233,221,111,246,
243,250,53,251,87,255,138,209,12,226,50,255,244,254,19,255,53,255,53,255,20,251,85,255,20,255,51,255,143,246,176,242,150,255,118,255,85,255,85,255,209,246,76,238,43,242,143,246,51,255,151,255,153,255,184,255,85,255,208,250,19,251,51,251,
19,255,243,250,209,246,209,246,176,246,176,246,176,246,176,250,175,242,110,238,202,233,38,197,0,136,65,144,3,177,39,173,72,161,76,149,113,157,210,169,241,173,110,157,110,157,44,145,110,153,110,157,144,157,20,162,54,166,54,162,86,162,88,170,
82,178,172,234,179,206,121,166,120,170,184,166,184,174,155,170,213,198,109,255,15,231,175,222,14,247,179,206,154,178,185,178,187,178,220,170,144,210,42,255,140,255,109,251,138,255,109,247,254,255,255,255,253,255,255,255,23,235,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,74,173,34,136,0,128,0,128,
227,172,144,242,210,250,51,251,20,251,169,217,177,246,18,255,20,255,52,255,86,255,52,251,53,251,84,255,53,255,210,250,235,221,52,255,151,255,118,255,86,255,117,255,84,251,241,250,242,250,53,255,118,255,152,255,152,255,185,251,177,254,111,246,
242,250,19,255,243,254,242,250,209,250,209,246,176,242,176,246,143,246,144,242,111,234,44,238,136,221,32,152,32,128,100,140,233,144,232,140,10,145,78,157,179,161,178,165,208,169,109,153,110,157,77,149,77,149,110,149,143,153,209,153,21,158,86,166,
54,166,55,154,77,194,232,254,75,251,175,218,120,162,183,182,186,174,185,174,13,239,44,243,109,255,44,251,14,239,184,170,188,170,184,162,188,170,187,166,204,230,108,255,108,255,109,255,77,251,107,255,117,251,255,255,254,251,254,255,253,255,122,243,
255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,147,214,100,144,
32,128,0,128,0,132,137,201,243,254,53,255,211,246,45,226,243,250,19,255,19,251,52,255,52,255,51,251,52,255,84,255,242,254,12,230,177,242,151,255,86,255,118,255,118,255,151,255,150,255,117,255,182,255,119,255,185,255,185,255,185,255,21,255,
145,250,208,250,176,250,242,250,18,255,210,250,210,250,177,246,176,246,144,250,144,250,143,242,45,242,234,233,196,176,1,128,133,136,200,144,232,144,233,140,144,157,21,162,54,166,53,178,243,177,45,157,143,157,45,149,77,149,78,149,110,153,210,149,
20,154,21,162,118,158,212,157,45,190,11,247,44,255,174,234,151,182,154,170,153,178,13,251,141,251,44,251,11,239,239,222,119,174,155,166,186,166,153,170,155,170,119,170,75,251,137,255,108,255,108,255,75,255,72,255,47,243,255,255,255,255,253,255,
254,251,187,247,124,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,
223,255,231,160,33,128,0,128,33,128,0,136,47,218,54,255,20,251,210,246,211,250,242,250,244,250,19,251,242,250,242,254,19,255,50,255,77,234,12,230,85,255,86,255,118,251,120,255,87,255,151,255,151,255,152,255,119,255,151,255,153,255,184,255,
119,255,79,250,242,254,175,250,144,246,209,250,209,250,209,246,209,250,176,250,175,246,176,246,144,246,110,238,12,246,37,201,32,144,166,144,10,145,10,149,11,149,209,153,85,162,118,166,54,170,53,166,210,161,78,157,109,157,44,145,78,153,77,149,
110,149,242,153,53,158,86,158,22,158,108,157,171,230,11,255,172,222,182,198,188,174,122,174,155,178,45,247,11,243,152,174,154,170,120,158,183,166,152,170,154,166,152,170,121,158,179,190,73,255,75,255,73,255,107,251,74,255,108,251,215,255,255,255,
254,255,253,251,221,255,253,255,89,235,221,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,147,214,32,132,0,132,32,132,66,128,66,144,81,230,53,255,20,255,20,255,210,246,243,250,20,255,20,255,19,255,18,255,43,230,234,217,83,255,54,251,119,255,119,255,120,255,120,255,152,255,152,255,119,251,184,255,151,255,
151,255,118,251,177,250,175,242,17,251,143,246,111,242,177,250,241,250,209,250,176,246,176,246,144,246,144,246,141,238,44,238,105,213,32,152,161,160,5,173,201,132,76,145,20,162,153,162,87,158,119,166,119,166,54,170,176,165,75,153,77,153,11,141,
109,149,45,149,79,149,243,153,244,149,22,158,209,165,106,165,201,246,171,238,83,182,155,162,218,166,184,166,184,166,120,170,88,166,186,154,186,170,152,166,120,166,121,158,184,170,153,158,120,162,112,202,41,255,10,247,46,251,12,247,46,251,250,255,
254,255,255,255,255,255,254,255,254,255,254,255,254,255,121,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,8,161,34,136,33,140,0,128,33,128,98,144,48,218,22,255,243,250,243,246,241,246,210,254,144,250,111,250,234,229,201,217,20,251,54,255,118,255,118,251,152,255,120,255,153,255,152,255,152,255,151,255,
119,255,118,251,117,255,176,250,175,246,242,254,176,246,111,246,207,242,240,242,208,246,176,246,176,242,175,250,112,250,144,250,110,234,235,225,130,172,64,148,37,173,231,156,111,145,86,162,153,158,118,162,120,166,87,166,87,162,54,166,175,161,78,149,
42,145,43,149,13,145,77,149,143,145,210,149,244,153,53,162,110,149,165,177,170,242,142,202,155,158,185,174,187,166,217,166,153,166,152,166,185,166,152,166,152,166,152,162,151,162,120,162,118,158,119,162,89,158,107,214,170,246,117,243,123,243,213,226,
211,214,253,255,254,255,255,255,254,255,255,255,253,255,254,255,221,255,187,247,123,243,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,235,132,144,65,144,65,136,65,140,66,136,64,140,237,201,22,255,20,255,18,247,209,246,144,246,235,221,76,222,51,255,53,255,86,251,118,255,119,255,119,255,152,255,153,255,120,255,
120,255,152,255,119,255,85,255,19,255,110,242,45,238,144,246,176,246,177,250,175,254,176,246,177,246,177,250,143,246,143,246,143,246,143,242,45,242,195,192,32,144,229,148,235,140,210,153,120,162,153,162,120,162,184,170,152,166,120,166,87,162,53,162,
208,165,77,153,10,149,13,149,76,149,77,145,176,145,210,157,53,154,52,162,234,160,229,209,200,250,85,174,155,154,186,170,186,166,186,166,153,166,153,166,152,166,152,166,120,162,120,162,119,162,87,162,86,158,118,158,85,158,73,210,242,234,154,247,
58,235,147,214,21,227,254,255,253,255,254,255,254,255,255,255,253,255,254,255,253,255,221,255,89,235,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,247,222,239,193,197,156,0,132,131,140,131,136,64,136,73,185,245,254,20,255,19,251,243,250,51,255,52,251,53,255,53,255,52,251,118,255,118,255,152,255,152,255,
120,255,152,255,120,255,151,255,86,255,53,255,243,254,176,250,143,242,144,250,144,246,210,246,243,250,210,250,176,250,177,254,143,250,111,242,175,246,45,242,70,209,66,144,199,136,141,145,53,158,154,166,154,162,152,162,120,166,153,170,152,158,120,166,
87,166,20,162,143,161,75,149,11,141,12,149,108,145,110,141,210,145,210,157,86,150,209,149,229,148,197,217,14,194,140,226,88,166,155,158,153,166,153,170,120,162,152,166,120,166,152,166,151,166,120,162,87,162,87,162,55,166,119,162,16,162,6,210,
55,231,89,231,149,218,79,202,186,247,253,255,221,251,254,255,254,255,255,255,254,255,254,255,253,255,220,255,188,247,89,235,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,56,231,130,144,164,148,99,140,164,148,33,136,40,173,212,242,54,255,52,255,51,251,21,255,53,251,85,255,52,255,86,255,118,255,
119,255,152,255,151,255,120,255,151,255,150,255,86,255,53,255,20,255,52,255,52,251,210,250,177,246,177,246,209,246,178,250,144,246,176,250,176,246,142,242,44,238,135,221,99,144,201,140,79,149,52,158,153,162,120,166,152,162,119,166,152,162,119,162,
119,162,86,162,54,162,243,165,44,157,11,141,42,145,76,153,75,137,175,153,210,141,244,157,112,194,109,149,168,136,78,153,19,158,43,247,43,255,207,218,122,162,120,166,120,162,120,166,120,166,119,166,120,162,87,162,87,166,87,162,54,166,154,162,
172,169,197,213,55,231,246,230,82,214,146,214,188,251,253,255,253,255,254,255,220,251,220,255,254,255,254,255,254,255,220,255,221,255,56,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,215,218,173,181,231,160,197,156,198,152,67,132,73,177,179,238,86,255,52,251,52,251,20,255,53,251,86,255,
117,255,86,255,119,255,119,255,151,255,119,255,118,255,118,255,86,255,52,251,52,251,85,255,52,251,242,250,177,250,177,250,176,246,144,242,111,242,175,250,108,242,44,242,136,213,32,144,134,132,109,149,243,149,120,166,120,166,151,162,152,162,119,162,
119,162,87,166,88,170,86,162,54,154,175,169,6,165,233,140,42,153,13,149,41,149,78,141,44,186,205,234,140,222,10,137,168,132,111,133,21,158,204,238,9,255,107,255,144,206,120,158,121,162,120,162,120,162,120,166,119,162,120,162,87,166,86,162,
87,158,121,158,72,169,70,189,13,198,80,210,236,197,211,226,122,243,220,255,221,255,220,251,88,239,54,231,88,235,155,247,253,255,188,251,220,255,123,247,122,243,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,59,235,107,173,164,148,205,185,198,152,7,157,214,230,245,242,85,255,85,251,52,251,
86,255,86,251,86,255,86,255,119,255,119,255,119,255,118,255,117,255,86,255,86,251,85,255,52,255,19,255,242,246,177,250,208,246,178,250,176,246,175,246,109,242,109,242,11,230,6,209,99,176,65,140,34,128,9,137,87,158,122,166,119,166,120,162,
121,162,119,162,119,166,118,166,88,166,120,166,20,154,74,161,2,173,9,149,11,137,11,145,11,141,42,157,135,242,204,234,77,206,166,136,166,140,143,149,52,162,173,234,11,251,11,251,13,235,87,158,120,162,120,162,120,166,120,166,120,166,119,162,
87,162,87,162,88,158,88,162,130,140,0,136,32,136,99,144,237,193,179,226,188,247,253,255,254,255,253,255,220,255,220,255,154,247,22,231,56,239,221,255,187,247,121,239,246,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,82,198,131,144,214,218,173,185,100,148,122,231,253,255,87,255,
53,255,52,251,53,251,54,255,53,255,86,255,87,255,119,255,87,255,86,255,85,255,85,255,53,255,85,255,51,255,242,254,177,246,176,246,176,246,175,242,141,250,109,242,235,229,103,197,131,172,163,188,72,209,200,213,199,160,99,132,41,145,85,162,
153,162,88,166,119,166,118,166,119,166,118,162,120,162,53,166,141,161,4,169,3,173,8,153,10,137,10,145,234,140,12,141,73,210,11,243,170,189,103,128,75,141,19,146,22,162,11,251,12,243,205,222,235,242,151,170,120,166,121,162,152,166,152,162,
152,166,119,166,119,166,87,162,121,158,20,166,65,140,0,136,33,132,73,173,146,214,154,251,254,255,221,251,254,255,253,255,253,255,254,255,254,255,252,251,89,239,23,235,121,247,121,243,213,222,255,255,255,255,255,251,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,247,222,231,160,57,231,248,226,133,148,214,214,
255,255,56,247,22,255,20,255,52,255,21,255,54,255,86,255,87,255,119,255,118,255,118,255,85,255,84,255,20,255,20,255,242,250,176,246,111,242,175,246,110,242,77,238,201,221,71,205,165,184,131,176,228,196,135,217,11,230,142,238,78,242,73,173,
199,132,9,145,241,157,152,166,153,162,154,166,121,162,88,162,120,162,178,161,5,169,1,181,37,173,230,148,234,144,10,141,200,140,202,140,106,222,42,255,232,148,234,132,212,145,211,149,109,165,74,255,207,214,175,222,236,234,119,162,152,162,153,162,
153,162,152,166,152,162,119,162,119,162,87,166,121,170,175,157,0,136,0,140,72,169,145,218,154,243,255,255,255,255,254,255,255,255,254,255,254,255,253,255,253,255,254,255,254,255,121,243,22,231,55,235,246,230,222,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,24,227,8,161,57,231,222,251,
66,144,181,210,255,251,255,255,245,246,20,255,52,255,84,255,84,247,52,251,52,255,52,255,85,255,85,251,52,251,53,255,18,251,210,246,176,246,178,254,144,246,76,234,201,225,6,209,193,184,194,192,5,201,105,213,136,221,234,229,111,238,143,238,
206,246,175,242,204,197,232,148,168,144,110,157,152,166,185,166,119,162,88,162,120,170,11,145,165,144,231,156,8,165,167,144,198,140,202,136,168,128,105,185,74,255,46,186,139,132,111,145,77,202,5,165,171,181,44,243,12,251,10,243,207,222,123,158,
152,166,184,162,119,158,151,162,154,166,151,162,152,162,153,162,150,158,139,157,0,144,39,173,213,226,22,227,155,247,252,255,252,251,253,255,253,255,254,255,253,255,253,255,255,255,254,255,253,255,254,255,89,243,179,226,179,218,122,243,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,123,243,8,161,
90,235,255,255,230,152,115,206,255,255,255,255,156,251,22,251,21,255,20,255,244,250,52,255,52,255,19,255,18,255,241,250,241,250,210,250,209,246,208,246,144,246,109,242,234,221,70,201,228,192,196,192,103,213,138,221,235,229,11,234,44,238,76,238,
77,238,177,246,144,246,78,242,203,209,167,148,201,144,7,149,75,149,86,158,152,166,119,166,243,161,167,136,168,140,235,140,234,144,169,132,167,140,198,128,200,144,232,250,17,223,114,141,234,132,16,186,7,222,33,144,108,214,44,255,107,255,43,251,
150,166,154,158,151,158,122,166,121,162,121,166,120,166,152,166,120,166,119,158,121,154,73,157,67,189,18,235,186,251,87,231,22,231,121,243,253,255,254,255,220,251,121,239,187,247,254,255,255,255,255,255,254,255,254,255,254,255,246,222,81,206,122,235,
255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
188,243,41,165,123,243,255,255,73,169,180,214,255,255,255,255,255,255,123,251,244,246,243,250,243,254,242,254,210,250,241,246,242,246,242,250,241,250,209,246,176,250,143,242,12,230,135,217,37,205,230,200,104,217,109,238,207,242,241,246,241,250,240,254,
209,246,143,242,78,234,236,213,5,181,98,152,0,132,0,128,97,128,231,148,9,153,232,140,243,153,120,162,174,165,132,136,43,145,77,145,12,141,232,144,199,144,235,140,206,149,208,206,85,166,177,153,143,149,51,174,163,160,199,140,12,255,12,255,
207,218,149,174,153,166,119,170,185,162,185,170,152,170,185,162,120,166,121,166,153,162,119,166,121,158,105,177,103,230,153,251,91,239,25,231,244,226,122,243,254,255,221,251,155,247,220,255,121,239,187,247,254,255,254,255,255,255,254,255,220,251,155,243,
147,210,221,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,189,247,75,169,189,247,255,255,108,181,56,231,255,255,255,255,255,255,255,255,154,251,212,250,211,254,211,250,179,250,146,250,178,246,210,250,177,246,143,246,45,238,169,221,38,209,136,217,170,221,78,238,19,255,50,255,83,255,85,255,
53,255,52,255,51,255,176,246,72,209,32,140,36,132,68,128,134,128,10,141,132,128,35,132,165,140,7,149,232,144,178,153,106,173,229,160,44,141,110,141,142,149,75,145,110,145,244,157,152,158,87,154,21,154,177,157,177,149,176,153,35,132,242,153,
236,234,115,186,123,154,154,162,87,162,120,162,154,166,152,166,151,166,186,166,186,166,185,170,184,162,120,166,88,162,231,197,167,242,89,243,122,243,22,235,212,226,221,251,255,255,221,255,221,255,48,202,121,239,56,235,252,255,254,255,255,255,23,251,
173,237,240,249,181,234,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,156,243,173,181,222,251,255,255,107,177,90,239,255,255,255,255,255,255,255,255,255,255,189,255,211,250,178,246,210,242,243,250,210,242,177,246,112,238,237,225,70,205,136,217,11,234,78,234,51,255,115,255,18,255,144,242,
143,230,204,217,14,218,14,218,169,209,197,176,166,140,110,141,244,145,18,150,243,149,244,149,143,149,134,136,1,132,166,136,231,152,233,148,165,144,194,160,106,165,111,141,174,149,242,153,120,158,152,162,120,162,85,166,54,162,210,149,210,153,233,144,
166,132,87,162,87,166,86,166,154,154,152,170,119,170,154,162,89,158,120,154,153,162,184,170,154,170,153,166,122,166,154,170,87,162,230,201,200,242,21,239,91,239,245,230,246,230,254,255,254,255,255,255,89,235,131,148,88,235,55,235,155,247,254,255,
253,255,240,249,74,241,9,241,16,246,155,239,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,123,239,139,173,255,255,255,255,42,173,189,247,255,255,255,255,255,255,255,255,255,255,255,255,253,255,244,242,47,234,111,238,142,234,45,222,203,217,139,213,202,217,45,238,108,242,83,255,83,255,77,238,
71,197,132,164,101,136,201,136,243,153,20,154,77,145,77,141,20,150,89,170,119,166,55,154,21,154,211,153,177,145,109,145,199,140,99,132,200,140,231,148,99,132,64,148,4,169,141,157,210,157,87,166,119,166,86,162,54,162,20,166,245,157,243,157,
209,157,101,136,167,140,53,158,87,166,150,158,153,166,184,166,121,158,119,166,176,210,178,206,122,166,185,158,184,170,154,158,186,166,187,162,86,162,166,205,170,242,207,238,148,222,81,210,24,231,254,255,188,255,89,239,254,255,254,255,155,247,213,218,
155,247,254,255,221,255,207,241,139,249,74,245,108,241,182,230,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,73,165,215,218,255,251,106,173,222,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,90,247,113,230,236,225,204,225,236,225,203,221,205,229,138,213,20,255,52,255,
13,222,229,180,164,152,165,132,201,148,242,153,53,154,55,162,186,166,186,162,152,166,152,162,120,162,86,158,53,154,244,153,210,149,175,153,75,153,200,140,132,140,67,136,98,140,130,148,128,156,164,152,112,145,20,162,20,162,243,165,20,154,243,157,
20,158,22,162,76,141,33,132,66,132,211,149,117,162,21,158,119,162,120,162,88,162,114,198,39,255,73,255,118,186,154,154,152,170,154,170,217,166,186,162,50,166,99,197,137,234,10,251,138,226,45,206,56,231,188,251,254,255,23,231,56,235,122,243,
246,222,213,226,220,255,219,251,220,255,147,242,233,236,201,240,206,229,180,226,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,243,90,235,255,255,81,202,148,214,255,251,255,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,121,247,179,226,81,218,238,209,14,206,
15,214,73,197,165,164,231,156,199,140,231,148,244,153,120,166,87,162,119,166,121,166,87,158,151,158,184,170,121,166,54,166,118,162,21,150,210,157,77,149,76,145,202,140,68,140,101,136,99,140,130,156,194,160,194,156,230,152,41,149,176,153,211,165,
243,161,242,161,209,157,240,161,168,136,8,153,40,161,44,161,242,157,244,169,52,170,19,162,245,157,79,182,201,254,42,255,12,235,148,174,121,162,154,174,120,162,187,170,16,174,34,193,200,213,201,246,102,230,77,214,57,239,154,243,187,251,154,247,
23,227,147,214,180,218,89,235,121,239,22,227,122,239,89,243,17,230,49,230,212,226,181,218,221,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,189,247,254,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,33,132,99,136,165,140,9,149,109,161,176,153,177,157,19,162,85,166,120,166,121,166,152,166,153,170,151,166,118,162,52,154,19,158,176,149,144,153,175,157,233,132,198,140,165,136,164,140,164,148,197,156,196,160,163,160,129,156,
131,136,7,149,108,153,109,157,77,157,175,177,215,222,223,255,255,255,255,255,214,214,142,173,175,165,143,161,77,145,111,145,43,206,136,242,201,250,171,242,80,190,122,162,121,170,220,170,106,157,195,152,100,181,166,201,77,218,179,222,213,226,246,234,
55,235,121,243,22,231,179,218,56,235,254,255,255,255,123,243,179,222,87,235,55,235,23,231,245,226,147,214,222,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,247,218,108,161,167,128,76,137,209,149,20,154,53,154,87,158,120,158,120,158,119,158,55,158,22,154,53,154,244,149,210,149,44,137,43,145,76,157,239,185,123,235,223,255,189,251,155,243,90,239,122,239,122,239,
123,239,122,239,155,243,157,243,156,243,157,243,222,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,156,243,57,231,214,222,146,214,47,202,13,206,236,189,239,173,176,169,244,161,10,153,7,153,246,222,88,235,88,231,23,227,
147,210,81,210,211,218,22,227,113,206,114,206,254,255,254,255,114,210,247,222,23,231,113,210,179,214,147,214,147,214,147,214,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,91,231,183,206,248,206,25,211,248,206,24,207,25,207,24,211,25,219,58,219,58,227,57,227,91,235,124,239,157,239,157,247,223,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,222,255,221,251,255,255,255,251,155,239,
24,231,245,226,113,214,14,198,205,185,82,206,15,194,82,206,255,255,254,255,7,161,180,214,245,222,238,193,48,198,16,198,48,198,124,247,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,90,239,213,230,245,230,146,218,115,214,255,255,156,247,247,226,82,206,23,227,122,239,23,227,181,222,173,185,74,173,140,181,206,189,25,231,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,253,255,255,255,255,255,
255,255,255,255,255,255,255,255,246,226,213,222,24,231,255,255,255,255,255,255,255,255,255,255,255,255,91,243,90,239,188,251,190,251,222,251,189,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,223,255,255,255,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
255,255,254,255,255,255,255,251,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,

 };

 
//********************* 1.Define-FT800 Memory Map Addresses *************************

#define RAM_CMD                     0x108000       //Address Start Graphic Engine Command Buffer
#define RAM_DL                      0x100000       //Address Start Display list ram


//**************** 2.Define-FT800 Command Memory Read/Write ********************

#define MEM_WRITE                    0x80          //FT800 Host Memory Write Mark bit7..6 = 10
#define MEM_READ                     0x3F          //FT800 Host Memory Read Mark bit7..6  = 00

//*************** 3.Define-FT800 Register Address (0x102400-0x10257F) ******************

#define      REG_ID                  0x102400
#define      REG_FRAMES              0x102404
#define      REG_CLOCK               0x102408
#define      REG_FREQUENCY           0x10240C
#define      REG_RENDERMODE          0x102410
#define      REG_SNAPY               0x102414
#define      REG_SNAPSHOT            0x102418
#define      REG_CPURESET            0x10241C
#define      REG_TAP_CRC             0x102420
#define      REG_TAP_MASK            0x102424
#define      REG_HCYCLE              0x102428
#define      REG_HOFFSET             0x10242C
#define      REG_HSIZE               0x102430
#define      REG_HSYNC0              0x102434
#define      REG_HSYNC1              0x102438
#define      REG_VCYCLE              0x10243C
#define      REG_VOFFSET             0x102440
#define      REG_VSIZE               0x102444
#define      REG_VSYNC0              0x102448
#define      REG_VSYNC1              0x10244C
#define      REG_DLSWAP              0x102450
#define      REG_ROTATE              0x102454
#define      REG_OUTBITS             0x102458

#define      REG_DITHER              0x10245C
#define      REG_SWIZZLE             0x102460
#define      REG_CSPREAD             0x102464
#define      REG_PCLK_POL            0x102468
#define      REG_PCLK                0x10246C
#define      REG_TAG_X               0x102470
#define      REG_TAG_Y               0x102474
#define      REG_TAG                 0x102478
#define      REG_VOL_PB              0x10247C
#define      REG_VOL_SOUND           0x102480
#define      REG_SOUND               0x102484
#define      REG_PLAY                0x102488
#define      REG_GPIO_DIR            0x10248C
#define      REG_GPIO                0x102490
#define      REG_INT_FLAGS           0x102498
#define      REG_INT_EN              0x10249C
#define      REG_INT_MASK            0x1024A0
#define      REG_PLAYBACK_START      0x1024A4
#define      REG_PLAYBACK_LENGTH     0x1024A8
#define      REG_PLAYBACK_READPTR    0x1024AC
#define      REG_PLAYBACK_FREQ       0x1024B0
#define      REG_PLAYBACK_FORMAT     0x1024B4
#define      REG_PLAYBACK_LOOP       0x1024B8

#define      REG_PLAYBACK_PLAY       0x1024BC
#define      REG_PWM_HZ              0x1024C0
#define      REG_PWM_DUTY            0x1024C4
#define      REG_MACRO_0             0x1024C8
#define      REG_MACRO_1             0x1024CC
#define      REG_CMD_READ            0x1024E4
#define      REG_CMD_WRITE           0x1024E8
#define      REG_CMD_DL              0x1024EC
#define      REG_TOUCH_MODE          0x1024F0
#define      REG_TOUCH_ADC_MODE      0x1024F4
#define      REG_TOUCH_CHARGE        0x1024F8
#define      REG_TOUCH_SETTLE        0x1024FC
#define      REG_TOUCH_OVERSAMPLE    0x102500
#define      REG_TOUCH_RZTHRESH      0x102504
#define      REG_TOUCH_RAW_XY        0x102508
#define      REG_TOUCH_RZ            0x10250C
#define      REG_TOUCH_SCREEN_XY     0x102510
#define      REG_TOUCH_TAG_XY        0x102514
#define      REG_TOUCH_TAG           0x102518
#define      REG_TOUCH_TRANSFORM_A   0x10251C

#define      REG_TOUCH_TRANSFORM_B   0x102520
#define      REG_TOUCH_TRANSFORM_C   0x102524
#define      REG_TOUCH_TRANSFORM_D   0x102528
#define      REG_TOUCH_TRANSFORM_E   0x10252C
#define      REG_TOUCH_TRANSFORM_F   0x102530
#define      REG_TOUCH_DIRECT_XY     0x102574
#define      REG_TOUCH_DIRECT_Z1Z2   0x102578
#define      REG_TRACKER             0x109000


/************************************************************************ 
 **                                                                    **
 **                4.Define-FT800 Host Commands                        **
 **                                                                    **
 **  -Use by FT800_HostCmdWrite(). Write Control to FT800              **
 **                                                                    **
 ************************************************************************/

//Group Power Mode

#define FT800_ACTIVE      0x00         //Initializes FT800
#define FT800_STANDBY     0x41         //Place FT800 in Standby (clk running)
#define FT800_SLEEP       0x42         //Place FT800 in Sleep (clk off)
#define FT800_PWRDOWN     0x50         //Place FT800 in Power Down (core off)

//Group Clock Switch

#define FT800_CLKEXT      0x44         //Select external clock source
#define FT800_CLK48M      0x62         //Select 48MHz PLL
#define FT800_CLK36M      0x61         //Select 36MHz PLL

//Group Miscellaneous

#define FT800_CORERST     0x68         //Reset core - all registers default


/*************************************************************************** 
 **                                                                       **
 **           5.Define-FT800 Display list commands(DL-CMD)                **
 **                                                                       **
 **  -Use by FT800memWritexx()/FT800memReadxx(). Write to Ram-DL          **
 **                                                                       **
 ***************************************************************************/

#define DL_ALPHA_FUNC       0x09000000 // requires OR'd arguments
#define DL_BITMAP_HANDLE    0x05000000 // requires OR'd arguments
#define DL_BITMAP_LAYOUT    0x07000000 // requires OR'd arguments
#define DL_BITMAP_SIZE      0x08000000 // requires OR'd arguments
#define DL_BITMAP_SOURCE    0x01000000 // requires OR'd arguments
#define DL_BITMAP_TFORM_A   0x15000000 // requires OR'd arguments
#define DL_BITMAP_TFORM_B   0x16000000 // requires OR'd arguments
#define DL_BITMAP_TFORM_C   0x17000000 // requires OR'd arguments
#define DL_BITMAP_TFORM_D   0x18000000 // requires OR'd arguments
#define DL_BITMAP_TFORM_E   0x19000000 // requires OR'd arguments
#define DL_BITMAP_TFORM_F   0x1A000000 // requires OR'd arguments
#define DL_BLEND_FUNC       0x0B000000 // requires OR'd arguments
#define DL_BEGIN            0x1F000000 // requires OR'd arguments
#define DL_CALL             0x1D000000 // requires OR'd arguments
#define DL_CLEAR            0x26000000 // requires OR'd arguments
#define DL_CELL             0x06000000 // requires OR'd arguments
#define DL_CLEAR_RGB        0x02000000 // requires OR'd arguments
#define DL_CLEAR_STENCIL    0x11000000 // requires OR'd arguments
#define DL_CLEAR_TAG        0x12000000 // requires OR'd arguments
#define DL_COLOR_A          0x0F000000 // requires OR'd arguments
#define DL_COLOR_MASK       0x20000000 // requires OR'd arguments
#define DL_COLOR_RGB        0x04000000 // requires OR'd arguments
#define DL_DISPLAY          0x00000000
#define DL_END              0x21000000
#define DL_JUMP             0x1E000000 // requires OR'd arguments
#define DL_LINE_WIDTH       0x0E000000 // requires OR'd arguments
#define DL_MACRO            0x25000000 // requires OR'd arguments
#define DL_POINT_SIZE       0x0D000000 // requires OR'd arguments
#define DL_RESTORE_CONTEXT  0x23000000
#define DL_RETURN           0x24000000
#define DL_SAVE_CONTEXT     0x22000000
#define DL_SCISSOR_SIZE     0x1C000000 // requires OR'd arguments
#define DL_SCISSOR_XY       0x1B000000 // requires OR'd arguments
#define DL_STENCIL_FUNC     0x0A000000 // requires OR'd arguments
#define DL_STENCIL_MASK     0x13000000 // requires OR'd arguments
#define DL_STENCIL_OP       0x0C000000 // requires OR'd arguments
#define DL_TAG              0x03000000 // requires OR'd arguments
#define DL_TAG_MASK         0x14000000 // requires OR'd arguments
#define DL_VERTEX2F         0x40000000 // requires OR'd arguments
#define DL_VERTEX2II        0x80000000 // requires OR'd arguments


/******************************************************************************
 **                                                                          **
 **           6.Define-FT800 Co-Processor Engine Commands(CO-CMD)            **
 **                                                                          **
 **         -Use by FT800memWritexx()/FT800memReadxx().Write to Ram-CMD      **
 **                                                                          **
 ******************************************************************************/

#define    CMD_APPEND            0xFFFFFF1E    //Append memory to display list
#define    CMD_BGCOLOR           0xFFFFFF09    //Set the background color
#define    CMD_BUTTON            0xFFFFFF0D    //Draw a button
#define    CMD_CALIBRATE         0xFFFFFF15    //Execute the touch screen calibration routine
#define    CMD_CLOCK             0xFFFFFF14    //Draw an analog clock
#define    CMD_COLDSTART         0xFFFFFF32    //Set co-processor engine state to default values
#define    CMD_DIAL              0xFFFFFF2D    //Draw a rotary dial control
#define    CMD_DLSTART           0xFFFFFF00    //Start a new display list
#define    CMD_FGCOLOR           0xFFFFFF0A    //Set the foreground color
#define    CMD_GAUGE             0xFFFFFF13    //Draw a gauge
#define    CMD_GETMATRIX         0xFFFFFF33    //Retrieves the current matrix coefficients
#define    CMD_GETPTR            0xFFFFFF23    //Get the end memory address of inflated data
#define    CMD_GRADCOLOR         0xFFFFFF34    //Set the 3D Button highlight color
#define    CMD_GRADIENT          0xFFFFFF0B    //Draw a smooth color gradient
#define    CMD_INFLATE           0xFFFFFF22    //Decompress data into memory
#define    CMD_INTERRUPT_TRIG    0xFFFFFF02    //Trigger interrupt INT_CMDFLAG
#define    CMD_KEYS              0xFFFFFF0E    //Draw a row of keys
#define    CMD_LOADIDENTITY      0xFFFFFF26    //Set the current matrix to the identity matrix
#define    CMD_LOADIMAGE         0xFFFFFF24    //Load a JPEG image
#define    CMD_LOGO              0xFFFFFF31    //Play FTDI logo animation
#define    CMD_MEMCPY            0xFFFFFF1D    //Copy a block of memory
#define    CMD_MEMCRC            0xFFFFFF18    //Compute a CRC-32 for memory
#define    CMD_MEMSET            0xFFFFFF1B    //Fill memory with a byte value
#define    CMD_MEMWRITE          0xFFFFFF1A    //Write bytes into memory
#define    CMD_MEMZERO           0xFFFFFF1C    //Write zero to a block of memory
#define    CMD_NUMBER            0xFFFFFF2E    //Draw a decimal number 
#define    CMD_PROGRESS          0xFFFFFF0F    //Draw a process bar
#define    CMD_REGREAD           0xFFFFFF19    //Read a register value
#define    CMD_ROTATE            0xFFFFFF29    //Apply a rotation to the current matrix
#define    CMD_SCALE             0xFFFFFF28    //Apply a scale to the current matrix
#define    CMD_SCREENSAVER       0xFFFFFF2F    //Start an animated screensaver
#define    CMD_SCROLLBAR         0xFFFFFF11    //Draw a scroll bar
#define    CMD_SETFONT           0xFFFFFF2B    //Set up a custom font 
#define    CMD_SETMATRIX         0xFFFFFF2A    //Write the current matrix to the display list
#define    CMD_SKETCH            0xFFFFFF30    //Start a continuous sketch update
#define    CMD_SLIDER            0xFFFFFF10    //Draw a slider
#define    CMD_SNAPSHOT          0xFFFFFF1F    //Take a snapshot of the current screen
#define    CMD_SPINNER           0xFFFFFF16    //Start an animated spinner
#define    CMD_STOP              0xFFFFFF17    //Stop an of spinner, screensaver or sketch
#define    CMD_SWAP              0xFFFFFF01    //Swap the current display list
#define    CMD_TEXT              0xFFFFFF0C    //Draw text
#define    CMD_TOGGLE            0xFFFFFF12    //Draw a toggle switch
#define    CMD_TRACK             0xFFFFFF2C    //Track touches for a graphics object
#define    CMD_TRANSLATE         0xFFFFFF27    //Apply a translation to the current matrix

#define    CMD_IDCT              0xFFFFFF06
#define    CMD_MARCH             0xFFFFFF05
#define    CMD_TOUCH_TRANSFORM   0xFFFFFF20 
#define    CMD_BITMAP_TRANSFORM  0xFFFFFF21
#define    CMD_CRC               0xFFFFFF03
#define    CMD_EXECUTE           0xFFFFFF07 
#define    CMD_GETPOINT          0xFFFFFF08
#define    CMD_GETPROPS          0xFFFFFF25
#define    CMD_HAMMERAUX         0xFFFFFF04 



//*********** 7.Data Parameter Option of DL-CMD,Co-CMD and Register *************

#define CLR_COL              0x4
#define CLR_STN              0x2
#define CLR_TAG              0x1
#define DECR                 4
#define DECR_WRAP            7
#define DLSWAP_DONE          0
#define DLSWAP_FRAME         2
#define DLSWAP_LINE          1
#define DST_ALPHA            3
#define EDGE_STRIP_A         7
#define EDGE_STRIP_B         8
#define EDGE_STRIP_L         6
#define EDGE_STRIP_R         5
#define EQUAL                5
#define GEQUAL               4
#define GREATER              3
#define INCR                 3
#define INCR_WRAP            6
#define INT_CMDEMPTY         32
#define INT_CMDFLAG          64
#define INT_CONVCOMPLETE     128
#define INT_PLAYBACK         16
#define INT_SOUND            8
#define INT_SWAP             1
#define INT_TAG              4
#define INT_TOUCH            2
#define INVERT               5
#define KEEP                 1
#define L1                   1
#define L4                   2
#define L8                   3
#define LEQUAL               2
#define LESS                 1
#define LINEAR_SAMPLES       0
#define LINES                3
#define LINE_STRIP           4
#define NEAREST              0
#define NEVER                0
#define NOTEQUAL             6
#define ONE                  1
#define ONE_MINUS_DST_ALPHA  5
#define ONE_MINUS_SRC_ALPHA  4
#define OPT_CENTER           1536    // 0x6000
#define OPT_CENTERX          512     // 0x0200
#define OPT_CENTERY          1024    // 0x0400
#define OPT_FLAT             256     // 0x0100
#define OPT_MONO             1
#define OPT_NOBACK           4096    // 0x1000
#define OPT_NODL             2
#define OPT_NOHANDS          49152   // 0xC168
#define OPT_NOHM             16384   // 0x4000
#define OPT_NOPOINTER        16384   // 0x4000
#define OPT_NOSECS           32768   // 0x8000
#define OPT_NOTICKS          8192    // 0x2000
#define OPT_RIGHTX           2048    // 0x0800
#define OPT_SIGNED           256     // 0x0100
#define PALETTED             8
#define PLAYCOLOR            0x00A0A080
#define FTPOINTS             2       // "POINTS" is a reserved word
#define RECTS                9
#define REPEAT               1
#define REPLACE              2
#define RGB332               4
#define RGB565               7
#define SRC_ALPHA            2
#define TEXT8X8              9
#define TEXTVGA              10
#define TOUCHMODE_CONTINUOUS 3
#define TOUCHMODE_FRAME      2
#define TOUCHMODE_OFF        0
#define TOUCHMODE_ONESHOT    1
#define ULAW_SAMPLES         1
#define ZERO                 0
#define BITMAPS              1


//***************** 8.Define Color RGB 24 bit *******************


#define      AliceBlue            0xF0F8FF
#define      AntiqueWhite         0xFAEBD7
#define      Aquamarine           0x7FFFD4
#define      Azure                0xF0FFFF
#define      Beige                0xF5F5DC
#define      Bisque               0xFFFAF0
#define      Black                0x000000
#define      BlanchedAlmond       0xFFEBCD
#define      Blue                 0x0000FF
#define      BlueViolet           0x8A2BE2
#define      Brown                0xA52A2A
#define      Burlywood            0xDEB887
#define      CadetBlue            0x5F9EA0
#define      Chartreuse           0x7FFF00
#define      Chocolate            0xD2691E
#define      Coral                0xFF7F50
#define      CornflowerBlue       0x6495ED
#define      Cornsilk             0xFFF8DC
#define      Cyan                 0x00FFFF
#define      DarkGoldenrod        0xB8860B
#define      DarkGreen            0x006400
#define      DarkKaki             0xBDB76B
#define      DarkOliveGreen       0x556B2F
#define      DarkOrange           0xFF8C00
#define      DarkOrchid           0x9932CC
#define      DarkSalmon           0xE9967A
#define      DarkSeaGreen         0x8FBC8F
#define      DarkSlateBlue        0x483D8B
#define      DarkSlateGray        0x2F4F4F
#define      DarkTurquoise        0x00CED1
#define      DarkViolet           0x9400D3
#define      DeepPink             0xFF1493
#define      DeepSkyBlue          0x00BFFF
#define      DimGrey              0x696969
#define      DodgeBlue            0x1E90FF
#define      Firebrick            0xB22222
#define      FloralWhite          0xFFFAF0
#define      ForestGreen          0x228B22
#define      Gainsboro            0xDCDCDC
#define      GhostWhite           0xF8F8FF
#define      Gold                 0xFFD700
#define      Goldenrod            0xDAA520
#define      Gray                 0xBEBEBE
#define      Green                0x00FF00
#define      GreenYellow          0xADFF2F
#define      Honeydew             0xF0FFF0
#define      HotPink              0xFF69B4
#define      IndianRed            0xCD5C5C
#define      LtGoldenrodYellow    0xFAFAD2
#define      Ivory                0xFFFFF0
#define      lavender             0xE6E6FA
#define      Lavender_Blush       0xFFF0F5
#define      LawnGreen            0x7CFC00
#define      LemonChiffon         0xFFFACD
#define      LightBlue            0xADD8E6
#define      LightCoral           0xF08080
#define      LightCyan            0xE0FFFF
#define      LightGoldenrod       0xEEDD82
#define      LightGray            0xD3D3D3
#define      LightPink            0xFFB6C1
#define      LightSeaGreen        0x20B2AA
#define      LightSkyBlue         0x87CEFA
#define      LightSalmon          0xFFA07A
#define      LightSlateBlue       0x8470FF
#define      LightSlateGray       0x778899
#define      LightSteelBlue       0xB0C4DE
#define      LightYellow          0xFFFFE0
#define      LimeGreen            0x32CD32
#define      Linen                0xFAF0E6
#define      Magenta              0xFF00FF
#define      Maroon               0xB03060
#define      MediumAquamarine     0x66CDAA
#define      MediumBlue           0x0000CD
#define      MediumOrchid         0xBA55D3
#define      MediumPurple         0x9370DB
#define      MediumSeaGreen       0x3CB371
#define      MediumSlateBlue      0x7B68EE
#define      MediumTurquoise      0x48D1CC
#define      MediumVioletRed      0xC71585
#define      MedSpringGreen       0x00FA9A
#define      MidnightBlue         0x191970
#define      MintCream            0xF5FFFA
#define      MistyRose            0xFFE4E1
#define      Moccasin             0xFFE4B5
#define      NavyBlue             0x000080
#define      NavajoWhite          0xFFDEAD
#define      OldLace              0xFDF5E6
#define      OliveDrab            0x6B8E23
#define      Orange               0xFFA500
#define      OrangeRed            0xFF4500
#define      Orchid               0xDA70D6
#define      PaleGoldenrod        0xEEE8AA
#define      PaleGreen            0x98FB98
#define      PaleTurquoise        0xAFEEEE
#define      PaleVioletRed        0xDB7093
#define      PapayaWhip           0xFFEFD5
#define      PeachPuff            0xFFDAB9
#define      Peru                 0xCD853F
#define      Pink                 0xFFc0CB
#define      Plum                 0xDDA0DD
#define      PowderBlue           0xB0E0E6
#define      Purple               0xA020F0
#define      Red                  0xFF0000
#define      RosyBrown            0xBC8F8F
#define      RoyalBlue            0x4169E1
#define      Salmon               0xFA8072
#define      SaddleBrown          0x8B4513
#define      SandyBrown           0xF4A460
#define      SeaGreen             0x2E8B57
#define      Seashell             0xFFF5EE
#define      Sienna               0xA0522D
#define      SkyBlue              0x87CEEB
#define      SlateBlue            0x6A5ACD
#define      SlateGrey            0x708090
#define      Snow                 0xFFFAFA
#define      SpringGreen          0x00FF7F
#define      SteelBlue            0x4682B4
#define      Tan                  0xD2B48C
#define      Tomato               0xFF6347   
#define      Thistle              0xD8BFD8
#define      Turquoise            0x40E0D0
#define      Violet               0xEE82EE
#define      Wheat                0xF5DEB3
#define      White                0xFFFFFF
#define      WhiteSmoke           0xF5F5F5
#define      Yellow               0xFFFF00
#define      YellowGreen          0x9ACD32
#define      VioletRed            0xD02090




//***************** 9.Define Sound Effect ,Use with REG_SOUND 8 bit Low  *******************
                                     
                                      /* Continuous / Pitch adjus midi */    
                              
#define      Silence         0x00    //       yes    /        no          :No-sound
#define      SquareWave      0x01    //       yes    /        yes        
#define      SineWave        0x02    //       yes    /        yes       
#define      SawtoothWave    0x03    //       yes    /        yes        
#define      TriangleWave    0x04    //       yes    /        yes        
#define      Beeping         0x05    //       yes    /        yes 
#define      Alarm           0x06    //       yes    /        yes 
#define      Warble          0x07    //       yes    /        yes 
#define      Carousel        0x08    //       yes    /        yes 
#define      Short1Pip       0x10    //       no     /        yes   
#define      Short2Pips      0x11    //       no     /        yes  
#define      Short3Pips      0x12    //       no     /        yes  
#define      Short4Pips      0x13    //       no     /        yes  
#define      Short5Pips      0x14    //       no     /        yes  
#define      Short6Pips      0x15    //       no     /        yes  
#define      Short7Pips      0x16    //       no     /        yes  
#define      Short8Pips      0x17    //       no     /        yes  
#define      Short9Pips      0x18    //       no     /        yes  
#define      Short10Pips     0x19    //       no     /        yes  
#define      Short11Pips     0x1A    //       no     /        yes  
#define      Short12Pips     0x1B    //       no     /        yes  
#define      Short13Pips     0x1C    //       no     /        yes  
#define      Short14Pips     0x1D    //       no     /        yes  
#define      Short15Pips     0x1E    //       no     /        yes  
#define      Short16Pips     0x1F    //       no     /        yes  
#define      DTMF_shap       0x23    //       yes    /        no  
#define      DTMF_star       0x2A    //       yes    /        no  
#define      DTMF0           0x30    //       yes    /        no  
#define      DTMF1           0x31    //       yes    /        no  
#define      DTMF2           0x32    //       yes    /        no  
#define      DTMF3           0x33    //       yes    /        no  
#define      DTMF4           0x34    //       yes    /        no  
#define      DTMF5           0x35    //       yes    /        no  
#define      DTMF6           0x36    //       yes    /        no  
#define      DTMF7           0x37    //       yes    /        no  
#define      DTMF8           0x38    //       yes    /        no  
#define      DTMF9           0x39    //       yes    /        no  
#define      Harp            0x40    //       no     /        yes  
#define      Xylophone       0x41    //       no     /        yes  
#define      Tuba            0x42    //       no     /        yes  
#define      Glockenspiel    0x43    //       no     /        yes  
#define      Organ           0x44    //       no     /        yes  
#define      Trumpet         0x45    //       no     /        yes  
#define      Piano           0x46    //       no     /        yes  
#define      Chimes          0x47    //       no     /        yes  
#define      MusicBox        0x48    //       no     /        yes  
#define      Bell            0x49    //       no     /        yes  
#define      Click           0x50    //       no     /        yes  
#define      Swit            0x51    //       no     /        yes  
#define      Cowbell         0x52    //       no     /        yes  
#define      Notch           0x53    //       no     /        yes  
#define      Hihat           0x54    //       no     /        yes  
#define      Kickdrum        0x55    //       no     /        yes  
#define      Pop             0x56    //       no     /        yes  
#define      Clack           0x57    //       no     /        yes  
#define      Chack           0x58    //       no     /        yes  
#define      Mute            0x60    //       no     /        yes  
#define      Unmute          0x61    //       no     /        yes  



//***************** 10.Define MIDI Note Effect ,Use with REG_SOUND 8 bit High  *******************

                              /* Freq (Hz)*/

#define      midC       0        //Level MiddelC
#define      A0        21        //27.5   
#define      A_0       22        //29.1
#define      B0        23        //30.9
#define      C1        24        //32.7
#define      C_1       25        //34.6
#define      D1        26        //36.7
#define      D_1       27        //38.9
#define      E1        28        //41.2
#define      F1        29        //43.7
#define      F_1       30        //46.2
#define      G1        31        //49.0
#define      G_1       32        //51.9
#define      A1        33        //55.0
#define      A_1       34        //58.3
#define      B1        35        //61.7
#define      C2        36        //65.4
#define      C_2       37        //69.3
#define      D2        38        //73.4
#define      D_2       39        //77.8
#define      E2        40        //82.4
#define      F2        41        //87.3
#define      F_2       42        //92.5
#define      G2        43        //98.0
#define      G_2       44        //103.8
#define      A2        45        //110.0
#define      A_2       46        //116.5
#define      B2        47        //123.5
#define      C3        48        //130.8
#define      C_3       49        //138.6
#define      D3        50        //146.8
#define      D_3       51        //155.6
#define      E3        52        //164.8
#define      F3        53        //174.6
#define      F_3       54        //185.0
#define      G3        55        //196.0
#define      G_3       56        //207.7
#define      A3        57        //220.0
#define      A_3       58        //233.1
#define      B3        59        //246.9
#define      C4        60        //261.6
#define      C_4       61        //277.2
#define      D4        62        //293.7
#define      D_4       63        //311.1
#define      E4        64        //329.6
#define      F4        65        //349.2
#define      F_4       66        //370.0
#define      G4        67        //392.0
#define      G_4       68        //415.3
#define      A4        69        //440.0
#define      A_4       70        //466.2
#define      B4        71        //493.9
#define      C5        72        //523.3
#define      C_5       73        //554.4
#define      D5        74        //587.3
#define      D_5       75        //622.3
#define      E5        76        //659.3
#define      F5        77        //698.5
#define      F_5       78        //740.0
#define      G5        79        //784.0
#define      G_5       80        //830.6
#define      A5        81        //880.0
#define      A_5       82        //932.3
#define      B5        83        //987.8
#define      C6        84        //1046.5
#define      C_6       85        //1108.7
#define      D6        86        //1174.7
#define      D_6       87        //1244.5
#define      E6        88        //1318.5
#define      F6        89        //1396.9
#define      F_6       90        //1480.0
#define      G6        91        //1568.0
#define      G_6       92        //1661.2
#define      A6        93        //1760.0 
#define      A_6       94        //1864.7
#define      B6        95        //1975.5
#define      C7        96        //2093.0
#define      C_7       97        //2217.5
#define      D7        98        //2349.3
#define      D_7       99        //2489.0
#define      E7       100        //2637.0
#define      F7       101        //2793.8
#define      F_7      102        //2960.0
#define      G7       103        //3136.0
#define      G_7      104        //3322.4
#define      A7       105        //3520.0
#define      A_7      106        //3729.3
#define      B7       107        //3951.1
#define      C8       108        //4186.0



/*#################################################################
 ##                                                              ##
 ##                        Define Variable                       ##
 ##                                                              ##
 #################################################################*/


unsigned int16 DL_Offset   = 0x0000  ;          //Offset Address Pointer of display list memory 
unsigned int16 cmdOffset   = 0x0000  ;          //Offset Address Pointer of Command Buffer memmory

unsigned long RamG_Offset = 0x0000   ;          //Offset Address Pointer of Ram_G
unsigned long BMP_Add[50]            ;          //Keep Address Start of each Picture in Ram_G  Max 50 Pixture
unsigned char bmp_pt=0               ;

unsigned int16 cmdBufferRd = 0x0000  ;          //Used to navigate command ring buffer
unsigned int16 cmdBufferWr = 0x0000  ;          //Used to navigate command ring buffer

unsigned int8 ft800Gpio              ;          //Used for FT800 GPIO register

unsigned int8 num_cha                ;          //keep Number Print Text 
unsigned int16 tc_x,tc_y             ;          //keeop Positin Touch Screen X,Y 

//------------------ Valiable for User Application ---------------

unsigned int8 pic      = 0           ;
unsigned int8 fag_rt   = 0           ;
int32 angle            = 0           ;



/*#################################################################
 ##                                                              ##
 ##              Define Function Sub-program                     ##
 ##                                                              ##
 ##################################################################*/

                               

/****************************************************************
 **                                                            **
 **    1.Function-About Manage Hardware/Software of MCU        **
 **                                                            **     
 ****************************************************************/

void init_port(void)               ;


/***********************************************************************************
 **                                                                               **
 **         2. Function-About Software SPI Read/Write 8 bit (RJ0-RJ6)             **
 **                                                                               **
 ***********************************************************************************/

void spi_sck_hi(void)             ;
void spi_sck_lo(void)             ;
void spi_cs_hi(void)              ;
void spi_cs_lo(void)              ;
void spi_sdo_hi(void)             ;
void spi_sdo_lo(void)             ;
unsigned int8 spi_rw(unsigned int8 Db)   ;


/*******************************************************************************
 **                                                                           **
 **                       3.Function- About Write FT800                       **
 **                                                                           **
 *******************************************************************************/

//-------------- Function-FT800 Power-Down[RJ4] ------------------ 

void FT800_PD_hi(void)            ;
void FT800_PD_lo(void)            ;   //Set Power Down FT800

//------------Function-Write Register,Ram-DL,Ram-CMD (Address[22bit] and Data Parameter 8,16,32 bit)---------

void FT800memWrite8(unsigned  int32 addr,unsigned int8 data8)      ;
void FT800memWrite16(unsigned int32 addr,unsigned int16 data16)    ;
void FT800memWrite32(unsigned int32 addr,unsigned int32 data32)    ;

//-------------Function-Write Address Ram-CMD and Data Text-String -----------------

void FT800memWriteStr(unsigned int32 addr,int8 *str)               ;  //Command for Write Address + Text-String 

//------------------ Function-Write Address Ram_G and Data Bitmap  -----------------

void FT800memWrBitmap(unsigned int32 addr,unsigned int32 length , rom int8 *bitmap) ; //Write Data Picture to RAM_G


//------------ Function-Write Host Command  (Command[6-bit]+0x00+0x00)-------------

void FT800_HostCmdWrite(unsigned int8 Command)                     ;



/*******************************************************************************
 **                                                                           **
 **                         4.Function-About Read FT800                       **
 **                                                                           **
 *******************************************************************************/


//------------Function-Read Register,Ram-DL,RAm-CMD (Address[22bit] + Data Parameter 8,16,32 bit)---------

unsigned int8 FT800memRead8(unsigned int32 addr)                   ;
unsigned int16 FT800memRead16(unsigned int32 addr)                 ;
unsigned int32 FT800memRead32(unsigned int32 addr)                 ; 



/***********************************************************************************
 **                                                                               **
 **           5.Function-About Manage memory address FT800 Ring Buffer            **              
 **                                                                               **
 ***********************************************************************************/

//----------- Function-Increment Address Offset Pointer for Ram-CMD --------------

unsigned int16 incCMDOffset(unsigned int16 currentOffset,unsigned int8 commandSize)     ; 
unsigned int16 End_incCMDOffset(unsigned int16 currentOffset,unsigned int8 commandSize) ; //Use when end Co-Processor CMD 

//----------- Function-Increment Address Offset Pointer for Ram_G --------------

unsigned int32 incRamG_Offset(unsigned int32 currentOffset, unsigned int32 BitmapSize)  ;
 
//-------- Function-Start Offset pointer & Waite Co-Processor CMD Finish executing -------------  

void Start_CMDOffset(void) ;



/*************************************************************************************
 **                                                                                 **
 **                         6.Function-About Touch Screen                           **
 **                                                                                 **
 *************************************************************************************/

int8 Touch_Detect(void)    ;
void Touch_Read_XY(void)   ;
void Touch_Calibrate(void) ;


/*************************************************************************************
 **                                                                                 **
 **                               7.Function-About Audio                            **
 **                                                                                 **
 *************************************************************************************/

void Sound_Effect(unsigned int8 vol,int16 midi,int16 effect) ;


/*************************************************************************************
 **                                                                                 **
 **                         8.Function-About FT800 DL-CMD,Co-CMD                    **
 **                                                                                 **
 *************************************************************************************/


void Start_CMDList(int32 screen_color);
void End_CMDList(void)                ;
void Button_CMD(int8 *str,int16 x,int16 y,int16 wide,int16 high,int16 font,int16 opt,int32 tx_color,int32 bt_color) ;
void Text_CMD(int8 *str,int16 x,int16 y,int16 font,int16 opt,int32 tx_color) ;
void Rect_DL(int32 x1,int32 y1,int32 x2,int32 y2,int16 wd,int32 rect_color)  ;
void Bitmap_DL(int32 x,int32 y,int32 addr,int32 format,int32 line_byte,int32 width,int16 height ) ;
void RotateBMP_CMD(int32 x,int32 y,int32 addr,int32 format,int32 line_byte,int32 width,int16 height,int32 angle_rotat );


/*************************************************************************************
 **                                                                                 **
 **                       9.Function-About User Application                         **
 **                                                                                 **
 *************************************************************************************/

void FT800_Initial(void)   ;
void Update_Screen(int32 color_bt1,int32 color_bt2,int32 color_bt3) ;
void User_App(void)        ;


/*##########################################################################
 ##                                                                       ##
 ##                            MAIN PROGRAM                               ##
 ##                                                                       ##
 ###########################################################################*/

void main(void)
 {
  
   init_port()        ;
   FT800_Initial()    ;
   Touch_Calibrate()  ;
   User_App()         ;

}
    


/*################################################################################
  ##                                                                            ##
  ##                          Function SUB-PROGRAM                              ##
  ##                                                                            ##
  ################################################################################ */

 

/*****************************************************************************
 **                                                                         **
 **            1.Function-About Manage Hardware/Software of MCU             **
 **                                                                         **     
 *****************************************************************************/

/*+++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                               ++
  ++         1.1) Function-Initial Port            ++
  ++                                               ++ 
  +++++++++++++++++++++++++++++++++++++++++++++++++++*/

 void init_port(void)
  {
   set_tris_J(0x21)          ;   //Set RJ1[MOSI],RJ2[SCK],RJ3[CS],RJ4[PD#],RJ6[SD_CS] = Output:0  ; RJ0[MISO],RJ5(INT)=Input:1
 
   //------ Set Value Default Port ------ 
         
   output_J(0x5A)            ;   //RJ4(PD)=1(Disable Power down),RJ3(CS)=1,RJ2(SCK)=0,RJ1(MOSI)=1 ,RJ6(SD_CS) =1  

  }


/***********************************************************************************
 **                                                                               **
 **         2. Function-About Software SPI Read/Write 8 bit (RJ0-RJ6)             **
 **                                                                               **
 ***********************************************************************************/


//++++++++++++++++ Data MOSI [RJ1] ++++++++++++++++++

void spi_sdo_hi(void)
 {
   output_high(PIN_J1) ;   //RJ1=1
 }

void spi_sdo_lo(void)
 {
   output_low(PIN_J1)  ;   //RJ1=0
 }


//+++++++++++++++++ SCK [RJ2] ++++++++++++++++++++++

void spi_sck_hi(void)
 {
   output_high(PIN_J2);   //RJ2=1
 }

void spi_sck_lo(void) 
 {
  output_low(PIN_J2)  ;   //RJ2=1(Ideal)
 }


//+++++++++++++++++ CS [RJ3] ++++++++++++++++++++++

 void spi_cs_hi(void)
 {
   output_high(PIN_J3);   //RJ3=1
 }

void spi_cs_lo(void)
 {
   output_low(PIN_J3) ;   //RJ3=0(Active)
 }



/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ++                                                                                   ++
 ++                  2.1) Function-SPI Read/Write Data 1 Byte                         ++
 ++                                                                                   ++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ++   Input :                                                                         ++
 ++           Db = Data or Cmmand  1 Byte (Send data most significant bit first)      ++
 ++                                                                                   ++
 ++   Output:                                                                         ++
 ++           result = Return data 1 byte Pass Function                               ++
 ++                                                                                   ++
 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


unsigned int8 spi_rw(unsigned int8 Db)              
{
  unsigned int8 bt,result=0;                   
  
     for(bt=0;bt<8;bt++)                      //Loop read/write 8 bit
      {       
      //--------- Write Data(RJ1) ---------
 
        if((Db & 0x80)== 0x80)
          spi_sdo_hi()                     ;    //Set bit data(RJ1) = 1
        else
          spi_sdo_lo()                     ;    //Clear bit data(RJ1) = 0
 
        spi_sck_hi()                       ;    //Start Clock  High (active rise edge) 
     
        Db  <<= 1                          ;    //Shift Next Bit Data
         
        //---------- Read Data(RJ0) -------
        
        result <<= 1                       ;    //Shift data read to MSB bit     
     
        if(input(PIN_J0)== 1)                   //If SDI = "1"                  
         {
           result |= 0x01                  ;    //Keep Result of Read-data        
         } 
        spi_sck_lo()                       ;      
     }
 
     return result                         ;
}




/*******************************************************************************
 **                                                                           **
 **                       3.Function- About Write FT800                       **
 **                                                                           **
 *******************************************************************************/

/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                         ++
  ++                   3.1) Function-FT800 Power-Down[RJ4]                   ++
  ++                                                                         ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void FT800_PD_hi(void)
{
   output_high(PIN_J4)     ;   //RJ4=1:Disable Power-Down FT800
}


void FT800_PD_lo(void)
{
   output_low(PIN_J4)      ;   //RJ4=0:Enable Power-Down FT800
}



/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                         ++
  ++          3.2) Function-Write Register,Ram-DL,Ram-CMD +Data              ++
  ++                                                                         ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++ Input:                                                                  ++
  ++         addr    = FT800 memory space address Ram-DL,Ram-CMD,Reg.        ++
  ++                                                                         ++
  ++         dataxx  = Data for Co-CMD,DL-CMD or Reg.                        ++
  ++                                                                         ++
  ++ Overview:         Writes FT800 internal address space                   ++
  ++ Note:             "xx" is data of 8, 16 or 32 bit                       ++
  ++                                                                         ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


//++++++++++++++ Function-Write Address Register,Ram-DL,Ram-CMD + Data 8 bit ++++++++++++++++


void FT800memWrite8(unsigned int32 addr, unsigned int8 data8)
{
  spi_cs_lo()                     ; // Set CS# low
  
  //sent address Ram
  spi_rw(((addr>>16)|MEM_WRITE))  ; // Send Memory Write plus high address byte
  spi_rw(addr>>8)                 ; // Send middle address byte
  spi_rw(addr)                    ; // Send low address byte
 
 //sent data 1 byte
  spi_rw(data8)                   ; // Send data byte

  spi_cs_hi()                     ; // Set CS# high
}


//++++++++++++++ Function-Write Address Register,Ram-DL,Ram-CMD + Data 16 bit++++++++++++++++

void FT800memWrite16(unsigned int32 addr, unsigned int16 data16)
{

  spi_cs_lo()                     ;   // Set CS# low

  //sent address Ram
  spi_rw(((addr>>16)|MEM_WRITE))  ;   // Send Memory Write plus high address byte
  spi_rw(addr>>8)                 ;   // Send middle address byte
  spi_rw(addr)                    ;   // Send low address byte

 //sent data 2 byte
  spi_rw(data16)                  ;   // Send data low byte
  spi_rw(data16>>8)               ;   // Send data high byte
  
  spi_cs_hi()                     ;   // Set CS# high

}

//++++++++++++ Function-Write Address Register,Ram-DL,Ram-CMD + Data 32 bit +++++++++++++++

void FT800memWrite32(unsigned int32 addr, unsigned int32 data32)
{
  spi_cs_lo()                     ;   // Set CS# low

//sent address Ram
  spi_rw(((addr>>16)|MEM_WRITE))  ;   // Send Memory Write plus high address byte
  spi_rw(addr>>8)                 ;   // Send middle address byte
  spi_rw(addr)                    ;   // Send low address byte

//Sent data 4 byte
  spi_rw(data32)                  ;   // Send data low byte
  spi_rw(data32>>8)               ;   
  spi_rw(data32>>16)              ;   
  spi_rw(data32>>24)              ;   // Send data high byte
  
  spi_cs_hi()                     ;   // Set CS# high

}


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                        ++
  ++        3.3) Function-Write Address Ram-CMD and Data Text-String        ++
  ++                                                                        ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++ Input  :                                                               ++
  ++           addr = FT800 memory space address Ram-CMD                    ++
  ++           str  = Data Text String                                      ++
  ++                                                                        ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

                                                          
void FT800memWriteStr(unsigned int32 addr,int8 *str)
{
  unsigned int16 i ;
  
  num_cha = 0                     ;
  spi_cs_lo()                     ;   // Set CS# low
  
  //sent address ram
  spi_rw(((addr>>16)|MEM_WRITE))  ;   // Send Memory Write plus high address byte
  spi_rw(addr>>8)                 ;   // Send middle address byte
  spi_rw(addr)                    ;   // Send low address byte

 // sent data string 
 for (i=0; str[i] != '\0'; i++)      //Check End String In C
  {                 
     spi_rw(str[i])              ;
     num_cha +=  1               ;
  }

  spi_rw(0)                      ;   //Sent End Write String Sent 0

  num_cha = num_cha+1            ;

  spi_cs_hi()                    ;   // Set CS# high

}


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                             ++
  ++           3.4) Function-Write Address Ram_G and Data Bitmap                 ++
  ++                                                                             ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++ Input  :                                                                    ++
  ++         addr   = FT800 memory space address Ram_G(Start 0x00000),Size256k   ++
  ++         length = Size Picture  in byte                                      ++
  ++         bitmap = Array pointer of Data Picture(byte)                        ++
  ++                                                                             ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void FT800memWrBitmap(unsigned int32 addr,unsigned int32 length , rom int8 *bitmap)
{
  unsigned int32 pt=0 ;
  unsigned int8 dat   ;


  BMP_Add[bmp_pt] = addr                  ; //Set begin Address in Ram_G for Write data Picture
  bmp_pt          = bmp_pt+1              ; //Pointer Number Picture
  

  spi_cs_lo()                             ; //Set CS# low

  spi_rw(((addr>>16)|MEM_WRITE))          ; //Send Memory Write plus high address byte
  spi_rw(addr>>8)                         ; //Send middle address byte
  spi_rw(addr)                            ; //Send low address byte


  while(length--) 
   {
     dat  = bitmap[pt]                    ; //Read data Ascii from Flash at data picture
     spi_rw(dat)                          ; //Write data byte to FT800 RAM_G
     pt++                                 ; //Increment Pointer for array

   }
   
  spi_cs_hi()                             ; //Set CS# high
}



/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                        ++
  ++      3.5) Function-Write Host Command  (Command[6-bit]+0x00+0x00)      ++
  ++                                                                        ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++  Input :                                                               ++
  ++           Command = FT800 Command                                      ++
  ++                                                                        ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void FT800_HostCmdWrite(unsigned int8 Command)
{
  spi_cs_lo()            ;  // Set CS# low

  spi_rw(Command)        ;  // Send command
  spi_rw(0x00)           ;  // Commands consist of two more zero bytes
  spi_rw(0x00)           ;  // Send last zero byte

  spi_cs_hi()            ;  // Set CS# high
}


/*******************************************************************************
 **                                                                           **
 **                         4.Function-About Read FT800                       **
 **                                                                           **
 *******************************************************************************/


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                         ++
  ++            4.1) Function-Read data Register,Ram-DL,Ram-CMD              ++
  ++                                                                         ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++ Input    :                                                              ++
  ++            Address = FT800 memory space address Ram-DL,CMD,Reg          ++
  ++ Output   :                                                              ++
  ++            Dataxx  = data Read for Co-CMD,DL-CMD or Reg.                ++
  ++                                                                         ++
  ++ Note     : "xx" is data of 8, 16 or 32 bit                              ++
  ++                                                                         ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


//++++++++++++++++++ Function-Read data Memory 8 bit +++++++++++++++++++++++

unsigned int8 FT800memRead8(unsigned int32 addr)
{
  unsigned int8 data8 ;

  spi_cs_lo()                     ; // Set CS# low

  //Sent Address Ram for read
  spi_rw(((addr>>16)&MEM_READ))   ; // Send Memory Write plus high address byte
  spi_rw(addr>>8)                 ; // Send middle address byte
  spi_rw(addr)                    ; // Send low address byte
  
  spi_rw(ZERO)                    ; // Send dummy byte
  
  //Read data 1 byte
  data8 = spi_rw(ZERO)            ; // Read data byte

  spi_cs_hi()                     ; // Set CS# high
  
  return data8                    ; // Return byte read


}


//++++++++++++++++++++ Function-Read data Memory 16 bit ++++++++++++++++++++

unsigned int16 FT800memRead16(unsigned int32 addr)
{
  unsigned int16 data16,dat;

  spi_cs_lo()                                  ; // Set CS# low
  
   //Sent Address Ram for read
  spi_rw(((addr>>16)&MEM_READ))                ; // Send Memory Write plus high address byte
  spi_rw(addr>>8)                              ; // Send middle address byte
  spi_rw(addr)                                 ; // Send low address byte
  
  spi_rw(ZERO)                                 ; // Send dummy byte

  //Read data 2 byte 
  data16 = spi_rw(ZERO)                        ; // Read low byte
  dat    = spi_rw(ZERO)                        ; // Read high byte
  data16 = (dat << 8)| data16                  ; 
 

  spi_cs_hi()                                  ; // Set CS# high
    
  return data16;                             // Return integer read
}


//+++++++++++++++++ Function-Read data Memory 32 bit +++++++++++++++++++++

unsigned int32 FT800memRead32(unsigned int32 addr)
{
  unsigned int32 data32,dat;

  spi_cs_lo()                                  ; // Set CS# low

   //Sent Address Ram for read
  spi_rw(((addr>>16)&MEM_READ))                ; // Send Memory Write plus high address byte
  spi_rw(addr>>8)                              ; // Send middle address byte
  spi_rw(addr)                                 ; // Send low address byte
 
  spi_rw(ZERO)                                 ; // Send dummy byte

  //Read data 4 byte 
  data32 = spi_rw(ZERO)                        ; // Read low byte
  dat    = spi_rw(ZERO)                        ; 
  data32 = (dat<<8)| data32                    ;
  dat    = spi_rw(ZERO)                        ; 
  data32 = (dat<<16)| data32                   ;
  dat    = spi_rw(ZERO)                        ; // Read high byte 
  data32 = (dat<<24)| data32                   ;

  spi_cs_hi()                                  ; // Set CS# high
    
  return data32                                ; // Return integer read
}



/***********************************************************************************
 **                                                                               **
 **           5.Function-About Manage memory address FT800 Ring Buffer            **              
 **                                                                               **
 ***********************************************************************************/

 
/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                        ++
  ++     5.1) Function-Waite Co-Processor Finish executing and              ++
  ++          Start Offset pointer                                          ++
  ++                                                                        ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void Start_CMDOffset(void) 

 {
  //------------Determine Pointer Offset for Ram_CMD Address---------------
    do
     {
       cmdBufferRd = FT800memRead16(REG_CMD_READ)      ;   //***Read Reg.the graphics processor read pointer
       cmdBufferWr = FT800memRead16(REG_CMD_WRITE)     ;   //***Read Reg.the graphics processor write pointer
  
     }while(cmdBufferWr != cmdBufferRd)                ;   //Wait until the two registers match
  
      cmdOffset = cmdBufferWr                          ;   //The new starting point the first location after the last command

  }


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                                 ++
  ++         5.2) Function-Increment Offset Address Pointer for Ram-CMD              ++
  ++                                                                                 ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++ Input    :                                                                      ++
  ++            currentOffset = graphics processor command list pointer              ++
  ++            commandSize   = number of bytes data or CMD to increment the offset  ++
  ++                                                                                 ++
  ++ Output   : newOffset = the new ring buffer pointer after adding the command     ++ 
  ++                                                                                 ++
  ++ Overview : Adds commandSize to the currentOffset.                               ++
  ++            Checks for 4K ring-buffer offset roll-over                           ++
  ++                                                                                 ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


  //++++++++++++++++++ Function-Increment Offset Address +++++++++++++++++++++++

unsigned int16 incCMDOffset(unsigned int16 currentOffset, unsigned int8 commandSize)
{
    unsigned int16 newOffset                  ;   //used to hold new offset

    newOffset = currentOffset + commandSize   ;   //Calculate new offset

    if(newOffset > 4095)                          //If new offset past boundary...
    {
        newOffset = (newOffset - 4096)        ;   //... roll over pointer
    }

    return newOffset;                             //Return new offset
}



 //++++++++++++ Function-Increment Offset Address Use when end Co-Processor CMD (offset Address/4 = integer)+++++++++++++

unsigned int16 End_incCMDOffset(unsigned int16 currentOffset, unsigned int8 commandSize)
{
  unsigned int16 newOffset                    ;  //used to hold new offset

   newOffset = currentOffset + commandSize    ;  //Calculate new offset

   if(newOffset > 4095)                          //If new offset past boundary...
    {
        newOffset = (newOffset - 4096)        ;  //... roll over pointer
    }
   

  //increment the length and align it by 4 bytes//

   newOffset = (newOffset+3) & 4092           ;

   return newOffset ;                            //Return new offset
}



/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                                       ++
  ++       5.3) Function-Increment Offset Address Pointer for Ram_G for Bitmap             ++
  ++                                                                                       ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++ Input    :                                                                            ++
  ++            currentOffset = Offset pointer of RAM-G                                    ++
  ++            commandSize   = number of bytes data Bitmap Size  to increment the offset  ++
  ++                                                                                       ++
  ++ Output   : newOffset = the new pointer after adding the Bitmap Size                   ++ 
  ++                                                                                       ++
  ++ Overview : Adds Bitmap Size to the currentOffset.                                     ++
  ++            Checks for 256K Ram_G offset roll-over                                     ++
  ++                                                                                       ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


 //++++++++++++ Function-Increment Offset Address for Ram_G (offset Address/4 = integer)+++++++++++++

unsigned int32 incRamG_Offset(unsigned int32 currentOffset, unsigned int32 BitmapSize)
{
  unsigned int32 newOffset                   ;  //used to hold new offset



   newOffset = currentOffset + BitmapSize   ;   //Calculate new offset

   if(newOffset > 262143)                       //If new offset >256 KB
    {
        newOffset = 0xFFFFF                  ;  //Large Memore RAM_G
    }
   

  //increment the length and align it by 4 bytes//

   newOffset = (newOffset+3) & 0x3FFFC      ;

   return newOffset;                            //Return new offset
}



/*************************************************************************************
 **                                                                                 **
 **                         6.Function-About Touch Screen                           **
 **                                                                                 **
 *************************************************************************************/


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                             ++
  ++               6.1) Function-Read Statust Toucu  (Not Toch = 0xFFFF)         ++
  ++                                                                             ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

 int8 Touch_Detect(void)
  {
    unsigned int16 td  ;

    td = FT800memRead16(REG_TOUCH_RAW_XY)  ;   //***Read Reg.Toucu Detect
    
   if(td != 0xFFFF)   
     return 1       ;       //Touch return 1
   else
     return 0       ;       //No Touch return 0
      
  }

/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                                ++
  ++          6.2) Function-Read Position Touch Screen XY [X=0-479,Y=0-271]         ++
  ++                                                                                ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void Touch_Read_XY(void)
 {
    unsigned int32 xy ;  

   xy = FT800memRead32(REG_TOUCH_SCREEN_XY)   ; //***Read Reg : Read Value Position XY Touch Screen

   tc_x = (xy >> 16) & 0x000001FF             ; //Mark X-Position 0-479 in Pixel

   tc_y = xy & 0x1FF                          ; //Mark Y-Position 0-271 in Pixel 

 }


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                      ++
  ++                6.3) Function-Calibrate Touch Screen                  ++
  ++                                                                      ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void Touch_Calibrate(void)
 {
   unsigned int8 strbuf[50];
    // Calibrate Touch Screen //

    //--- 1.Start Display List ---
   Start_CMDList(Black)    ;
    
    //--- 2.1 Co-Processor Draw Text-CMD --- 
   
   sprintf (strbuf,"Please tap on a dot")          ;
   Text_CMD(strbuf,240,139,26,OPT_CENTER,White)    ;

   //--- 2.2 Co-Processor Calibrate CMD --- 

    FT800memWrite32(RAM_CMD + cmdOffset,CMD_CALIBRATE)             ; //***Sent Co-CMD for Calibrate Touch Screen
    cmdOffset = incCMDOffset(cmdOffset,4)                          ; //Update Offset pointer Ram-CMD 4 byte for Next CMD


   //--- 3.End Display List and Update Execute ----

    End_CMDList();

    Start_CMDOffset()                                              ; //Wait Calibrate Execute  

}


/*************************************************************************************
 **                                                                                 **
 **                               7.Function-About Audio                            **
 **                                                                                 **
 *************************************************************************************/



/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                      ++
  ++                    7.1) Function-Sound Effect                        ++
  ++                                                                      ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++     
  ++   Input : vol    = Value Volume(0-255) by min=0,max=255              ++
  ++           midi   = MIDI note for the sound effect (value 22-108)     ++                                          
  ++           effect = Sound Effect (0x00-0x08,0x10-0x1F,23,2C...)       ++
  ++                    00 : No Sound                                     ++                                                     
  ++                                                                      ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

 void Sound_Effect(unsigned int8 vol,int16 midi,int16 effect)
  {

    midi = midi << 8                                ;  //Set data Midi 8 bit High
    FT800memWrite8(REG_VOL_SOUND,vol)               ;  //***Write data to Reg : Turn synthesizer volume 0-0xFF   
    FT800memWrite16(REG_SOUND,midi | effect)        ;  //***Write data to Reg : Select Sound Effect = Silence(No Sound) 
    FT800memWrite8(REG_PLAY,0x01)                   ;  //***Write data to Reg : Play Sound Effect


  }


/*************************************************************************************
 **                                                                                 **
 **                     8.Function-About FT800 DL-CMD,Co-CMD                        **
 **                                                                                 **
 *************************************************************************************/


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                              ++
  ++     8.1) Function:Start Co-Processor Command List (Write Program to Ram_CMD) ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++  Input :                                                                     ++
  ++           screen_color  : Color Background Screen                            ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
  
  void Start_CMDList(int32 screen_color)
   {

    //-------------------- Start Display List ------------------------

     Start_CMDOffset()                                                  ; //Start Offset pointer for Ram-CMD

     FT800memWrite32(RAM_CMD + cmdOffset,CMD_DLSTART)                   ; //*** Sent Co-CMD Start the display list                                                     
     cmdOffset = incCMDOffset(cmdOffset,4)                              ; //Update Offset pointer Ram-CMD 4 byte for Next CMD     
    
     FT800memWrite32(RAM_CMD + cmdOffset,(DL_CLEAR_RGB | screen_color)) ; //*** Sent DL-CMD Clear color BackGround to Black (Set BackGround)                  
     cmdOffset = incCMDOffset(cmdOffset,4)                              ; //Update Offset pointer Ram-CMD 4 byte for Next CMD

     FT800memWrite32(RAM_CMD + cmdOffset,(DL_CLEAR | CLR_COL | CLR_STN | CLR_TAG));   //*** Sent DL-CMD Clear the screen - this and the previous prevent artifacts between lists                                                                               // Attributes are the color, stencil and tag buffers
     cmdOffset = incCMDOffset(cmdOffset,4)                              ;             //Update Offset pointer Ram-CMD 4 byte for Next CMD

   }


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                              ++
  ++     8.2) Function:End Co-Processor Command List (Write Program to Ram_CMD)   ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

  void End_CMDList(void)               
  {
    //----------------- End Display List and Update Execute -----------------

    FT800memWrite32(RAM_CMD + cmdOffset,DL_DISPLAY)          ;//*** Sent DL-CMD End Display List                  
    cmdOffset = incCMDOffset(cmdOffset,4)                    ;//Update Offset pointer Ram-CMD 4 byte for Next CMD
 
    FT800memWrite32(RAM_CMD + cmdOffset,CMD_SWAP)            ;//*** Sent Co-CMD Requse Display List Swap
    cmdOffset = incCMDOffset(cmdOffset,4)                    ;//Update Offset pointer Ram-CMD 4 byte for Next CMD

    FT800memWrite16(REG_CMD_WRITE,cmdOffset)                 ;//*** Sent Data cmdOffset to reg. CMD_Write for
                                                              //Update the ring buffer pointer so the graphics processor starts executing
  } 


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                              ++
  ++     8.3) Function:Co-Processor Draw Button (Write Program to Ram_CMD)        ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++   Input :     *str =  Text Button label                                      ++
  ++               x,y  =  x,y codinate button top-left ,in pixel                 ++
  ++               wide =  Wide Button in pixel                                   ++
  ++               high =  High Button in pixel                                   ++
  ++               font =  Format font for Button label                           ++
  ++                opt =  0=3D Button ,256 = Flat Button                         ++
  ++           tx_color =  Color Text Button label                                ++
  ++           bt_color =  Color Button                                           ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void Button_CMD(int8 *str,int16 x,int16 y,int16 wide,int16 high,int16 font,int16 opt,int32 tx_color,int32 bt_color)
 {

      // Set Attribute Button //

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_COLOR_RGB | tx_color))      ; //*** Sent DL-CMD Set Color Text              
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next CMD


    FT800memWrite32(RAM_CMD + cmdOffset,CMD_FGCOLOR)                    ; //*** Sent Co-CMD Set Color Button                                                  
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next CMD
   
    FT800memWrite32(RAM_CMD + cmdOffset,bt_color)                       ; //---Sent Data Color Button
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next CMD

    // Start Draw Button1 //   

    FT800memWrite32(RAM_CMD + cmdOffset,CMD_BUTTON)                     ; //***Sent Co-CMD Build Button
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next Data

    FT800memWrite16(RAM_CMD + cmdOffset,x)                              ; //---Sent data X-Point top-left (Pixel) 
    cmdOffset = incCMDOffset(cmdOffset,2)                               ; //Update Offset pointer Ram-CMD 2 byte for Next Data

    FT800memWrite16(RAM_CMD + cmdOffset,y)                              ; //---Sent data Y-Point  top-left (Pixel)
    cmdOffset = incCMDOffset(cmdOffset,2)                               ; //Update Offset pointer Ram-CMD 2 byte for Next Data

    FT800memWrite16(RAM_CMD + cmdOffset,wide)                           ; //---Sent data wide-Button (pixel)
    cmdOffset = incCMDOffset(cmdOffset,2)                               ; //Update Offset pointer Ram-CMD 2 byte for Next Data

    FT800memWrite16(RAM_CMD + cmdOffset,high)                           ; //---Sent data high-Button (Pixel)                                                     
    cmdOffset = incCMDOffset(cmdOffset,2)                               ; //Update Offset pointer Ram-CMD 2 byte for Next Data

    FT800memWrite16(RAM_CMD + cmdOffset,font)                           ; //---Sent data format font in Button label (16,18,20,21,22...)                                                     
    cmdOffset = incCMDOffset(cmdOffset,2)                               ; //Update Offset pointer Ram-CMD 2 byte for Next Data

    FT800memWrite16(RAM_CMD + cmdOffset,opt)                            ; //---Sent data Option Button Drawn 3D                                                     
    cmdOffset = incCMDOffset(cmdOffset,2)                               ; //Update Offset pointer Ram-CMD 2 byte for Next Data

    FT800memWriteStr(RAM_CMD + cmdOffset,str)                           ; //---Sent data Text Button Label (String)
    cmdOffset = End_incCMDOffset(cmdOffset,num_cha)                     ; //Update Offset pointer Ram-CMD for End CMD-Button  
 
 }


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                              ++
  ++       8.4) Function:Co-Processor Draw Text (Write Program to Ram_CMD)        ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++   Input :                                                                    ++
  ++                str =  Text String                                            ++
  ++                x,y =  x,y codinate Text base ,in pixel                       ++
  ++               font =  format font text(0-31)                                 ++
  ++               opt  =  Set Position Text default 0 top-left  or               ++
  ++                       OPT_CENTERX,OPT_CENTERY,OPT_CENTER,OPT_RIGHTX          ++
  ++                                                                              ++
  ++           tx_color =  Color Text                                             ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


void Text_CMD(int8 *str,int16 x,int16 y,int16 font,int16 opt,int32 tx_color)
 {

    // Set Attribute Clock //

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_COLOR_RGB | tx_color))    ; //***Sent DL-CMD Set Color Text-White  
    cmdOffset = incCMDOffset(cmdOffset,4)                             ; //Update Offset pointer Ram-CMD 4 byte for Next CMD

   
   //Start Draw Text//    

    FT800memWrite32(RAM_CMD + cmdOffset,CMD_TEXT)                     ; //***Sent Co-CMD Draw TEXT
    cmdOffset = incCMDOffset(cmdOffset,4)                             ; //Update Offset pointer Ram-CMD 4 byte for Next data

    FT800memWrite16(RAM_CMD + cmdOffset,x)                            ; //---Sent data X-Point top-left (Pixel) 
    cmdOffset = incCMDOffset(cmdOffset,2)                             ; //Update Offset pointer Ram-CMD 2 byte for Next data

    FT800memWrite16(RAM_CMD + cmdOffset,y)                            ; //---Sent data Y-Point top-left (Pixel) 
    cmdOffset = incCMDOffset(cmdOffset,2)                             ; //Update Offset pointer Ram-CMD 2 byte for Next data
  
    FT800memWrite16(RAM_CMD + cmdOffset,font)                         ; //---Sent data Set format font(16,18,20,21,22,23,24...)                                                     
    cmdOffset = incCMDOffset(cmdOffset,2)                             ; //Update Offset pointer Ram-CMD 2 byte for Next data

    FT800memWrite16(RAM_CMD + cmdOffset,opt)                          ; //---Sent data Option : Position Draw  Text                                                     
    cmdOffset = incCMDOffset(cmdOffset,2)                             ; //Update Offset pointer Ram-CMD 2 byte for Next data

    FT800memWriteStr(RAM_CMD + cmdOffset,str)                         ; //---Sent data Text   String      
    cmdOffset = End_incCMDOffset(cmdOffset,num_cha)                   ; //Update Offset pointer Ram-CMD for End CMD-Text
  
  }


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                                    ++
  ++        8.5) Function:Display-List Rectangle Drawing  (Write Program to Ram_CMD)    ++
  ++                                                                                    ++ 
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++   Input :                                                                          ++
  ++                x1,y1 =  Start Point Rectangle in pixel  (0-479,0-271)              ++
  ++                x2,y2 =  End Point Rectangle in pixel    (0-479,0-271)              ++
  ++                                                                                    ++
  ++                                                                                    ++
  ++                             (x1,y1) +--------------+                               ++
  ++                                     |              |                               ++
  ++                                     |              |                               ++
  ++                                     |              |                               ++
  ++                                     |              |                               ++
  ++                                     +--------------+ (x2,y2)                       ++  
  ++                                                                                    ++
  ++                   wd =  Line width in pixel(1-255) by width is the distance from   ++ 
  ++                         the center of the line                                     ++
  ++           rect_color =  Rectange Color (24 bit)                                    ++
  ++                                                                                    ++
  ++                                                                                    ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



void Rect_DL(int32 x1,int32 y1,int32 x2,int32 y2,int16 wd,int32 rect_color)
 {
    int32 xy1,xy2 ;
   
    x1 = (x1*16)<<15  ;    //Convert Start Point Rect in Pixel  to  unit  1/16  (Pixel * 16 = value use )
    y1 = y1*16        ;              
    xy1 = x1|y1       ;


    x2  = (x2*16)<<15 ;    //Convert End Point Rect in Pixel  to unit 1/16  (Pixel * 16 = value use )
    y2  = y2*16       ;              
    xy2 = x2|y2       ;



    //Set Attribute Line//

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_COLOR_RGB | rect_color))    ; //***Sent DL-CMD Set Color Rectangle
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_LINE_WIDTH | (wd*16)))      ; //***Sent DL-CMD Set Width Line(unit  1/16 )
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

   //Start Draw Line//    

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BEGIN | RECTS))             ; //***Sent DL-CMD BEGIN for Rectangle Drawing Mode
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_VERTEX2F | xy1))            ; //***Sent DL-CMD Set Start point Rect in unit 1/16 pixel
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD
  
    FT800memWrite32(RAM_CMD + cmdOffset,(DL_VERTEX2F | xy2))            ; //***Sent DL-CMD Set End point Rect in unit 1/16 pixel
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

    FT800memWrite32(RAM_CMD + cmdOffset,DL_END)                         ; //***Sent DL-CMD End Rectangle Draw  
    cmdOffset = incCMDOffset(cmdOffset,4)                               ; //Update Offset pointer Ram-CMD 4 byte for Next CMD           
  
  }






/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                                         ++
  ++        8.6) Function:Display-List BITMAP Drawing  (Write Program to Ram_CMD)           ++
  ++                                                                                         ++ 
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++   Input :                                                                               ++
  ++             x,y =  Start Point Drawing Picture in pixel  (0-479,0-271)                  ++
  ++            addr =  Set Start Address in Ram_G at keep Bitmap data (0-0x3FFFF:256KB)     ++  
  ++          format =  Set Format Layout of Pictur at Convert (Format 0-11)                 ++
  ++       line_byte =  Set Number byte Data in 1 Line of Picture that = width  except if    ++
  ++                    the Picture Convert format is  RGB565/ARGB4/ARGB1555 value           ++   
  ++                    line_byte = width x2                                                 ++
  ++           width =  Set width  of Picture in Pixel (0-479)                               ++
  ++          height =  Set Height of Picture in Pixel (0-271) for DL_BITMAP_SIZE CMM and    ++
  ++                        Height of data Picture in Line (0-271) for DL_BTMAP_LAYOUT       ++
  ++                                                                                         ++
  ++                                                                                         ++
  ++                                      x-width(0-479 pixel)                               ++
  ++                               (x,y) +--------------+                                    ++
  ++                                     |              |                                    ++
  ++                                     |              | y-height(0-271pixel)               ++
  ++                                     |    Picture   |                                    ++
  ++                                     |              |                                    ++
  ++                                     +--------------+                                    ++  
  ++                                                                                         ++
  ++                                                                                         ++
  ++                                                                                         ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

void Bitmap_DL(int32 x,int32 y,int32 addr,int32 format,int32 line_byte,int32 width,int16 height )
 {
    int32 xy;
   
    x  =  x << 21  ;   //Set point (x,y) for Start plot Picture in pixel (Use DL_VERTEX2II CMM)  
    y  =  y << 12  ;
    xy = x|y       ;

    format    = format << 19     ; // Begin bit19 for format (Use DL_BITMAP_LAOUT CMM)  
    line_byte = line_byte  << 9  ; // Begin bit9 for Number Byte  in 1 Line of  data Picture (Use DL_BITMAP_LAOUT CMM)  
    width     = width << 9       ; // Begin bit9 for width in pixel of picture (Use DL_BITMAP_SIZE CMM)  

    //Set Attribute Bitmap//

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_COLOR_RGB | White))           ; //***Sent DL-CMD Set Color RGB =White
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next CMD


    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BITMAP_SOURCE|addr))          ; //***Sent DL-CMD Start Address of bitmap Data In RAM_G
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BITMAP_LAYOUT|format|line_byte|height  )) ; //***Sent DL-CMD Set Bitmap Layout data 
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BITMAP_SIZE|width|height ))   ; //***Sent DL-CMD Set Bitmap Size in Pixel
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD


   //Start Draw Bitmap//    

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BEGIN | BITMAPS))             ; //***Sent DL-CMD BEGIN for BITMAP Drawing Mode
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD


    FT800memWrite32(RAM_CMD + cmdOffset,(DL_VERTEX2II | xy))              ; //***Sent DL-CMD Set Start point Draw Picture in pixel
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD
 
    FT800memWrite32(RAM_CMD + cmdOffset,DL_END)                           ; //***Sent DL-CMD End Draw Picture  
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next CMD           
  
  }


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                                                           ++
  ++        8.7) Function:Display-List BITMAP Drawing And Rotate BITMAP  (Write Program to Ram_CMD)            ++
  ++                                                                                                           ++ 
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++   Input :                                                                                                 ++
  ++             x,y =  Start Point Drawing Picture in pixel  (0-479,0-271)                                    ++
  ++            addr =  Set Start Address in Ram_G at keep Bitmap data (0-0x3FFFF:256KB)                       ++  
  ++          format =  Set Format Layout of Pictur at Convert (Format 0-11)                                   ++
  ++       line_byte =  Set Number byte Data in 1 Line of Picture that = width  except if                      ++
  ++                    the Picture Convert format is  RGB565/ARGB4/ARGB1555 value                             ++   
  ++                    line_byte = width x2                                                                   ++
  ++           width =  Set width  of Picture in Pixel (0-479)                                                 ++
  ++          height =  Set Height of Picture in Pixel (0-271) for DL_BITMAP_SIZE CMM and                      ++
  ++                        Height of data Picture in Line (0-271) for DL_BTMAP_LAYOUT                         ++
  ++     angle_rotat =  Set Clockwish Rotate angle in unit 1/65536 of Circle (0-360 degree)                    ++
  ++                    Normal Picture Turn-right(--->) if Turn Left(<-- ) give Set (-) front angle_rotat      ++             
  ++                                                                                                           ++
  ++                                                                                                           ++
  ++                                      x-width(0-479 pixel)                                                 ++
  ++                               (x,y) +--------------+                                                      ++
  ++                                     |              |                                                      ++
  ++                                     |              | y-height(0-271pixel)                                 ++
  ++                                     |    Picture   |                                                      ++
  ++                                     |              |                                                      ++
  ++                                     +--------------+                                                      ++  
  ++                                                                                                           ++
  ++                                                                                                           ++
  ++                                                                                                           ++
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/



void RotateBMP_CMD(int32 x,int32 y,int32 addr,int32 format,int32 line_byte,int32 width,int16 height,int32 angle_rotat )
 {
    int32 xy,tfx,tfy;   

 //------ use CMD_TRANSLATE ----
    tfx =  (width/2)* 65536      ;   //Set x translate factor for use Rotate Bitmap Around Center
    tfy =   (height/2)*65536     ;   //Set x translate factor for use Rotate Bitmap Around Center

    angle_rotat =  (angle_rotat*65536) /360   ; //Clockwish Rotate angle in unit 1/65536 of Circle

 //------------------------------
    x  =  x << 21  ;   //Set point (x,y) for Start plot Picture in pixel (Use DL_VERTEX2II CMM)  
    y  =  y << 12  ;
    xy = x|y       ;

    format    = format << 19     ; // Begin bit19 for format (Use DL_BITMAP_LAOUT CMM)  
    line_byte = line_byte  << 9  ; // Begin bit9 for Number Byte  in 1 Line of  data Picture (Use DL_BITMAP_LAOUT CMM)  
    width     = width << 9       ; // Begin bit9 for width in pixel of picture (Use DL_BITMAP_SIZE CMM)  

    //Set Attribute Bitmap//

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_COLOR_RGB | White))           ; //***Sent DL-CMD Set Color RGB =White
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD


    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BITMAP_SOURCE|addr))          ; //***Sent DL-CMD Start Address of bitmap Data In RAM_G
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BITMAP_LAYOUT|format|line_byte|height  )) ; //***Sent DL-CMD Set Bitmap Layout data 
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BITMAP_SIZE|width|height ))   ; //***Sent DL-CMD Set Bitmap Size in Pixel
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD


   //Start Draw and Rotate Bitmap//    

    FT800memWrite32(RAM_CMD + cmdOffset,(DL_BEGIN | BITMAPS))             ; //***Sent DL-CMD BEGIN for BITMAP Drawing Mode
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next Co-CMD
 
    //----------- Set Current Matrix --------
    FT800memWrite32(RAM_CMD + cmdOffset,CMD_LOADIDENTITY)                 ; //***Sent Co-CMD Load Identity for Set current matrix
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next Co-CMD

    //-------------Set-Translate(+) ----------
    FT800memWrite32(RAM_CMD + cmdOffset,CMD_TRANSLATE )                   ; //***Sent Co-CMD Translate for Translate current matrix
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next data
    FT800memWrite32(RAM_CMD + cmdOffset,tfx)                              ; //---Sent data x translate factor
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next data
    FT800memWrite32(RAM_CMD + cmdOffset,tfy)                              ; //---Sent data y translate factor
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next Co-CMD

    //------------Set Degree Rotate ----------
    FT800memWrite32(RAM_CMD + cmdOffset,CMD_ROTATE)                       ; //***Sent Co-CMD  Rotate Bitmap for Rotate Current Matrix
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next data
    FT800memWrite32(RAM_CMD + cmdOffset,angle_rotat)                     ; //---Sent data clockwise rotate angle
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next Co-CMD
  
    //-------------Set-Translate(-) ----------
    FT800memWrite32(RAM_CMD + cmdOffset,CMD_TRANSLATE )                   ; //***Sent Co-CMD Translate for Translate current matrix
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next data
    FT800memWrite32(RAM_CMD + cmdOffset,-tfx)                             ; //---Sent data -x translate factor
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next data
    FT800memWrite32(RAM_CMD + cmdOffset,-tfy)                             ; //---Sent data -y translate factor
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next Co-CMD


    //-------------Set-Matrix ------------

    FT800memWrite32(RAM_CMD + cmdOffset,CMD_SETMATRIX)                    ; //***Sent Co-CMD Set Matrix for write current matrix to display list
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD


    FT800memWrite32(RAM_CMD + cmdOffset,(DL_VERTEX2II | xy))              ; //***Sent DL-CMD Set Start point Draw Picture in pixel
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next DL-CMD
 
    FT800memWrite32(RAM_CMD + cmdOffset,DL_END)                           ; //***Sent DL-CMD End Draw Picture  
    cmdOffset = incCMDOffset(cmdOffset,4)                                 ; //Update Offset pointer Ram-CMD 4 byte for Next CMD           


  }


/*************************************************************************************
 **                                                                                 **
 **                       9.Function-About User Application                         **
 **                                                                                 **
 *************************************************************************************/


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                   ++
  ++                     9.1)Function:FT800 Initial                    ++
  ++                                                                   ++                                       
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


void FT800_Initial(void)         
 {
 
 //---------------------- 1.Walk-Up FT800 -----------------------

     
   FT800_PD_lo()                            ;  //Power-Down FT800
   delay_ms(20)                             ;  //delay 20 ms
    
   FT800_PD_hi()                            ;  //Power-Up FT800  
   delay_ms(20)                             ;  //delay 20 ms


   FT800_HostCmdWrite(FT800_ACTIVE)         ;  //***Sent Host-CMD Start FT800
   delay_ms(5);                                //Give some time to process

   FT800_HostCmdWrite(FT800_CLKEXT)         ;  //***Sent Host-CMD Set FT800 for external clock
   delay_ms(5);                                //Give some time to process

   FT800_HostCmdWrite(FT800_CLK48M)         ;  //***Sent Host-CMD Set FT800 for 48MHz PLL
   delay_ms(5)                              ;  //Give some time to process
                                               //Now FT800 can accept commands at up to 30MHz clock on SPI bus
                                               //This application leaves the SPI bus at 4MHz

 
  if(FT800memRead8(REG_ID) != 0x7C)            //***Read ID register - is it 0x7C?
   {
     while(true);                                 //If we don't get 0x7C, the ineface isn't working - halt with infinite loop
   }
  
   FT800memWrite8(REG_PCLK,ZERO)           ;   //***Write data zero to Reg.PCLK  for don't clock the LCD until later
   FT800memWrite8(REG_PWM_DUTY,ZERO)       ;   //***Write data zero to Reg.PWM_Duty for Turn off backlight
  

 //-------------------- 2.Configure Display ------------------------

  FT800memWrite16(REG_HSIZE,480)           ;  //***Write data to Reg : Active display width =480 Pixel
  FT800memWrite16(REG_HCYCLE,548)          ;  //***Write data to Reg : Total number of clocks per line, incl front/back porch
  FT800memWrite16(REG_HOFFSET,43)          ;  //***Write data to Reg : start of active line
  FT800memWrite16(REG_HSYNC0,0)            ;  //***Write data to Reg : Start of horizontal sync pulse
  FT800memWrite16(REG_HSYNC1,41)           ;  //***Write data to Reg : End of horizontal sync pulse
  
  FT800memWrite16(REG_VSIZE,272)           ;  //***Write data to Reg : Active display height =272 Pixel
  FT800memWrite16(REG_VCYCLE,292)          ;  //***Write data to Reg : Total number of lines per screen, incl pre/post
  FT800memWrite16(REG_VOFFSET,12)          ;  //***Write data to Reg : Start of active screen
  FT800memWrite16(REG_VSYNC0,0)            ;  //***Write data to Reg : Start of vertical sync pulse
  FT800memWrite16(REG_VSYNC1,10)           ;  //***Write data to Reg : End of vertical sync pulse
  
  FT800memWrite8(REG_SWIZZLE,0)            ;  //***Write data to Reg : FT800 output to LCD - pin order
  FT800memWrite8(REG_PCLK_POL,1)           ;  //***Write data to Reg : LCD data is clocked in on this PCLK edge
                                              //***Write data to Reg : Don't set PCLK yet - wait for just after the first display list


 //------------------- 3.Configure Touch -----------------
  
  FT800memWrite8(REG_TOUCH_MODE,0x03)      ;  //***Write data to Reg : Touch Mode Continuous
  FT800memWrite16(REG_TOUCH_RZTHRESH,1200) ;  //***Write data to Reg : Eliminate any false touches
  


//-------------------- 4. Configure Audio ----------------


  FT800memWrite8(REG_GPIO_DIR,0x82)        ;   //***Write Data to Reg :  Set Direction  GPIO 7,1 = Output

  ft800Gpio = FT800memRead8(REG_GPIO)      ;   //***Read the FT800 GPIO register for a read/modify/write operation
  ft800Gpio = ft800Gpio | 0x02             ;   //set bit 1 of FT800 GPIO register (Audio) - others are inputs

  FT800memWrite8(REG_GPIO,ft800Gpio)       ;   //***Write Data to Reg : Enable(1) the Audio Amp
  
  FT800memWrite8(REG_VOL_PB,ZERO)          ;  //***Write data to Reg : Turn recorded audio volume 
  FT800memWrite8(REG_VOL_SOUND,0x80)       ;  //***Write data to Reg : Turn synthesizer volume 50%(100%=0xFF)  
 
  FT800memWrite16(REG_SOUND,0x0000)        ;  //***Write data to Reg : Select Sound Effect = Silence(No Sound) 
  FT800memWrite8(REG_PLAY,0x01)            ;  //***Write data to Reg : Play Sound Effect

 //------------------ 5.Write Initial Display List & Enable Display -----------------

  FT800memWrite32(RAM_DL+DL_Offset,DL_CLEAR_RGB)  ;     //***Sent DL-CMD Clear color BackGround to Black (default)
  DL_Offset += 4                                  ;     //Update Offset pointer Ram-DL 4 byte for Next DL-CMD

  FT800memWrite32(RAM_DL+DL_Offset,(DL_CLEAR | CLR_COL | CLR_STN | CLR_TAG));   //***Sent DL-CMD Clear C/S/T define which parameters to clear
  DL_Offset += 4                                  ;     //Update Offset pointer Ram-DL 4 byte for Next DL-CMD

  FT800memWrite32(RAM_DL+DL_Offset,DL_DISPLAY)    ;     //***Sent DL-CMD for end of display list

  FT800memWrite32(REG_DLSWAP,DLSWAP_FRAME )       ;     //***Write data(0x02) to Reg : Display List Execute
                                                
  DL_Offset = 0                                   ;     //Reset Display List offset pointer=0 for new Display list
  
  ft800Gpio = FT800memRead8(REG_GPIO)             ;     //***Read the FT800 GPIO register for a read/modify/write operation
  ft800Gpio = ft800Gpio | 0x80                    ;     //set bit 7 of FT800 GPIO register (DISP) - others are inputs

  FT800memWrite8(REG_GPIO,ft800Gpio)              ;     //***Write Data to Reg : Enable the DISP signal to the LCD panel
  FT800memWrite8(REG_PCLK,5)                      ;     //***Write Data to Reg : Now start clocking data to the LCD panel
 

  FT800memWrite8(REG_PWM_DUTY,128);                     //***Write Data to Reg : Turn on backlight by set PWM_duty Max for full brighness
  delay_ms(10);

 }



/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                              ++
  ++                      9.2)Function: Update_Screen Application                 ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                              ++
  ++  Input :                                                                     ++
  ++           color_bt1 = Value Update for Color button Audio                    ++
  ++           color_bt2 = Value Update for Color button Dog                      ++
  ++           color_bt3 = Value Update for Color button Human                    ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/

  void Update_Screen(int32 color_bt1,int32 color_bt2,int32 color_bt3)
   {
     unsigned int8 strbuf[50];
    //----------------- 1.Start Display List ------------------------
      
     Start_CMDList(Black)   ;

   //------------------ 2.User Program ------------------------- 

     //Draw-Rectan//
     Rect_DL(0,0,479,271,1,Yellow)                                        ;
     Rect_DL(5,5,474,266,1,Blue)                                          ;
 

     //Draw-Button//
     sprintf(strbuf,"Audio")                                              ;
     Button_CMD(strbuf, 60,20,80,30,23,0,Green,color_bt1)                 ;  //Draw Button"Human"
     sprintf(strbuf,"Dog")                                                ;
     Button_CMD(strbuf,200,20,80,30,23,0,Green,color_bt2)                 ;  //Draw Button"Dog"
     sprintf(strbuf,"Human")                                              ;
     Button_CMD(strbuf,340,20,80,30,23,0,Green,color_bt3)                 ;  //Draw Button"Audio"

     if(fag_rt == 1)   //Release Button "RL,RR"
      {
        sprintf(strbuf,"RL")                                              ;
        Button_CMD(strbuf, 80,120,40,30,23,0,Red,Gold)                    ;  //Draw Button"RL"
        sprintf(strbuf,"RR")                                              ;
        Button_CMD(strbuf,360,120,40,30,23,0,Red,Gold)                    ;  //Draw Button"RR"
       }  
    if(fag_rt == 2)   //Press Button"RL" ,Release Button "RR"
      {
        sprintf(strbuf,"RL")                                              ;
        Button_CMD(strbuf, 80,120,40,30,23,0,Red,LightYellow)             ;  //Draw Button"RL"
        sprintf(strbuf,"RR")                                              ;
        Button_CMD(strbuf,360,120,40,30,23,0,Red,Gold)                    ;  //Draw Button"RR"
      }
     if(fag_rt == 3)   //Press Button"RR" ,Release Button "RL"
      {
        sprintf(strbuf,"RL")                                              ;
        Button_CMD(strbuf, 80,120,40,30,23,0,Red,Gold)                    ;  //Draw Button"RL"
        sprintf(strbuf,"RR")                                              ;
        Button_CMD(strbuf,360,120,40,30,23,0,Red,LightYellow)             ;  //Draw Button"RR"
      }


     switch(pic) 
     {
        case 1: //Display Picture1//
                Rect_DL(170,75,310,195,1,Red)                               ;
                Rect_DL(175,80,305,190,1,Black)                             ;
                
                if(fag_rt==1)
                   Bitmap_DL(187,82,BMP_Add[0],0,210,105,105)               ;  //Display Picture audio (line_byte = width*2)
                if(fag_rt==2)
                   RotateBMP_CMD(187,82,BMP_Add[0],0,210,105,105,-(angle))  ;  //Display Picture audio Rotate-L (line_byte = width*2)
                if(fag_rt==3)
                   RotateBMP_CMD(187,82,BMP_Add[0],0,210,105,105,(angle))   ;   //Display Picture audio Rotate-R (line_byte = width*2)

                break ; 
          
        case 2: //Display Picture2//
                Rect_DL(170,75,310,195,1,Red)                              ;
                Rect_DL(175,80,305,190,1,Black)                            ;
                 
                if(fag_rt==1)
                  Bitmap_DL(202,92,BMP_Add[1],0,150,75,85 )                ;  //Display Picture dog(line_byte = width*2) 
                if(fag_rt==2)
                  RotateBMP_CMD(202,92,BMP_Add[1],0,150,75,85,-(angle))    ;  //Display Picture dog Rotate-L (line_byte = width*2) 
                if(fag_rt==3)
                  RotateBMP_CMD(202,92,BMP_Add[1],0,150,75,85,angle)       ;  //Display Picture dog Rotate-R (line_byte = width*2) 
 
                break ; 
           
        case 3: //Display Picture3//
                Rect_DL(170,75,310,195,1,Red)                              ;
                Rect_DL(175,80,305,190,1,Black)                            ;

                if(fag_rt==1)
                   Bitmap_DL(175,87,BMP_Add[2],0,260,130,95)               ;  //Display Picture human (line_byte = width*2)
                if(fag_rt==2)
                   RotateBMP_CMD(175,87,BMP_Add[2],0,260,130,95,-(angle))  ;  //Display Picture human Rotate-L (line_byte = width*2
                if(fag_rt==3)
                   RotateBMP_CMD(175,87,BMP_Add[2],0,260,130,95,angle)     ;  //Display Picture human Rotate-R (line_byte = width*2)

                break ; 

    }

    //----------------- 3.End Display List and Update Execute -------------

   End_CMDList();

 }


/*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ++                                                                              ++
  ++                      9.3) Function: User Application                         ++
  ++                                                                              ++
  ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/


 void User_App(void)
  {
     unsigned int8 strbuf[50];
     
   //------------- Write Picture All Keep Ram_G By Start Address 0 --------------- 

    RamG_Offset = 0                                  ;

    FT800memWrBitmap(RamG_Offset,22050,jpeg_audio)   ;    //Write data Pic_audio 105x105 to Ram_G
    RamG_Offset = incRamG_Offset(RamG_Offset,22050)  ;
  
    FT800memWrBitmap(RamG_Offset,12750,jpeg_dog)     ;    //Write data Pic_dog 75x85 to Ram_G
    RamG_Offset = incRamG_Offset(RamG_Offset,12750)  ;

    FT800memWrBitmap(RamG_Offset,24700,jpeg_human)   ;    //Write data Pic_human 130x95 to Ram_G
    RamG_Offset = incRamG_Offset(RamG_Offset,24700)  ;


   //----------------- 1.Start Display List ------------------------
      
     Start_CMDList(Black)   ;

 
   //----------------- 2.User Program ------------------------- 

     //Draw-Rectan//
    Rect_DL(0,0,479,271,1,Yellow)                                         ;
    Rect_DL(5,5,474,266,1,Blue)                                           ;
   
    Rect_DL(170,75,310,195,1,Red)                                         ;
    Rect_DL(175,80,305,190,1,Black)                                       ;

     //Draw Text//
    sprintf(strbuf,"Picture")                                             ;
    Text_CMD(strbuf,210,130,18,0,White)                                   ;

     //Draw-Button//
    sprintf(strbuf,"Auduo")                                               ;
    Button_CMD(strbuf,60,20,80,30,23,0,Green,DeepPink)                    ;  //Draw Button"Audio"
    sprintf(strbuf,"Dog")                                                 ;
    Button_CMD(strbuf,200,20,80,30,23,0,Green,DeepPink)                   ;  //Draw Button"Dog"
    sprintf(strbuf,"Human")                                               ;
    Button_CMD(strbuf,340,20,80,30,23,0,Green,DeepPink)                   ;  //Draw Button"Human"
   
    sprintf(strbuf,"RL")                                                  ;
    Button_CMD(strbuf, 80,120,40,30,23,0,Red,Gold)                        ;  //Draw Button"RL"
    sprintf(strbuf,"RR")                                                  ;
    Button_CMD(strbuf,360,120,40,30,23,0,Red,Gold)                        ;  //Draw Button"RR"

    //----------------- 3.End Display List and Update Execute -------------

   End_CMDList();

   while(true)
    { 

    //-------- Check Statust Touch Screen ---------
         
     if(Touch_Detect())                        //if Touch =1 
      {
        Touch_Read_XY()          ;             //Read Position Touch Screen XY

        //----------------------Check Button"Human,Dog,Audio"------------------------//

        //Y-Touch Button "Human,Dog,Audio"

        if((tc_y>20) & (tc_y <50))                           //Check Position Touch Y-axis for Button"Human,Dog,Audio"
         { 
         //----X-Touch Button"Human"-----//

           if((tc_x>60)&(tc_x<140))                          //Check Position Touch X-axis for Button"Audio"
            {       
              fag_rt = 1                                   ;
              pic = 1                                      ;
              Sound_Effect(100,C7,Swit)                    ; //Set Sound Press Button
              Update_Screen(Snow,DeepPink,DeepPink)        ; //Update Screen

      
           //---------------------- Check Release Button -----------------------//
        
              while(Touch_Detect()){;}                        //Check Release Touch button
              delay_ms(50) ;
              Update_Screen(DeepPink,DeepPink,DeepPink)    ;  //Up date Screen 
            } 

            //------X-Touch Button"Dog"------//

           if((tc_x>200)&(tc_x<280))                          //Check Position Touch X-axis for Button"Dog"
            {  
             fag_rt = 1                                   ;
             pic = 2                                      ;
             Sound_Effect(100,C7,Swit)                    ;  //Set Sound Press Button
             Update_Screen(DeepPink,Snow,DeepPink)        ;  //Update Screen
           
           //---------------------- Check Release Button -----------------------//
        
             while(Touch_Detect()){;}                        //Check Release Touch button
             delay_ms(50) ;
             Update_Screen(DeepPink,DeepPink,DeepPink)    ;  //Up date Screen             
              
            } 

            //------X-Touch Button"Audio"------//

           if((tc_x>380)&(tc_x<420))                          //Check Position Touch X-axis for Button"Human"
            {  
             fag_rt = 1                                   ;
             pic = 3                                      ;
             Sound_Effect(100,C7,Swit)                    ;   //Set Sound Press Button
             Update_Screen(DeepPink,DeepPink,Snow)        ;   //Update Screen
             
           //---------------------- Check Release Button -----------------------//
        
             while(Touch_Detect()){;}                         //Check Release Touch button
             delay_ms(50) ;
             Update_Screen(DeepPink,DeepPink,DeepPink)    ;   //Up date Screen 
            } 

         }  //if tc_y  Button"Human,Dog,Audio"
        
         //----------------------Check Button"RL,RR"------------------------//

        //Y-Touch Button "RL,RR"

       if((tc_y>120) & (tc_y <150))                             //Check Position Touch Y-axis for Button"RL,RR"
        {     
          if(fag_rt==1)                                         //fag=1 = Release Button "RR,RL" and have Picture display        
           {     
              //----X-Touch Button"RL"-----//

             if((tc_x>80)&(tc_x<120))                               //Check Position Touch X-axis for Button"RL"
              {                  
                fag_rt = 2                                       ;  //Set Fag for Status Press Button "RL"
                Sound_Effect(100,C7,Swit)                        ;  //Set Sound Press Button
                Sound_Effect(100,0,Carousel)                     ;  //Play Sound Song
              
                  //---------------------- Check Release Button -----------------------//
                while(Touch_Detect())                               //Check Release Touch button
                 {        
                   Update_Screen(DeepPink,DeepPink,DeepPink)     ;  //Up date Screen 
                   angle = angle+1                               ;  //Adjust angle Rotate 1 degree
                   if(angle == 360) 
                      angle = 0                                  ;  //Clear angle=0 when rotate =360
                 }

                Sound_Effect(100,0,Silence)                      ;  //Stop Sound Song               
                angle  = 0                                       ;  //Clear Angle Rotate                           
                fag_rt = 1                                       ;  //Clear fag_rt  
                Update_Screen(DeepPink,DeepPink,DeepPink)        ;  //Up date Screen   

              } //if tc_x  bt_RL
      
               //----X-Touch Button"RR"-----//

              if((tc_x>360)&(tc_x<400))                             //Check Position Touch X-axis for Button"RR"
               {               
                 fag_rt = 3                                      ;  //Set Fag for Status Press Button "RR"
                 Sound_Effect(100,C7,Swit)                       ;  //Set Sound Press Button
                 Sound_Effect(100,0,Warble   )                   ;  //Play Sound Song
              
                  //---------------------- Check Release Button -----------------------//
                 while(Touch_Detect())                              //Check Release Touch button
                  {              
                    Update_Screen(DeepPink,DeepPink,DeepPink)    ;  //Up date Screen 
                    angle = angle+1                              ;  //Adjust angle Rotate 1 degree
                    if(angle == 360)
                      angle = 0                                  ;  //Clear angle=0 when rotate =360
                  }
               
                 Sound_Effect(100,0,Silence)                     ;  //Stop Sound Song      
                 angle  = 0                                      ;   //Clear Angle Rotate                           
                 fag_rt = 1                                      ;  //Clear fag_rt    
                 Update_Screen(DeepPink,DeepPink,DeepPink)       ;  //Up date Screen   

               } //if tc_x  bt_RR
           } //if fag_rt
        }    //if tc_y Button"Rotate"       
    }        //if Touch_Detect      
  }          //while
}            //end User App










